﻿using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using GrapeCity.ActiveReports;
using GrapeCity.ActiveReports.SectionReportModel;
using GrapeCity.ActiveReports.Document.Section;
using Microsoft.Win32;
using FebGui.WinForms;
using FebUtil.Operations;
using System.Windows.Forms;
using GrapeCity.ActiveReports.Data;
using System.Collections.Generic;

namespace FebPrintClassLib
{
     public static partial class CommonItems
    {
        public static Color clBackGround
        {
            get
            {
                return Color.FromArgb(223, 242, 252); //Sort of "Light blue/Cyan" :) 210,228,242
            }
        }

        public static Color clForeGround
        {
            get
            {
                return Color.Black;
            }
        }

        //private static Dictionary<int, Font> PFont = new Dictionary<int, Font>()
        //{
        //    { 4, new Font("Arial", 4) },
        //    { 5, new Font("Arial", 5) },
        //    { 6, new Font("Arial", 6) },
        //    { 7, new Font("Arial", 7) },
        //    { 8, new Font("Arial", 8) },
        //    { 9, new Font("Arial", 9) },
        //    { 10, new Font("Arial", 10) },
        //    { 11, new Font("Arial", 11) },
        //    { 12, new Font("Arial", 12) },
        //    { 13, new Font("Arial", 13) },
        //    { 14, new Font("Arial", 14) },
        //    { 15, new Font("Arial", 15) },
        //    { 16, new Font("Arial", 16) },
        //    { 17, new Font("Arial", 17) },
        //    { 18, new Font("Arial", 18) },
        //    { 19, new Font("Arial", 19) },
        //    { 20, new Font("Arial", 20) }
        //};

        public static string strLicCountry
        {
            get
            {
                //Registry keys
                //Get Febdok Registry keys in HKLM
                string root = "SOFTWARE\\FEBDOK";
                string LicCountry = "";
                RegistryKey m_rKey = Registry.LocalMachine;
                RegistryKey RkS = m_rKey.OpenSubKey(root);
                if (RkS == null)
                {
                    RkS = m_rKey.OpenSubKey("SOFTWARE\\NELFO\\FEBDOK");
                }

                try
                {
                    LicCountry = RkS.GetValue("LicenseSupportCountry", "NO").ToString();//UK;DK;SE;FI;NO
                    m_rKey.Close();
                    RkS.Close();
                }
                catch (Exception)
                {
                    LicCountry = "NO";
                }

                return LicCountry;
            }
        }
  
        public static void RtfSupercsriptDown(GrapeCity.ActiveReports.SectionReportModel.RichTextBox rtfTextBox, string strFindTxt)
		{
			if (rtfTextBox.Find(strFindTxt) != -1)
			{
				rtfTextBox.SelectionStart = rtfTextBox.Find(strFindTxt);
				rtfTextBox.SelectionLength = strFindTxt.Length;
				rtfTextBox.SelectionCharOffset = -.03f;
			}
		}

        //*************************************************************************
        // This function is Public and called from Rpt01,02 for drawing functions *
        //*************************************************************************
		public static void DrawFebGraphics(Page CurrentPage, string strDrawingElement, int iX1pos, int iY1pos, int iX2pos, int iY2pos, int iRot, short iLineThickness,
					string strLineCol, string strLineStyle, string strFillColor, string strFillStyle, int iTextHeight, string strTextColor,
					string strText1, string strText2, string strText3, string strText4, string strTextAlignment, string strTextVerticalAlignment)
		{
			int iFillstyle = 0;
			PointF Pt1 = new PointF(GetInch(iX1pos), GetInch(iY1pos));
			PointF Pt2 = new PointF(GetInch(iX2pos), GetInch(iY2pos));
			//PointF Pt1 = new PointF(iX1pos, iY1pos);
			//PointF Pt2 = new PointF(iX2pos, iY2pos);

			switch (iTextHeight)
			{
				case 30:
					iTextHeight = 6;
					break;
				default:
					iTextHeight = 6;
					break;
			}


			switch (strLineStyle)
			{
				case "Dash":
					CurrentPage.PenStyle = PenStyles.Dash;
					break;
				case "DashDot":
					CurrentPage.PenStyle = PenStyles.DashDot;
					break;
				case "DashDotDot":
					CurrentPage.PenStyle = PenStyles.DashDotDot;
					break;
				case "Dot":
					CurrentPage.PenStyle = PenStyles.Dot;
					break;
				case "Solid":
					CurrentPage.PenStyle = PenStyles.Solid;
					break;
				default:
					CurrentPage.PenStyle = PenStyles.Solid;
					break;
			}

			switch (strTextAlignment)
			{
				case "Center":
					CurrentPage.TextAlignment = TextAlignment.Center;
					break;
				case "Left":
					CurrentPage.TextAlignment = TextAlignment.Left;
					break;
				case "Right":
					CurrentPage.TextAlignment = TextAlignment.Right;
					break;
				default:
					CurrentPage.TextAlignment = TextAlignment.Left;
					break;
			}

			switch (strTextVerticalAlignment)
			{
				case "Bottom":
					CurrentPage.VerticalTextAlignment = VerticalTextAlignment.Bottom;
					break;
				case "Top":
					CurrentPage.VerticalTextAlignment = VerticalTextAlignment.Top;
					break;
				case "Middle":
					CurrentPage.VerticalTextAlignment = VerticalTextAlignment.Middle;
					break;
				default:
					CurrentPage.VerticalTextAlignment = VerticalTextAlignment.Bottom;
					break;
			}

			switch (strLineCol)
			{
				case "Black":
					CurrentPage.ForeColor = Color.Black;
					break;
				case "Blue":
					CurrentPage.ForeColor = Color.Blue;
					break;
				case "BlueGreen":
					CurrentPage.ForeColor = Color.MediumSpringGreen;
					break;
				case "Green":
					CurrentPage.ForeColor = Color.Green;
					break;
				case "Green/Yellow":
					CurrentPage.ForeColor = Color.GreenYellow;
					break;
				case "Grey":
					CurrentPage.ForeColor = Color.LightGray;
					break;
				case "Red":
					CurrentPage.ForeColor = Color.Red;
					break;
				case "Violet":
					CurrentPage.ForeColor = Color.DarkViolet;
					break;
				case "White":
					CurrentPage.ForeColor = Color.White;
					break;
				case "Yellow":
					CurrentPage.ForeColor = Color.Yellow;
					break;
				case "Pink":
					CurrentPage.ForeColor = Color.Pink;
					break;
				case "Orange":
					CurrentPage.ForeColor = Color.Orange;
					break;
				default:
					CurrentPage.ForeColor = Color.Black;
					break;

			}

			switch (strFillColor)
			{
				case "Black":
					CurrentPage.BackColor = Color.Black;
					break;
				case "Blue":
					CurrentPage.BackColor = Color.Blue;
					break;
				case "Green":
					CurrentPage.BackColor = Color.Green;
					break;
				case "Green/Yellow":
					CurrentPage.BackColor = Color.GreenYellow;
					break;
				case "Grey":
					CurrentPage.BackColor = Color.LightGray;
					break;
				case "Red":
					CurrentPage.BackColor = Color.Red;
					break;
				case "Violet":
					CurrentPage.BackColor = Color.DarkViolet;
					break;
				case "White":
					CurrentPage.BackColor = Color.White;
					break;
				case "Yellow":
					CurrentPage.BackColor = Color.Yellow;
					break;
				default:
					CurrentPage.BackColor = Color.Transparent;
					break;

			}

			switch (strFillStyle) // Finns inget för detta...
			{
				case "Horizontal":
					iFillstyle = 1;
					break;
				case "Vertical":
					iFillstyle = 2;
					break;
				case "ForwardDiagonal":
					iFillstyle = 3;
					break;
				case "BackwardDiagonal":
					iFillstyle = 4;
					break;
				case "Cross":
					iFillstyle = 5;
					break;
				case "DiagonalCross":
					iFillstyle = 6;
					break;
				case "Solid":
					iFillstyle = 7;
					break;
				default:
					iFillstyle = 0;
					break;
			}

			switch (strDrawingElement)
			{
				case "Network":
					DrawFebNetwork(CurrentPage, iX1pos, iY1pos, CurrentPage.ForeColor, strFillStyle, strText1);
					break;
				case "Line":
					DrawLine(CurrentPage, iX1pos, iY1pos, iX2pos, iY2pos, CurrentPage.PenStyle, iLineThickness, CurrentPage.ForeColor);
					break;
				case "Rectangle":
					CurrentPage.FillRect(Pt1.X, Pt1.Y, Pt2.X - Pt1.X, Pt2.Y - Pt1.Y);
					DrawFebRect(CurrentPage, Pt1, Pt2);
					break;
				case "Ellipse":
					DrawEllipse(CurrentPage, iX1pos, iY1pos, iX2pos, iY2pos, CurrentPage.PenStyle, CurrentPage.ForeColor, iFillstyle, CurrentPage.BackColor);
					break;
				case "Text":
					DrawFebText(CurrentPage, iX1pos, iY1pos, iRot, strText1, CurrentPage.ForeColor, CurrentPage.VerticalTextAlignment, CurrentPage.TextAlignment, iTextHeight);
					break;
				case "Cable":
					DrawFebCable(CurrentPage, iX1pos, iY1pos, iX2pos, iY2pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "SocketOutlet":
					DrawFebSocketOutlet(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "FixedLoad":
					DrawFebFixedLoad(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "Luminaire":
					DrawFebLight(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "ControlCircuit":
					DrawFebControlCircuit(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "Motor":
					DrawFebMotorGenerator(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor, true);
					break;
				case "Generator":
					DrawFebMotorGenerator(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor, false);
					break;
				case "DistributedLoad":
					DrawFebDistributedLoad(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "RingCircuit":
					DrawFebRingCircuit(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "DistributionBoard":
					DrawFebDistributionBoard(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "GroupBusbar":
					DrawFebGroupBusbar(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "BranchNode":
					DrawFebBranchNode(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "BusbarTrunking":
					DrawFebBusbarTrunking(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "JunctionBox":
					DrawFebJunctionBox(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "Transformer":
					DrawFebTrafo(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "UPS":
					DrawFebUPS(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "UPS_StaticBypass":
					DrawFebUPS_StaticBypass(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "UPS_StaticBypass_SeparateFeeder":
					DrawFebUPS_StaticBypass_SeparateFeeder(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "Fuse":
					DrawFebFuse(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "CircuitBreaker":
					DrawFebCircuitBreaker(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "MCB":
					DrawFebMCB(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "MCBRCD":
					DrawFebMCBRCD(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "RCD":
					DrawFebRCD(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "RCM":
					DrawFebRCM(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "Bimetal":
					DrawFebBimetal(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "Contactor":
					DrawFebContactor(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "LoadSwitch":
					DrawFebLoadSwitch(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "Disconnector":
					DrawFebDisconnector(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "SwitchDisconnector":
					DrawFebSwitchDisconnector(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "Meter":
					DrawFebMeter(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "SPD":
					DrawFebSPD(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "BellTransformer":
					DrawFebBellTransformer(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "EarthElectrode":
					DrawFebEarthElectrode(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "EquipotentialBonding":
					DrawFebEquipotentialBonding(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "LineConductor":
					DrawFebLineConductor(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "NeutralConductor":
					DrawFebNeutralConductor(CurrentPage, iX1pos, iY1pos, iRot, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "ClosedCurve":
					DrawFebClosedCurve(CurrentPage, iX1pos, iY1pos, strText1, strText2, strText3, strText4, CurrentPage.ForeColor);
					break;
				case "DiscriminationDiagram":
					DrawFebDiscriminationDiagram(CurrentPage, iX1pos, iY1pos, iX2pos, iY2pos, iLineThickness);
					break;
				case "CurrentTimeDiagram":
					DrawFebCurrentTimeDiagram(CurrentPage, iX1pos, iY1pos, iX2pos, iY2pos);
					break;
				case "I2tDiagram":
					DrawFebI2tDiagram(CurrentPage, iX1pos, iY1pos, iX2pos, iY2pos, iRot);
					break;
				case "IIpeakDiagram":
					DrawFebIIpeakDiagram(CurrentPage, iX1pos, iY1pos, iX2pos, iY2pos, iRot);
					break;

				default:
					break;
			}

		}

        //*********************************************
        //Private functions for drawing symbols
        //*********************************************
        #region Private Drawing symbols and functions 

		private static void DrawLine(Page pg, int iX1Pos, int iY1Pos, int iX2Pos, int iY2Pos, PenStyles ePenstyle, short iPenWidth, Color clPen)
		{

			pg.PenStyle = ePenstyle;
			pg.PenWidth = iPenWidth;
			pg.BackColor = Color.White;
			pg.ForeColor = clPen;

			PointF Pt1 = new PointF(GetInch(iX1Pos), GetInch(iY1Pos));
			PointF Pt2 = new PointF(GetInch(iX2Pos), GetInch(iY2Pos));

			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);

			pg.PenWidth = 1;

		}

		private static void DrawRect(Page pg, int iX1Pos, int iY1Pos, int iX2Pos, int iY2Pos, PenStyles ePenstyle, Color clPen, int fillstyle, Color clFill)
		{
			/*
			 *None, Horizontal, Vertical, ForwardDiagonal, BackwardDiagonal, Cross, DiagonalCross 
			 *Distance[mm]=distance[pixel]*resolution[DPI]*conve​rsion[inch/mm]
			*/
			Single x = GetInch(iX1Pos);
			Single y = GetInch(iY1Pos);
			Single width = GetInch(iX2Pos - iX1Pos);
			Single height = GetInch(iY2Pos - iY1Pos);
			//PointF Pt1 = new PointF(GetInch(iX1Pos), GetInch(iY1Pos));
			//PointF Pt2 = new PointF(GetInch(iX2Pos), GetInch(iY2Pos));
			//FillRect(Pt1.X, Pt1.Y Pt2.X - Pt1.X, Pt2.Y - Pt1.Y);

			HatchStyle hstyle = HatchStyle.Percent05;
			//pg.PenWidth = 1;

			switch (fillstyle)
			{
				//case 0:
				//    break;
				case 1:
					hstyle = HatchStyle.Horizontal;
					break;
				case 2:
					hstyle = HatchStyle.Vertical;
					break;
				case 3:
					hstyle = HatchStyle.ForwardDiagonal;
					break;
				case 4:
					hstyle = HatchStyle.BackwardDiagonal;
					break;
				case 5:
					hstyle = HatchStyle.Cross;
					break;
				case 6:
					hstyle = HatchStyle.DiagonalCross;
					break;
				case 7:
					hstyle = HatchStyle.Percent90;
					break;
				default:
					break;
			}

			int iwidth = iX2Pos / 2;
			int iheight = iY2Pos / 2;

			//string xx = String.Format("width: {0} iwidth:{1}", width, iwidth);
			//pg.DrawText(xx, 1, 1, 4, 1);

			//Single x1 = 300 * width;
			//PointF pos = new PointF(x,y);

			pg.PenStyle = ePenstyle;
			//pg.PenWidth = 
			pg.BackColor = clFill;
			pg.ForeColor = clPen;

			SolidBrush sb = new SolidBrush(clPen);
			Pen p = new Pen(sb, 2);
			HatchBrush hb = new HatchBrush(hstyle, clPen, clFill);
			RectangleF rect = new RectangleF(x, y, width, height);

			Bitmap img = new Bitmap(iwidth, iheight, System.Drawing.Imaging.PixelFormat.Format24bppRgb);
			img.SetResolution(300, 300);
			img.MakeTransparent();

			Graphics g = Graphics.FromImage(img);

			if (fillstyle > 0)
			{
				g.FillRectangle(hb, 0, 0, iwidth, iheight);
				g.DrawRectangle(p, 0, 0, iwidth, iheight);
				pg.DrawImage(img, true, rect);
			}
			else
			{
				//DrawFebRect(pg, Pt1, Pt2);
				pg.DrawRect(rect);
			}

			sb.Dispose();
			p.Dispose();
			hb.Dispose();
			g.Dispose();
			pg.PenWidth = 1;
		}

		private static void DrawEllipse(Page pg, int iX1Pos, int iY1Pos, int iX2Pos, int iY2Pos, PenStyles ePenstyle, Color clPen, int fillstyle, Color clFill)
		{
			/*
			*None, Horizontal, Vertical, ForwardDiagonal, BackwardDiagonal, Cross, DiagonalCross 
			*Distance[mm]=distance[pixel]*resolution[DPI]*conve​rsion[inch/mm]
		   */

			PointF Pt1 = new PointF(GetInch(iX1Pos), GetInch(iY1Pos));

			Single width = GetInch(iX2Pos);
			Single height = GetInch(iY2Pos);
			HatchStyle hstyle;

			switch (fillstyle)
			{
				case 1:
					hstyle = HatchStyle.Horizontal;
					break;
				case 2:
					hstyle = HatchStyle.Vertical;
					break;
				case 3:
					hstyle = HatchStyle.ForwardDiagonal;
					break;
				case 4:
					hstyle = HatchStyle.BackwardDiagonal;
					break;
				case 5:
					hstyle = HatchStyle.Cross;
					break;
				case 6:
					hstyle = HatchStyle.DiagonalCross;
					break;
				default:
					hstyle = HatchStyle.Percent05;
					break;
			}

			int iwidth = Convert.ToInt32(width * 150);//iX2Pos / 2;
			int iheight = Convert.ToInt32(height * 150);//iY2Pos / 2;

			pg.PenStyle = ePenstyle;
			//pg.PenWidth = 
			pg.BackColor = clFill;
			pg.ForeColor = clPen;

			SolidBrush sb = new SolidBrush(clPen);
			Pen p = new Pen(sb, 2);
			HatchBrush hb = new HatchBrush(hstyle, clPen, clFill);
			RectangleF rect = new RectangleF(Pt1.X, Pt1.Y, width, height);

			Bitmap img = new Bitmap(iwidth, iheight, System.Drawing.Imaging.PixelFormat.Format24bppRgb);
			img.SetResolution(300, 300);
			img.MakeTransparent();

			Graphics g = Graphics.FromImage(img);

			if (fillstyle > 0)
			{
				g.FillEllipse(hb, 0, 0, iwidth, iheight);
				g.DrawEllipse(p, 0, 0, iwidth, iheight);
				pg.DrawImage(img, true, rect);
			}
			else
			{
				pg.DrawEllipse(rect.X, rect.Y, rect.Width, rect.Height);
			}

			sb.Dispose();
			p.Dispose();
			hb.Dispose();
			g.Dispose();

			pg.PenWidth = 1;
			//pg.DrawEllipse();
		}

		private static float GetInch(int imm)
		{
			return (float)imm * 0.00393700787f;
		}

		private static void DrawFebRect(Page pg, PointF Pt1, PointF Pt2)
		{
			pg.PenWidth = 1;
			pg.DrawLine(Pt1.X, Pt1.Y, Pt1.X, Pt2.Y);
			pg.DrawLine(Pt1.X, Pt2.Y, Pt2.X, Pt2.Y);
			pg.DrawLine(Pt2.X, Pt2.Y, Pt2.X, Pt1.Y);
			pg.DrawLine(Pt2.X, Pt1.Y, Pt1.X, Pt1.Y);

		}

		private static void DrawFebBreaker(Page pg, int iXpos, int iYpos, int iRot, Color clPen)
		{
			pg.ForeColor = clPen;

			PointF Pt2 = new PointF();

			PointF Pt1 = new PointF(GetInch(iXpos), GetInch(iYpos));
			Pt2 = GetXYpoint(iXpos, iYpos, 0, 40, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -22, 37, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, 0, 80, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, 0, 120, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);

			pg.ForeColor = Color.Black;
		}

		private static void DrawFebBreakerText(Page pg, int iXpos, int iYpos, int iDeviation, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4)
		{
			PointF Pt1 = new PointF();
            Font pfont = new Font("Arial", 6);
			int iXposX;
			int iYposX;

			pg.Font = pfont;
			pg.ForeColor = Color.Black;
			if (iRot == 0 || iRot == 180)
			{
				if (iRot == 0) 
					iYposX = iYpos;
				else 
					iYposX = iYpos - 120;
				pg.TextAlignment = TextAlignment.Right;
				if (strTxt3 != "")
				{
					if (strTxt1 != "")
					{
						pg.VerticalTextAlignment = VerticalTextAlignment.Bottom;
						Pt1 = GetXYpoint(iXpos, iYposX, -iDeviation, 45, 0);
						pg.DrawText(strTxt1, Pt1.X - 2.0f, Pt1.Y - 1.0f, 2.0f, 1.0f);
					}
					if (strTxt2 != "")
					{
						pg.VerticalTextAlignment = VerticalTextAlignment.Middle;
						Pt1 = GetXYpoint(iXpos, iYposX, -iDeviation, 60, 0);
						pg.DrawText(strTxt2, Pt1.X - 2.0f, Pt1.Y - 0.5f, 2.0f, 1.0f);
					}
					pg.VerticalTextAlignment = VerticalTextAlignment.Top;
					Pt1 = GetXYpoint(iXpos, iYposX, -iDeviation, 75, 0);
					pg.DrawText(strTxt3, Pt1.X - 2.0f, Pt1.Y, 2.0f, 1.0f);
				}
				else
				{
					if (strTxt1 != "")
					{
						pg.VerticalTextAlignment = VerticalTextAlignment.Bottom;
						Pt1 = GetXYpoint(iXpos, iYposX, -iDeviation, 55, 0);
						pg.DrawText(strTxt1, Pt1.X - 2.0f, Pt1.Y - 1.0f, 2.0f, 1.0f);
					}
					if (strTxt2 != "")
					{
						pg.VerticalTextAlignment = VerticalTextAlignment.Top;
						Pt1 = GetXYpoint(iXpos, iYposX, -iDeviation, 65, 0);
						pg.DrawText(strTxt2, Pt1.X - 2.0f, Pt1.Y, 2.0f, 1.0f);
					}
				}
				if (strTxt4 != "")
				{
					if (iRot == 0) 
						iXposX = iXpos + 15;
					else 
						iXposX = iXpos + iDeviation;
					pg.TextAlignment = TextAlignment.Left;
					pg.VerticalTextAlignment = VerticalTextAlignment.Middle;
					pg.ForeColor = Color.Red;
					Pt1 = GetXYpoint(iXposX, iYpos, 0, 60, 0);
					pg.DrawText(strTxt4, Pt1.X, Pt1.Y - 1.0f, 2.0f, 2.0f);
				}
			}
			else
			{
				if (iRot == 90) iXposX = iXpos - 120;
				else iXposX = iXpos;
				if (iRot == 270)
					iYposX = iYpos - 10;
				else 
					iYposX = iYpos - iDeviation;
				pg.TextAlignment = TextAlignment.Left;
				pg.VerticalTextAlignment = VerticalTextAlignment.Bottom;
				if (strTxt3 != "")
				{
					Pt1 = GetXYpoint(iXposX, iYposX, 5, 0, 0);
					pg.DrawText(strTxt3, Pt1.X, Pt1.Y - 1.0f, 2.0f, 1.0f);
					iYposX -= 25;
				}
				if (strTxt2 != "")
				{
					Pt1 = GetXYpoint(iXposX, iYposX, 5, 0, 0);
					pg.DrawText(strTxt2, Pt1.X, Pt1.Y - 1.0f, 2.0f, 1.0f);
					iYposX -= 25;
				}
				if (strTxt1 != "")
				{
					Pt1 = GetXYpoint(iXposX, iYposX, 5, 0, 0);
					pg.DrawText(strTxt1, Pt1.X, Pt1.Y - 1.0f, 2.0f, 1.0f);
				}
				if (strTxt4 != "")
				{
					if (iRot == 270)
						iYposX = iYpos + 15;
					else
						iYposX = iYpos + iDeviation;
					pg.VerticalTextAlignment = VerticalTextAlignment.Top;
					pg.ForeColor = Color.Red;
					//Pt1 = GetXYpoint(iXposX, iYposX, 30, 0, 0);
					Pt1 = GetXYpoint(iXposX, iYposX, 0, 0, 0);
					pg.DrawText(strTxt4, Pt1.X, Pt1.Y, 2.0f, 1.0f);
				}
			}
		}

		private static void DrawFebComponentText(Page pg, int iXpos, int iYpos, int iLength, int iRot, string strTxt1, string strTxt2)
		{
			PointF Pt1 = new PointF();
            Font pfont = new Font("Arial", 6);

			pg.Font = pfont;
			pg.ForeColor = Color.Black;
			if (iRot == 0 || iRot == 180)
			{
				pg.TextAlignment = TextAlignment.Right;
				pg.VerticalTextAlignment = VerticalTextAlignment.Bottom;
				if (strTxt1 != "")
				{
					Pt1 = GetXYpoint(iXpos, iYpos, -5, iLength / 2 - 5, 0);
					pg.DrawText(strTxt1, Pt1.X - 2.0f, Pt1.Y - 1.0f, 2.0f, 1.0f);
				}
				//if (strTxt2 != "")
				//{
				//    Pt1 = GetXYpoint(iXposX, iYposX, -52, -90, 0);
				//    pg.DrawText(strTxt2, Pt1.X - 2.0f, Pt1.Y, 2.0f, 1.0f);
				//}
			}
			else
			{
				pg.TextAlignment = TextAlignment.Left;
				pg.VerticalTextAlignment = VerticalTextAlignment.Bottom;
				pg.WrapMode = GrapeCity.ActiveReports.Document.Section.WrapMode.WordWrap;
				//if (strTxt1 != "")
				//{
				//    Pt1 = GetXYpoint(iXposX, iYposX, 5, -55, 0);
				//    pg.DrawText(strTxt1, Pt1.X, Pt1.Y, 2.0f, 1.0f);
				//}
				if (strTxt2 != "")
				{
					SizeF sz = pg.MeasureParagraphHeight(strTxt2, 2.0f);
					Pt1 = GetXYpoint(iXpos, iYpos, -20, -5, 0);
					pg.DrawText(strTxt2, Pt1.X, Pt1.Y - sz.Height, 2.0f, sz.Height);
				}
			}
		}

		private static void DrawFebHatchForward(Page pg, int iXpos1, int iYpos1, int iXpos2, int iYpos2, Color cCol)
		{
			int iX1;
			int iX2;
			int iYpos;

			iX1 = iXpos1 + (iXpos2 - iXpos1) / 2 - (iYpos2 - iYpos1) / 2;
			iYpos = iYpos1;
			while (iX1 < iXpos2)
			{
				iX2 = Math.Min(iXpos2, iX1 + (iYpos2 - iYpos1));
				if (iX2 == iXpos2) iYpos = iYpos2 - (iXpos2 - iX1);
				DrawFebLine(pg, iX1, iYpos2, iX2, iYpos);
				iX1 += 20;
			}
			iX1 = iXpos1 + (iXpos2 - iXpos1) / 2 + (iYpos2 - iYpos1) / 2 - 20;
			iYpos = iYpos2;
			while (iX1 > iXpos1)
			{
				iX2 = Math.Max(iXpos1, iX1 - (iYpos2 - iYpos1));
				if (iX2 == iXpos1) iYpos = iYpos1 + (iX1 - iXpos1);
				DrawFebLine(pg, iX1, iYpos1, iX2, iYpos);
				iX1 -= 20;
			}
		}
		private static void DrawFebHatchBackward(Page pg, int iXpos1, int iYpos1, int iXpos2, int iYpos2, Color cCol)
		{
			int iX1;
			int iX2;
			int iYpos;

			iX1 = iXpos1 + (iXpos2 - iXpos1) / 2 - (iYpos2 - iYpos1) / 2;
			iYpos = iYpos2;
			while (iX1 < iXpos2)
			{
				iX2 = Math.Min(iXpos2, iX1 + (iYpos2 - iYpos1));
				if (iX2 == iXpos2) iYpos = iYpos1 + (iXpos2 - iX1);
				DrawFebLine(pg, iX1, iYpos1, iX2, iYpos);
				iX1 += 20;
			}
			iX1 = iXpos1 + (iXpos2 - iXpos1) / 2 + (iYpos2 - iYpos1) / 2 - 20;
			iYpos = iYpos1;
			while (iX1 > iXpos1)
			{
				iX2 = Math.Max(iXpos1, iX1 - (iYpos2 - iYpos1));
				if (iX2 == iXpos1) iYpos = iYpos2 - (iX1 - iXpos1);
				DrawFebLine(pg, iX1, iYpos2, iX2, iYpos);
				iX1 -= 20;
			}
		}

		private static void DrawFebNetwork(Page pg, int iXpos, int iYpos, Color cCol, string strFillStyle, string strTxt1)
		{
            Font pfont = new Font("Arial", 6);

			pg.ForeColor = cCol;
			DrawFebRect(pg, iXpos - 100, iYpos, 200, 100);
			if (strFillStyle == "DiagonalCross")
			{
				DrawFebHatchForward(pg, iXpos - 100, iYpos, iXpos + 100, iYpos + 100, cCol);
				DrawFebHatchBackward(pg, iXpos - 100, iYpos, iXpos + 100, iYpos + 100, cCol);
			}
			if (strTxt1 != "")
			{
				pg.Font = pfont;
				pg.TextAlignment = TextAlignment.Center;
				pg.VerticalTextAlignment = VerticalTextAlignment.Middle;
				pg.DrawText(strTxt1, GetInch(iXpos - 98), GetInch(iYpos + 2), GetInch(196), GetInch(96));
			}
		}
		private static void DrawFebFuse(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			PointF Pt1 = new PointF(GetInch(iXpos), GetInch(iYpos));
			PointF Pt2 = new PointF();
            Font pfont = new Font("Arial", 6);
			int iXposX;
			int iYposX;

			pg.Font = pfont;
			pg.ForeColor = cCol;

			Pt2 = GetXYpoint(iXpos, iYpos, 0, 120, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -10, 30, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, 10, 90, iRot);
			DrawFebRect(pg, Pt1, Pt2);

			pg.ForeColor = Color.Black;

			if (iRot == 0 || iRot == 180)
			{
				if (iRot == 0) iYposX = iYpos;
				else iYposX = iYpos + 120;
				pg.TextAlignment = TextAlignment.Right;
				if (strTxt1 != "")
				{
					pg.VerticalTextAlignment = VerticalTextAlignment.Bottom;
					Pt1 = GetXYpoint(iXpos, iYposX, -15, 55, 0);
					pg.DrawText(strTxt1, Pt1.X - 2.0f, Pt1.Y - 1.0f, 2.0f, 1.0f);
				}
				if (strTxt2 != "")
				{
					pg.VerticalTextAlignment = VerticalTextAlignment.Top;
					Pt1 = GetXYpoint(iXpos, iYposX, -15, 65, 0);
					pg.DrawText(strTxt2, Pt1.X - 2.0f, Pt1.Y, 2.0f, 1.0f);
				}
				if (strTxt3 != "")
				{
					pg.VerticalTextAlignment = VerticalTextAlignment.Middle;
					Pt1 = GetXYpoint(iXpos, iYposX, 15, 60, 0);
					pg.DrawText(strTxt3, Pt1.X - 2.0f, Pt1.Y - 0.5f, 2.0f, 1.0f);
				}
				if (strTxt4 != "")
				{
					pg.TextAlignment = TextAlignment.Left;
					pg.VerticalTextAlignment = VerticalTextAlignment.Middle;
					pg.ForeColor = Color.Red;
					Pt1 = GetXYpoint(iXpos, iYposX, 15, 60, 0);
					pg.DrawText(strTxt4, Pt1.X, Pt1.Y - 1.0f, 2.0f, 2.0f);
				}
			}
			else
			{
				if (iRot == 90) iXposX = iXpos - 120;
				else iXposX = iXpos;
				iYposX = iYpos - 15;
				pg.TextAlignment = TextAlignment.Left;
				pg.VerticalTextAlignment = VerticalTextAlignment.Bottom;
				if (strTxt2 != "")
				{
					Pt1 = GetXYpoint(iXposX, iYposX, 5, 0, 0);
					pg.DrawText(strTxt2, Pt1.X, Pt1.Y - 1.0f, 2.0f, 1.0f);
					iYposX -= 25;
				}
				if (strTxt1 != "")
				{
					Pt1 = GetXYpoint(iXposX, iYposX, 5, 0, 0);
					pg.DrawText(strTxt1, Pt1.X, Pt1.Y - 1.0f, 2.0f, 1.0f);
				}
				if (strTxt3 != "")
				{
					pg.TextAlignment = TextAlignment.Center;
					pg.VerticalTextAlignment = VerticalTextAlignment.Top;
					Pt1 = GetXYpoint(iXposX, iYpos, 60, 15, 0);
					pg.DrawText(strTxt3, Pt1.X - 1.0f, Pt1.Y, 2.0f, 1.0f);
				}
				if (strTxt4 != "")
				{
					pg.TextAlignment = TextAlignment.Center;
					pg.VerticalTextAlignment = VerticalTextAlignment.Top;
					pg.ForeColor = Color.Red;
					Pt1 = GetXYpoint(iXposX, iYpos, 60, 15, 0);
					pg.DrawText(strTxt4, Pt1.X - 1.0f, Pt1.Y, 2.0f, 1.0f);
				}
			}
		}

		private static void DrawFebBimetal(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			PointF Pt1 = new PointF(GetInch(iXpos), GetInch(iYpos));
			PointF Pt2 = new PointF();
            Font pfont = new Font("Arial", 6);
			int iXposX;
			int iYposX;

			pg.Font = pfont;
			pg.ForeColor = cCol;

			Pt2 = GetXYpoint(iXpos, iYpos, 0, 50, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, 20, 50, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt2 = GetXYpoint(iXpos, iYpos, 20, 70, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, 0, 70, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt2 = GetXYpoint(iXpos, iYpos, 0, 120, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);

			pg.ForeColor = Color.Black;

			if (iRot == 0 || iRot == 180)
			{
				if (iRot == 0) iYposX = iYpos;
				else iYposX = iYpos + 120;
				pg.TextAlignment = TextAlignment.Right;
				if (strTxt1 != "")
				{
					pg.VerticalTextAlignment = VerticalTextAlignment.Bottom;
					Pt1 = GetXYpoint(iXpos, iYposX, -5, 55, 0);
					pg.DrawText(strTxt1, Pt1.X - 2.0f, Pt1.Y - 1.0f, 2.0f, 1.0f);
				}
				if (strTxt2 != "")
				{
					pg.VerticalTextAlignment = VerticalTextAlignment.Top;
					Pt1 = GetXYpoint(iXpos, iYposX, -5, 65, 0);
					pg.DrawText(strTxt2, Pt1.X - 2.0f, Pt1.Y, 2.0f, 1.0f);
				}
				if (strTxt4 != "")
				{
					pg.VerticalTextAlignment = VerticalTextAlignment.Bottom;
					pg.ForeColor = Color.Red;
					Pt1 = GetXYpoint(iXpos, iYposX, -5, 110, 0);
					pg.DrawText(strTxt4, Pt1.X - 2.0f, Pt1.Y - 1.0f, 2.0f, 1.0f);
				}
			}
			else
			{
				if (iRot == 90) iXposX = iXpos - 120;
				else iXposX = iXpos;
				if (iRot == 270) iYposX = iYpos - 25;
				iYposX = iYpos - 5;
				pg.TextAlignment = TextAlignment.Left;
				pg.VerticalTextAlignment = VerticalTextAlignment.Bottom;
				if (strTxt2 != "")
				{
					Pt1 = GetXYpoint(iXposX, iYposX, 5, 0, 0);
					pg.DrawText(strTxt2, Pt1.X, Pt1.Y - 1.0f, 2.0f, 1.0f);
					iYposX -= 25;
				}
				if (strTxt1 != "")
				{
					Pt1 = GetXYpoint(iXposX, iYposX, 5, 0, 0);
					pg.DrawText(strTxt1, Pt1.X, Pt1.Y - 1.0f, 2.0f, 1.0f);
				}
				if (strTxt4 != "")
				{
					pg.VerticalTextAlignment = VerticalTextAlignment.Top;
					pg.ForeColor = Color.Red;
					Pt1 = GetXYpoint(iXposX, iYpos, 5, 5, 0);
					pg.DrawText(strTxt4, Pt1.X, Pt1.Y, 2.0f, 1.0f);
				}
			}
			pg.ForeColor = Color.Black;
		}

		private static void DrawFebRCM(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			PointF Pt1 = new PointF();
            //PointF Pt2 = new PointF();
            Font pfont = new Font("Arial", 6);
			Color OldBackColor;
			int iXposX;
			int iYposX;

			pg.Font = pfont;
			pg.ForeColor = cCol;

			if (iRot == 0 || iRot == 180)
			{
				iXposX = iXpos - 40;
				if (iRot == 0) iYposX = iYpos + 20;
				else iYposX = iYpos - 100;
				DrawFebLine(pg, iXposX + 40, iYposX - 20, iXposX + 40, iYposX);
				DrawFebLine(pg, iXposX + 40, iYposX + 80, iXposX + 40, iYposX + 100);
			}
			else
			{
				if (iRot == 270) iXposX = iXpos + 20;
				else iXposX = iXpos - 100;
				iYposX = iYpos - 40;
				DrawFebLine(pg, iXposX - 20, iYposX + 40, iXposX, iYposX + 40);
				DrawFebLine(pg, iXposX + 80, iYposX + 40, iXposX + 100, iYposX + 40);
			}

			pg.DrawRect(GetInch(iXposX), GetInch(iYposX), GetInch(80), GetInch(80));

			// Draw "I"
			DrawFebLine(pg, iXposX + 35, iYposX + 10, iXposX + 35, iYposX + 25);
			DrawFebLine(pg, iXposX + 30, iYposX + 10, iXposX + 40, iYposX + 10);
			DrawFebLine(pg, iXposX + 30, iYposX + 25, iXposX + 40, iYposX + 25);
			//Draw "Delta"
			DrawFebLine(pg, iXposX + 46, iYposX + 17, iXposX + 51, iYposX + 32);
			DrawFebLine(pg, iXposX + 51, iYposX + 32, iXposX + 41, iYposX + 32);
			DrawFebLine(pg, iXposX + 41, iYposX + 32, iXposX + 46, iYposX + 17);

			//DrawCircle
			Pt1 = GetXYpoint(iXposX, iYposX, 8, 46, 0);
			pg.DrawEllipse(Pt1.X, Pt1.Y, GetInch(24), GetInch(24));

			//Draw "X" in circle
			DrawFebLine(pg, iXposX + 11, iYposX + 49, iXposX + 29, iYposX + 67);
			DrawFebLine(pg, iXposX + 11, iYposX + 67, iXposX + 29, iYposX + 49);

			//Draw Summer
			pg.DrawEllipse(GetInch(iXposX + 49), GetInch(iYposX + 39), GetInch(22), GetInch(22));
			pg.PenStyle = PenStyles.Transparent;
			OldBackColor = pg.BackColor;
			pg.BackColor = Color.White;
			pg.FillRect(GetInch(iXposX + 48), GetInch(iYposX + 39), GetInch(24), GetInch(11));
			pg.BackColor = OldBackColor;
			pg.PenStyle = PenStyles.Solid;
			DrawFebLine(pg, iXposX + 49, iYposX + 50, iXposX + 71, iYposX + 50);
			DrawFebLine(pg, iXposX + 56, iYposX + 60, iXposX + 56, iYposX + 70);
			DrawFebLine(pg, iXposX + 64, iYposX + 60, iXposX + 64, iYposX + 70);

			pg.ForeColor = Color.Black;

			if (iRot == 0 || iRot == 180)
			{
				pg.TextAlignment = TextAlignment.Right;
				pg.VerticalTextAlignment = VerticalTextAlignment.Top;
				if (strTxt1 != "")
				{
					Pt1 = GetXYpoint(iXposX, iYposX, -5, 0, 0);
					pg.DrawText(strTxt1, Pt1.X - 2.0f, Pt1.Y, 2.0f, 1.0f);
				}
				if (strTxt3 != "")
				{
					Pt1 = GetXYpoint(iXposX, iYposX, -5, 25, 0);
					pg.DrawText(strTxt3, Pt1.X - 2.0f, Pt1.Y, 2.0f, 1.0f);
				}
			}
			else
			{
				pg.TextAlignment = TextAlignment.Left;
				pg.VerticalTextAlignment = VerticalTextAlignment.Bottom;
				if (strTxt3 != "")
				{
					Pt1 = GetXYpoint(iXposX, iYposX, 0, -5, 0);
					pg.DrawText(strTxt3, Pt1.X, Pt1.Y - 1.0f, 2.0f, 1.0f);
					iYposX -= 25;
				}
				if (strTxt1 != "")
				{
					Pt1 = GetXYpoint(iXposX, iYposX, 0, 0, 0);
					pg.DrawText(strTxt1, Pt1.X, Pt1.Y - 1.0f, 2.0f, 1.0f);
				}
			}
		}

		private static void DrawFebDistributedLoad(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			PointF Pt1 = new PointF();
			PointF Pt2 = new PointF();
			int iXposX = 0;
			int iYposX = 0;

			pg.ForeColor = cCol;
			switch (iRot)
			{
				case 0:
					iXposX = iXpos - 30;
					iYposX = iYpos + 50;
					Pt1 = GetXYpoint(iXpos, iYposX, 0, 0, 0);
					break;
				case 270:
					iXposX = iXpos + 120;
					iYposX = iYpos - 30;
					Pt1 = GetXYpoint(iXposX, iYpos, 0, 0, 0);
					break;
				case 180:
					iXposX = iXpos - 30;
					iYposX = iYpos - 120;
					Pt1 = GetXYpoint(iXpos, iYposX, 0, 0, 0);
					break;
				case 90:
					iXposX = iXpos - 190;
					iYposX = iYpos - 30;
					Pt1 = GetXYpoint(iXposX, iYpos, 0, 0, 0);
					break;
			}
			pg.DrawLine(GetInch(iXpos), GetInch(iYpos), Pt1.X, Pt1.Y);

			//DrawRectangle
			pg.DrawRect(GetInch(iXposX), GetInch(iYposX), GetInch(70), GetInch(70));

			//DrawCircle
			Pt1 = GetXYpoint(iXposX, iYposX, 15, 15, 0);
			pg.DrawEllipse(Pt1.X, Pt1.Y, GetInch(40), GetInch(40));

			//Draw "X" in circle
			Pt1 = GetXYpoint(iXposX, iYposX, 21, 21, 0);
			Pt2 = GetXYpoint(iXposX, iYposX, 49, 49, 0);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXposX, iYposX, 21, 49, 0);
			Pt2 = GetXYpoint(iXposX, iYposX, 49, 21, 0);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);

			pg.ForeColor = Color.Black;
			DrawFebComponentText(pg, iXposX, iYposX, 70, iRot, strTxt1, strTxt2);
		}

		private static void DrawFebLight(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			int iXpos1 = 0;
			int iYpos1 = 0;
			int iXpos2 = 0;
			int iYpos2 = 0;

			pg.ForeColor = cCol;
			switch (iRot)
			{
				case 0:
					iXpos1 = iXpos - 30;
					iYpos1 = iYpos + 30;
					iXpos2 = iXpos;
					iYpos2 = iYpos + 90;
					break;
				case 270:
					iXpos1 = iXpos + 160;
					iYpos1 = iYpos - 30;
					iXpos2 = iXpos + 160;
					iYpos2 = iYpos;
					break;
				case 180:
					iXpos1 = iXpos - 30;
					iYpos1 = iYpos - 90;
					iXpos2 = iXpos;
					iYpos2 = iYpos - 90;
					break;
				case 90:
					iXpos1 = iXpos - 90;
					iYpos1 = iYpos - 30;
					iXpos2 = iXpos - 300;
					iYpos2 = iYpos;
					break;
			}
			DrawFebLine(pg, iXpos, iYpos, iXpos2, iYpos2);

			//DrawCircle
			pg.DrawEllipse(GetInch(iXpos1), GetInch(iYpos1), GetInch(60), GetInch(60));

			//Draw "X" in circle
			DrawFebLine(pg, iXpos1 + 10, iYpos1 + 10, iXpos1 + 50, iYpos1 + 50);
			DrawFebLine(pg, iXpos1 + 10, iYpos1 + 50, iXpos1 + 50, iYpos1 + 10);

			pg.ForeColor = Color.Black;
			DrawFebComponentText(pg, iXpos1 + 20, iYpos1, 50, iRot, strTxt1, strTxt2);
		}

		private static void DrawFebMotorGenerator(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol, bool motor)
		{
			PointF Pt1 = new PointF();
			PointF Pt2 = new PointF();
			int iXposX = 0;
			int iYposX = 0;

			pg.ForeColor = cCol;
			switch (iRot)
			{
				case 0:
					iXposX = iXpos - 30;
					iYposX = iYpos + 50;
					Pt1 = GetXYpoint(iXpos, iYposX, 0, 0, 0);
					break;
				case 270:
					iXposX = iXpos + 130;
					iYposX = iYpos - 30;
					Pt1 = GetXYpoint(iXposX, iYpos, 0, 0, 0);
					break;
				case 180:
					iXposX = iXpos - 30;
					iYposX = iYpos - 110;
					Pt1 = GetXYpoint(iXpos, iYposX, 0, 0, 0);
					break;
				case 90:
					iXposX = iXpos - 190;
					iYposX = iYpos - 30;
					Pt1 = GetXYpoint(iXposX, iYpos, 0, 0, 0);
					break;
			}
			pg.DrawLine(GetInch(iXpos), GetInch(iYpos), Pt1.X, Pt1.Y);

			//DrawCircle
			pg.DrawEllipse(GetInch(iXposX), GetInch(iYposX), GetInch(60), GetInch(60));

			if (motor)
			{
				//Draw "M" in circle
				Pt1 = GetXYpoint(iXposX, iYposX, 20, 40, 0);
				Pt2 = GetXYpoint(iXposX, iYposX, 20, 20, 0);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
				Pt1 = GetXYpoint(iXposX, iYposX, 30, 30, 0);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
				Pt2 = GetXYpoint(iXposX, iYposX, 40, 20, 0);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
				Pt1 = GetXYpoint(iXposX, iYposX, 40, 40, 0);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			}
			else
			{
				//Draw "G" in circle
				Pt1 = GetXYpoint(iXposX, iYposX, 38, 27, 0);
				Pt2 = GetXYpoint(iXposX, iYposX, 38, 23, 0);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
				Pt1 = GetXYpoint(iXposX, iYposX, 35, 20, 0);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
				Pt2 = GetXYpoint(iXposX, iYposX, 26, 20, 0);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
				Pt1 = GetXYpoint(iXposX, iYposX, 22, 24, 0);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
				Pt2 = GetXYpoint(iXposX, iYposX, 22, 36, 0);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
				Pt1 = GetXYpoint(iXposX, iYposX, 26, 40, 0);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
				Pt2 = GetXYpoint(iXposX, iYposX, 35, 40, 0);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
				Pt1 = GetXYpoint(iXposX, iYposX, 38, 37, 0);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
				Pt2 = GetXYpoint(iXposX, iYposX, 38, 32, 0);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
				Pt1 = GetXYpoint(iXposX, iYposX, 32, 32, 0);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			}


			pg.ForeColor = Color.Black;
			DrawFebComponentText(pg, iXposX, iYposX, 60, iRot, strTxt1, strTxt2);
		}

		private static void DrawFebSocketOutlet(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			PointF Pt1 = new PointF();
			Color OldBackColor = new Color();
			int iXpos1 = 0;
			int iYpos1 = 0;
			int iXpos2 = 0;
			int iYpos2 = 0;
			int iXpos3 = 0;
			int iYpos3 = 0;
			int iWidth = 0;
			int iHeight = 0;

			pg.ForeColor = cCol;
			switch (iRot)
			{
				case 0:
					iXpos1 = iXpos - 20;
					iYpos1 = iYpos + 50;
					iXpos2 = iXpos - 25;
					iYpos2 = iYpos + 70;
					iXpos3 = iXpos + 20;
					iYpos3 = iYpos + 50;
					Pt1 = GetXYpoint(iXpos, iYpos1, 0, 0, 0);
					iWidth = 50;
					iHeight = 25;
					break;
				case 270:
					iXpos1 = iXpos + 170;
					iYpos1 = iYpos - 20;
					iXpos2 = iXpos + 190;
					iYpos2 = iYpos - 25;
					iXpos3 = iXpos + 170;
					iYpos3 = iYpos + 20;
					Pt1 = GetXYpoint(iXpos1, iYpos, 0, 0, 0);
					iWidth = 25;
					iHeight = 50;
					break;
				case 180:
					iXpos1 = iXpos - 20;
					iYpos1 = iYpos - 210;
					iXpos2 = iXpos - 25;
					iYpos2 = iYpos - 210;
					iXpos3 = iXpos + 20;
					iYpos3 = iYpos - 170;
					Pt1 = GetXYpoint(iXpos, iYpos1, 0, 0, 0);
					iWidth = 50;
					iHeight = 25;
					break;
				case 90:
					iXpos1 = iXpos - 210;
					iYpos1 = iYpos - 20;
					iXpos2 = iXpos - 210;
					iYpos2 = iYpos - 25;
					iXpos3 = iXpos - 170;
					iYpos3 = iYpos + 20;
					Pt1 = GetXYpoint(iXpos1, iYpos, 0, 0, 0);
					iWidth = 25;
					iHeight = 50;
					break;
			}
			pg.DrawLine(GetInch(iXpos), GetInch(iYpos), Pt1.X, Pt1.Y);
			pg.DrawLine(GetInch(iXpos1), GetInch(iYpos1), GetInch(iXpos3), GetInch(iYpos3));

			//DrawSocket
			pg.DrawEllipse(GetInch(iXpos1), GetInch(iYpos1), GetInch(40), GetInch(40));
			pg.PenStyle = PenStyles.Transparent;
			OldBackColor = pg.BackColor;
			pg.BackColor = Color.White;
			pg.FillRect(GetInch(iXpos2), GetInch(iYpos2), GetInch(iWidth), GetInch(iHeight));
			pg.BackColor = OldBackColor;
			pg.PenStyle = PenStyles.Solid;

			pg.ForeColor = Color.Black;
			DrawFebComponentText(pg, iXpos1, iYpos1, 20, iRot, strTxt1, strTxt2);
		}

		private static void DrawFebFixedLoad(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			PointF Pt1 = new PointF();
			int iXposX = 0;
			int iYposX = 0;
			int iWidth = 0;
			int iHeight = 0;

			pg.ForeColor = cCol;
			switch (iRot)
			{
				case 0:
					iXposX = iXpos - 20;
					iYposX = iYpos + 50;
					Pt1 = GetXYpoint(iXpos, iYposX, 0, 0, 0);
					iWidth = 40;
					iHeight = 50;
					break;
				case 270:
					iXposX = iXpos + 140;
					iYposX = iYpos - 20;
					Pt1 = GetXYpoint(iXposX, iYpos, 0, 0, 0);
					iWidth = 50;
					iHeight = 40;
					break;
				case 180:
					iXposX = iXpos - 20;
					iYposX = iYpos - 110;
					Pt1 = GetXYpoint(iXpos, iYposX, 0, 0, 0);
					iWidth = 40;
					iHeight = 50;
					break;
				case 90:
					iXposX = iXpos - 190;
					iYposX = iYpos - 20;
					Pt1 = GetXYpoint(iXposX, iYpos, 0, 0, 0);
					iWidth = 50;
					iHeight = 40;
					break;
			}
			pg.DrawLine(GetInch(iXpos), GetInch(iYpos), Pt1.X, Pt1.Y);

			//DrawRectangle
			pg.DrawRect(GetInch(iXposX), GetInch(iYposX), GetInch(iWidth), GetInch(iHeight));

			pg.ForeColor = Color.Black;
			DrawFebComponentText(pg, iXposX, iYposX, 50, iRot, strTxt1, strTxt2);
		}

		private static void DrawFebRingCircuit(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			PointF Pt1 = new PointF();
			Color OldBackColor = new Color();
			int iXposX = 0;
			int iYposX = 0;
			int iXpos1 = 0;
			int iYpos1 = 0;
			int iXpos2 = 0;
			int iYpos2 = 0;
			int iXpos3 = 0;
			int iYpos3 = 0;
			int iWidth = 0;
			int iHeight = 0;

			pg.ForeColor = cCol;
			switch (iRot)
			{
				case 0:
					iXposX = iXpos - 30;
					iYposX = iYpos + 20;
					iXpos1 = iXpos - 20;
					iYpos1 = iYpos + 90;
					iXpos2 = iXpos - 20;
					iYpos2 = iYpos + 110;
					iXpos3 = iXpos + 20;
					iYpos3 = iYpos + 90;
					Pt1 = GetXYpoint(iXpos, iYpos1, 0, 0, 0);
					iWidth = 40;
					iHeight = 20;
					break;
				case 270:
					iXposX = iXpos + 100;
					iYposX = iYpos - 30;
					iXpos1 = iXpos + 170;
					iYpos1 = iYpos - 20;
					iXpos2 = iXpos + 190;
					iYpos2 = iYpos - 20;
					iXpos3 = iXpos + 170;
					iYpos3 = iYpos + 20;
					Pt1 = GetXYpoint(iXpos1, iYpos, 0, 0, 0);
					iWidth = 20;
					iHeight = 40;
					break;
				case 180:
					iXposX = iXpos - 20;
					iYposX = iYpos - 160;
					iXpos1 = iXpos - 20;
					iYpos1 = iYpos - 190;
					iXpos2 = iXpos - 20;
					iYpos2 = iYpos - 190;
					iXpos3 = iXpos + 20;
					iYpos3 = iYpos - 170;
					Pt1 = GetXYpoint(iXpos, iYpos1, 0, 0, 0);
					iWidth = 40;
					iHeight = 20;
					break;
				case 90:
					iXposX = iXpos - 160;
					iYposX = iYpos - 30;
					iXpos1 = iXpos - 210;
					iYpos1 = iYpos - 20;
					iXpos2 = iXpos - 210;
					iYpos2 = iYpos - 20;
					iXpos3 = iXpos - 170;
					iYpos3 = iYpos + 20;
					Pt1 = GetXYpoint(iXpos1, iYpos, 0, 0, 0);
					iWidth = 20;
					iHeight = 40;
					break;
			}
			pg.DrawLine(GetInch(iXpos), GetInch(iYpos), Pt1.X, Pt1.Y);
			pg.DrawLine(GetInch(iXpos1), GetInch(iYpos1), GetInch(iXpos3), GetInch(iYpos3));

			OldBackColor = pg.BackColor;
			pg.BackColor = Color.White;
			//DrawRing
			pg.DrawEllipse(GetInch(iXposX), GetInch(iYposX), GetInch(60), GetInch(60));
			//DrawSocket
			pg.DrawEllipse(GetInch(iXpos1), GetInch(iYpos1), GetInch(40), GetInch(40));
			pg.PenStyle = PenStyles.Transparent;
			pg.FillRect(GetInch(iXpos2), GetInch(iYpos2), GetInch(iWidth), GetInch(iHeight));
			pg.BackColor = OldBackColor;

			pg.ForeColor = Color.Black;
			DrawFebComponentText(pg, iXposX, iYposX, 90, iRot, strTxt1, strTxt2);
		}

		private static void DrawFebBusbarTrunking(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			PointF Pt1 = new PointF();
            Font pfont = new Font("Arial", 6);
			int iXposX = 0;
			int iYposX = 0;

			pg.ForeColor = cCol;
			switch (iRot)
			{
				case 0:
					iXposX = iXpos - 30;
					iYposX = iYpos + 50;
					Pt1 = GetXYpoint(iXpos, iYposX, 0, 0, 0);
					break;
				case 270:
					iXposX = iXpos + 120;
					iYposX = iYpos - 30;
					Pt1 = GetXYpoint(iXposX, iYpos, 0, 0, 0);
					break;
				case 180:
					iXposX = iXpos - 30;
					iYposX = iYpos - 120;
					Pt1 = GetXYpoint(iXpos, iYposX, 0, 0, 0);
					break;
				case 90:
					iXposX = iXpos - 190;
					iYposX = iYpos - 30;
					Pt1 = GetXYpoint(iXposX, iYpos, 0, 0, 0);
					break;
			}
			pg.DrawLine(GetInch(iXpos), GetInch(iYpos), Pt1.X, Pt1.Y);

			//DrawRectangle
			pg.DrawRect(GetInch(iXposX), GetInch(iYposX), GetInch(70), GetInch(70));

			pg.Font = pfont;
			pg.TextAlignment = TextAlignment.Center;
			pg.VerticalTextAlignment = VerticalTextAlignment.Middle;
			pg.DrawText("BTS", GetInch(iXposX + 35) - 0.5f, GetInch(iYposX + 35) - 0.5f, 1.0f, 1.0f);
			pg.ForeColor = Color.Black;
			DrawFebComponentText(pg, iXposX, iYposX, 100, iRot, strTxt1, strTxt2);
		}

		private static void DrawFebDistributionBoard(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			PointF Pt1 = new PointF();
			PointF Pt2 = new PointF();
			int iXposX = 0;

			if (iRot == 0 || iRot == 180) return;
			pg.ForeColor = cCol;
			Pt1 = GetXYpoint(iXpos, iYpos, 0, 190, iRot);
			pg.DrawLine(GetInch(iXpos), GetInch(iYpos), Pt1.X, Pt1.Y);
			pg.PenWidth = 8;
			Pt1 = GetXYpoint(iXpos, iYpos, -50, 190, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, 50, 190, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			pg.PenWidth = 1;

			Pt1 = GetXYpoint(iXpos, iYpos, -50, 190, iRot);
			pg.ForeColor = Color.Black;
			if (iRot == 270) iXposX = iXpos + 190;
			else iXpos = iXpos - 210;
			DrawFebComponentText(pg, iXposX, iYpos - 50, 100, iRot, strTxt1, strTxt2);
		}

		private static void DrawFebGroupBusbar(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
            Font pfont = new Font("Arial", 6);
			Color OldBackColor = new Color();

			OldBackColor = pg.BackColor;
			pg.BackColor = cCol;
			pg.ForeColor = cCol;
			if (iRot == 0 || iRot == 180)
			{
				pg.FillRect(GetInch(iXpos - 15), GetInch(iYpos - 20), GetInch(30), GetInch(20));
			}
			else
			{
				pg.FillRect(GetInch(iXpos - 15), GetInch(iYpos - 10), GetInch(30), GetInch(20));
			}
			pg.BackColor = OldBackColor;
			pg.ForeColor = Color.Black;
			if (iRot == 90 || iRot == 270)
			{
				if (strTxt1 != "")
				{
					pg.Font = pfont;
					pg.TextAlignment = TextAlignment.Left;
					pg.VerticalTextAlignment = VerticalTextAlignment.Bottom;
					pg.DrawText(strTxt1, GetInch(iXpos + 25), GetInch(iYpos - 10), 2.0f, 1.0f);
				}
			}
		}

		private static void DrawFebBranchNode(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			PointF Pt1 = new PointF();
			PointF Pt2 = new PointF();
            Font pfont = new Font("Arial", 6);
			int iYposX;

			pg.ForeColor = cCol;
			if (iRot == 90 || iRot == 270) iYposX = iYpos - 10;
			else iYposX = iYpos;
			for (int iTel = 0; iTel < 20; iTel++)
			{
				Pt1 = GetXYpoint(iXpos, iYposX, 0, 0, iRot);
				Pt2 = GetXYpoint(iXpos, iYposX, -20 + iTel, 0, iRot);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
				Pt1 = GetXYpoint(iXpos, iYposX, 0, -20 + iTel, iRot);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
				Pt2 = GetXYpoint(iXpos, iYposX, 20 - iTel, 0, iRot);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
				Pt1 = GetXYpoint(iXpos, iYposX, 0, 0, iRot);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			}
			pg.ForeColor = Color.Black;
			if (iRot == 90 || iRot == 270)
			{
				if (strTxt1 != "")
				{
					pg.Font = pfont;
					pg.TextAlignment = TextAlignment.Left;
					pg.VerticalTextAlignment = VerticalTextAlignment.Bottom;
					pg.DrawText(strTxt1, GetInch(iXpos + 25), GetInch(iYpos - 10), 2.0f, 1.0f);
				}
			}
		}

		private static void DrawFebJunctionBox(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
            Font pfont = new Font("Arial", 6);
			Color OldBackColor = new Color();

			OldBackColor = pg.BackColor;
			pg.BackColor = cCol;
			pg.ForeColor = cCol;
			pg.DrawEllipse(GetInch(iXpos - 15), GetInch(iYpos - 15), GetInch(30), GetInch(30));
			pg.BackColor = OldBackColor;
			pg.ForeColor = Color.Black;
			if (iRot == 90 || iRot == 270)
			{
				if (strTxt1 != "")
				{
					pg.Font = pfont;
					pg.TextAlignment = TextAlignment.Left;
					pg.VerticalTextAlignment = VerticalTextAlignment.Bottom;
					pg.DrawText(strTxt1, GetInch(iXpos + 25), GetInch(iYpos - 10), 2.0f, 1.0f);
				}
			}
		}

		private static void DrawFebSPD(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			PointF Pt1 = new PointF();
			PointF Pt2 = new PointF();
            Font pfont = new Font("Arial", 6);

			pg.ForeColor = cCol;
			Pt1 = GetXYpoint(iXpos, iYpos,  0, 0, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, 80, 0, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, 40, 0, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, 40, 70, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, 30, 50, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, 50, 110, iRot);
			DrawFebRect(pg, Pt1, Pt2);
			for (int iTel = 0; iTel < 6; iTel++)
			{
				Pt1 = GetXYpoint(iXpos, iYpos, 34 + iTel, 62, iRot);
				Pt2 = GetXYpoint(iXpos, iYpos, 46 - iTel, 62, iRot);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
				Pt1 = GetXYpoint(iXpos, iYpos, 40, 74 - iTel, iRot);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
				Pt2 = GetXYpoint(iXpos, iYpos, 34 + iTel, 62, iRot);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			}
			pg.ForeColor = Color.Black;

			if (strTxt1 != "")
			{
				pg.Font = pfont;
				switch (iRot)
				{
					case 0:
						pg.TextAlignment = TextAlignment.Right;
						pg.VerticalTextAlignment = VerticalTextAlignment.Top;
						Pt1 = GetXYpoint(iXpos, iYpos, -15, 30, iRot);
						pg.DrawText(strTxt1, Pt1.X - 2.0f, Pt1.Y, 2.0f, 1.0f);
						break;
					case 270:
						pg.TextAlignment = TextAlignment.Left;
						pg.VerticalTextAlignment = VerticalTextAlignment.Bottom;
						Pt1 = GetXYpoint(iXpos, iYpos, 15, 30, iRot);
						pg.DrawText(strTxt1, Pt1.X, Pt1.Y - 1.0f, 2.0f, 1.0f);
						break;
					case 180:
						pg.TextAlignment = TextAlignment.Right;
						pg.VerticalTextAlignment = VerticalTextAlignment.Top;
						Pt1 = GetXYpoint(iXpos, iYpos, 15, 90, iRot);
						pg.DrawText(strTxt1, Pt1.X - 2.0f, Pt1.Y, 2.0f, 1.0f);
						break;
					case 90:
						pg.TextAlignment = TextAlignment.Left;
						pg.VerticalTextAlignment = VerticalTextAlignment.Bottom;
						Pt1 = GetXYpoint(iXpos, iYpos, -15, 90, iRot);
						pg.DrawText(strTxt1, Pt1.X, Pt1.Y - 1.0f, 2.0f, 1.0f);
						break;
				}
			}
		}

		private static void DrawFebLineConductor(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			pg.ForeColor = cCol;
			if (iRot == 0 || iRot == 180)
			{
				pg.DrawLine(GetInch(iXpos - 5), GetInch(iYpos + 10), GetInch(iXpos + 5), GetInch(iYpos - 10));
			}
			else
			{
				pg.DrawLine(GetInch(iXpos - 10), GetInch(iYpos + 5), GetInch(iXpos + 10), GetInch(iYpos - 5));
			}
			pg.ForeColor = Color.Black;
		}

		private static void DrawFebNeutralConductor(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			DrawFebLineConductor(pg, iXpos, iYpos, iRot, strTxt1, strTxt2, strTxt3, strTxt4, cCol);
			pg.ForeColor = cCol;
			pg.BackColor = cCol;
			if (iRot == 0 || iRot == 180)
			{
				pg.DrawEllipse(GetInch(iXpos + 2), GetInch(iYpos - 13), GetInch(7), GetInch(7));
			}
			else
			{
				pg.DrawEllipse(GetInch(iXpos + 6), GetInch(iYpos - 8), GetInch(7), GetInch(7));
			}
			pg.ForeColor = Color.Black;
			pg.BackColor = Color.Transparent;
		}

		private static void DrawFebEarthElectrode(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			PointF Pt1 = new PointF();
			PointF Pt2 = new PointF();

			pg.ForeColor = cCol;
			Pt1 = GetXYpoint(iXpos, iYpos, 0, 0, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, 0, 30, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -15, 30, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, 15, 30, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -11, 40, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, 11, 40, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -7, 50, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, 7, 50, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			pg.ForeColor = Color.Black;
		}

		private static void DrawFebEquipotentialBonding(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			PointF Pt1 = new PointF();
			PointF Pt2 = new PointF();

			pg.ForeColor = cCol;
			Pt1 = GetXYpoint(iXpos, iYpos, 0, 0, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, 0, 30, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -15, 30, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, 15, 30, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, 0, 55, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt2 = GetXYpoint(iXpos, iYpos, -15, 30, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			pg.ForeColor = Color.Black;
		}

		private static void DrawFebControlCircuit(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			PointF Pt1 = new PointF();
            Font pfont = new Font("Arial", 6);
			int iXposX = 0;
			int iYposX = 0;

			pg.ForeColor = cCol;
			switch (iRot)
			{
				case 0:
					iXposX = iXpos - 30;
					iYposX = iYpos + 50;
					Pt1 = GetXYpoint(iXpos, iYposX, 0, 0, 0);
					break;
				case 270:
					iXposX = iXpos + 120;
					iYposX = iYpos - 30;
					Pt1 = GetXYpoint(iXposX, iYpos, 0, 0, 0);
					break;
				case 180:
					iXposX = iXpos - 30;
					iYposX = iYpos - 120;
					Pt1 = GetXYpoint(iXpos, iYposX, 0, 0, 0);
					break;
				case 90:
					iXposX = iXpos - 190;
					iYposX = iYpos - 30;
					Pt1 = GetXYpoint(iXposX, iYpos, 0, 0, 0);
					break;
			}
			pg.DrawLine(GetInch(iXpos), GetInch(iYpos), Pt1.X, Pt1.Y);

			//DrawRectangle
			pg.DrawRect(GetInch(iXposX), GetInch(iYposX), GetInch(70), GetInch(70));

			pg.Font = pfont;
			pg.TextAlignment = TextAlignment.Center;
			pg.VerticalTextAlignment = VerticalTextAlignment.Middle;
			pg.DrawText("Ctrl", GetInch(iXposX + 35) - 0.5f, GetInch(iYposX + 35) - 0.5f, 1.0f, 1.0f);
			pg.ForeColor = Color.Black;
			DrawFebComponentText(pg, iXposX, iYposX, 70, iRot, strTxt1, strTxt2);
		}

		private static void DrawFebMeter(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			PointF Pt1 = new PointF();
            Font pfont = new Font("Arial", 6);
			int iXpos1 = 0;
			int iYpos1 = 0;
			int iXpos2 = 0;
			int iYpos2 = 0;
			int iXpos3 = 0;
			int iYpos3 = 0;

			pg.ForeColor = cCol;
			switch (iRot)
			{
				case 0:
					iXpos1 = iXpos - 40;
					iYpos1 = iYpos + 10;
					iXpos2 = iXpos;
					iYpos2 = iYpos + 110;
					iXpos3 = iXpos;
					iYpos3 = iYpos + 120;
					Pt1 = GetXYpoint(iXpos, iYpos1, 0, 0, 0);
					break;
				case 90:
					iXpos1 = iXpos + 20;
					iYpos1 = iYpos - 50;
					iXpos2 = iXpos + 100;
					iYpos2 = iYpos;
					iXpos3 = iXpos + 120;
					iYpos3 = iYpos;
					Pt1 = GetXYpoint(iXpos1, iYpos, 0, 0, 0);
					break;
				case 180:
					iXpos1 = iXpos - 40;
					iYpos1 = iYpos - 110;
					iXpos2 = iXpos;
					iYpos2 = iYpos - 110;
					iXpos3 = iXpos;
					iYpos3 = iYpos - 120;
					Pt1 = GetXYpoint(iXpos, iYpos1, 0, 0, 0);
					break;
				case 270:
					iXpos1 = iXpos - 100;
					iYpos1 = iYpos - 50;
					iXpos2 = iXpos - 110;
					iYpos2 = iYpos;
					iXpos3 = iXpos - 120;
					iYpos3 = iYpos;
					Pt1 = GetXYpoint(iXpos1, iYpos, 0, 0, 0);
					break;
			}
			pg.DrawLine(GetInch(iXpos), GetInch(iYpos), Pt1.X, Pt1.Y);
			pg.DrawLine(GetInch(iXpos2), GetInch(iYpos2), GetInch(iXpos3), GetInch(iYpos3));

			//DrawRectangle
			pg.DrawRect(GetInch(iXpos1), GetInch(iYpos1), GetInch(80), GetInch(100));
			pg.DrawLine(GetInch(iXpos1), GetInch(iYpos1 + 30), GetInch(iXpos1 + 80), GetInch(iYpos1 + 30));

			pg.Font = pfont;
			pg.TextAlignment = TextAlignment.Center;
			pg.VerticalTextAlignment = VerticalTextAlignment.Middle;
			pg.DrawText("Wh", GetInch(iXpos1 + 40) - 0.5f, GetInch(iYpos1 + 70) - 0.5f, 1.0f, 1.0f);
			pg.ForeColor = Color.Black;
			if (strTxt1 != "")
			{
				if (iRot == 0 || iRot == 180)
				{
					pg.TextAlignment = TextAlignment.Right;
					pg.VerticalTextAlignment = VerticalTextAlignment.Top;
					pg.DrawText(strTxt1, GetInch(iXpos1 - 5) - 2.0f, GetInch(iYpos1 + 5), 2.0f, 1.0f);
				}
				else
				{
					pg.TextAlignment = TextAlignment.Left;
					pg.VerticalTextAlignment = VerticalTextAlignment.Bottom;
					pg.DrawText(strTxt1, GetInch(iXpos1 + 5), GetInch(iYpos1 - 5) - 1.0f, 2.0f, 1.0f);
				}
			}
		}

		private static void DrawFebCircuitBreaker(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			PointF Pt1 = new PointF();
			PointF Pt2 = new PointF();

			DrawFebBreaker(pg, iXpos, iYpos, iRot, cCol);
			pg.ForeColor = cCol;
			Pt1 = GetXYpoint(iXpos, iYpos, -10, 30, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, 10, 50, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -10, 50, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, 10, 30, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			pg.ForeColor = Color.Black;
			DrawFebBreakerText(pg, iXpos, iYpos, 28, iRot, strTxt1, strTxt2, strTxt3, strTxt4);
		}

        //Skiljebrytare
		private static void DrawFebDisconnector(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			PointF Pt1 = new PointF();
			PointF Pt2 = new PointF();

			DrawFebBreaker(pg, iXpos, iYpos, iRot, cCol);

			pg.ForeColor = cCol;
			//DrawLine
			Pt1 = GetXYpoint(iXpos, iYpos, -10, 40, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, 10, 40, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);

			pg.ForeColor = Color.Black;
			DrawFebBreakerText(pg, iXpos, iYpos, 28, iRot, strTxt1, strTxt2, strTxt3, strTxt4);
		}

		private static void DrawFebLoadSwitch(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			DrawFebBreaker(pg, iXpos, iYpos, iRot, cCol);
			DrawFebBreakerText(pg, iXpos, iYpos, 28, iRot, strTxt1, strTxt2, strTxt3, strTxt4);
		}

		//Kontaktor
		private static void DrawFebContactor(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			Color OldBackColor;
			int iXpos1 = 0;
			int iYpos1 = 0;
			int iXpos2 = 0;
			int iYpos2 = 0;
			int iWidth = 0;
			int iHeight = 0;

			switch (iRot)
			{
				case 0:
					iXpos1 = iXpos - 10;
					iYpos1 = iYpos + 20;
					iXpos2 = iXpos + 1;
					iYpos2 = iYpos + 19;//39
					iWidth = 11;
					iHeight = 22;
					break;
				case 270:
					iXpos1 = iXpos + 20;
					iYpos1 = iYpos - 10;
					iXpos2 = iXpos + 19;
					iYpos2 = iYpos - 11;
					iWidth = 22;
					iHeight = 11;
					break;
				case 180:
					iXpos1 = iXpos;
					iYpos1 = iYpos - 40;
					iXpos2 = iXpos - 11;
					iYpos2 = iYpos - 41;
					iWidth = 11;
					iHeight = 22;
					break;
				case 90:
					iXpos1 = iXpos - 40;
					iYpos1 = iYpos - 10;
					iXpos2 = iXpos - 41;
					iYpos2 = iYpos + 1;
					iWidth = 22;
					iHeight = 11;
					break;
			}
			//Draw Arc
			pg.DrawEllipse(GetInch(iXpos1), GetInch(iYpos1), GetInch(20), GetInch(20));
			pg.PenStyle = PenStyles.Transparent;
			OldBackColor = pg.BackColor;
			pg.BackColor = Color.White;
			pg.FillRect(GetInch(iXpos2), GetInch(iYpos2), GetInch(iWidth), GetInch(iHeight));
			pg.BackColor = OldBackColor;
			pg.PenStyle = PenStyles.Solid;

			DrawFebBreaker(pg, iXpos, iYpos, iRot, cCol);

			pg.ForeColor = cCol;

			////Draw ARC look alike..
			//Pt1 = GetXYpoint(iXpos, iYpos, 0, 40, iRot);
			//Pt2 = GetXYpoint(iXpos, iYpos, -4, 39, iRot);
			//pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			//Pt1 = GetXYpoint(iXpos, iYpos, -7, 37, iRot);
			//pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			//Pt2 = GetXYpoint(iXpos, iYpos, -9, 33, iRot);
			//pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			//Pt1 = GetXYpoint(iXpos, iYpos, -10, 30, iRot); // The Top
			//pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			//Pt2 = GetXYpoint(iXpos, iYpos, -9, 27, iRot);
			//pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			//Pt1 = GetXYpoint(iXpos, iYpos, -7, 23, iRot);
			//pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			//Pt2 = GetXYpoint(iXpos, iYpos, -4, 21, iRot);
			//pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			//Pt1 = GetXYpoint(iXpos, iYpos, 0, 20, iRot);
			//pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);

			pg.ForeColor = Color.Black;

			DrawFebBreakerText(pg, iXpos, iYpos, 28, iRot, strTxt1, strTxt2, strTxt3, strTxt4);
		}

		private static void DrawFebMCB(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			PointF Pt1 = new PointF();
			PointF Pt2 = new PointF();

			DrawFebBreaker(pg, iXpos, iYpos, iRot, cCol);

			pg.ForeColor = cCol;
			Pt1 = GetXYpoint(iXpos, iYpos, -12, 57, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, -28, 57, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -28, 45, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt2 = GetXYpoint(iXpos, iYpos, -40, 45, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -40, 57, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt2 = GetXYpoint(iXpos, iYpos, -46, 57, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);

			//Draw ARC look alike..
			Pt1 = GetXYpoint(iXpos, iYpos, -3, 73, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, -28, 73, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -29, 70, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt2 = GetXYpoint(iXpos, iYpos, -31, 68, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -34, 67, iRot); // The Top
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt2 = GetXYpoint(iXpos, iYpos, -37, 68, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -39, 70, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt2 = GetXYpoint(iXpos, iYpos, -40, 73, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -46, 73, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);

			pg.ForeColor = Color.Black;
			DrawFebBreakerText(pg, iXpos, iYpos, 50, iRot, strTxt1, strTxt2, strTxt3, strTxt4);
		}

		private static void DrawFebMCBRCD(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			PointF Pt1 = new PointF();
			PointF Pt2 = new PointF();

			DrawFebBreaker(pg, iXpos, iYpos, iRot, cCol);

			pg.ForeColor = cCol;

			Pt1 = GetXYpoint(iXpos, iYpos, -16, 49, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, -28, 49, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -28, 35, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt2 = GetXYpoint(iXpos, iYpos, -40, 35, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -40, 49, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt2 = GetXYpoint(iXpos, iYpos, -46, 49, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);

			//Draw ARC look alike..
			Pt1 = GetXYpoint(iXpos, iYpos, -9, 61, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, -28, 61, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -29, 58, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt2 = GetXYpoint(iXpos, iYpos, -31, 56, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -34, 55, iRot); // The Top
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt2 = GetXYpoint(iXpos, iYpos, -37, 56, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -39, 58, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt2 = GetXYpoint(iXpos, iYpos, -40, 61, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -46, 61, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);

			// Draw "I"
			Pt1 = GetXYpoint(iXpos, iYpos, -35, 70, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, -35, 85, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -30, 70, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, -40, 70, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -30, 85, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, -40, 85, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			//Draw "Delta"
			Pt1 = GetXYpoint(iXpos, iYpos, -23, 77, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, -18, 92, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -28, 92, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt2 = GetXYpoint(iXpos, iYpos, -23, 77, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);

			pg.ForeColor = Color.Black;
			DrawFebBreakerText(pg, iXpos, iYpos, 50, iRot, strTxt1, strTxt2, strTxt3, strTxt4);
		}

        //Load disconnector
		private static void DrawFebSwitchDisconnector(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			PointF Pt1 = new PointF();
			PointF Pt2 = new PointF();
			pg.ForeColor = cCol;

			Pt1.X = GetInch(iXpos);
			Pt1.Y = GetInch(iYpos);
			Pt2 = GetXYpoint(iXpos, iYpos, 0, 30, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -22, 37, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, 0, 80, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, 0, 120, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);

			//DrawLine
			Pt1 = GetXYpoint(iXpos, iYpos, -10, 30, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, 10, 30, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			// Draw "Circle..."

			if (iRot == 0)
				Pt1 = GetXYpoint(iXpos, iYpos, -7, 30, iRot);
			else if (iRot == 180)
				Pt1 = GetXYpoint(iXpos, iYpos, 7, 50, iRot);
			else if (iRot == 270)
				Pt1 = GetXYpoint(iXpos, iYpos, 7, 30, iRot);
			else
				Pt1 = GetXYpoint(iXpos, iYpos, -7, 50, iRot);

			//if (iRot == 0)
			//    Pt1 = GetXYpoint(iXpos, iYpos, -10, 30, iRot);
			//else if (iRot == 180)
			//    Pt1 = GetXYpoint(iXpos, iYpos, 10, 50, iRot);
			//else if (iRot == 90)
			//    Pt1 = GetXYpoint(iXpos, iYpos, 10, 30, iRot);
			//else 
			//    Pt1 = GetXYpoint(iXpos, iYpos, -10, 50, iRot);

			pg.DrawEllipse(Pt1.X, Pt1.Y, GetInch(14), GetInch(14));


			DrawFebBreakerText(pg, iXpos, iYpos, 28, iRot, strTxt1, strTxt2, strTxt3, strTxt4);
		}

		private static void DrawFebRCD(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			PointF Pt1 = new PointF();
			PointF Pt2 = new PointF();

			DrawFebBreaker(pg, iXpos, iYpos, iRot, cCol);
			pg.ForeColor = cCol;

			// Draw "I"
			Pt1 = GetXYpoint(iXpos, iYpos, -35, 51, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, -35, 66, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -30, 51, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, -40, 51, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -30, 66, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, -40, 66, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			//Draw "Delta"
			Pt1 = GetXYpoint(iXpos, iYpos, -23, 58, iRot);
			Pt2 = GetXYpoint(iXpos, iYpos, -18, 73, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt1 = GetXYpoint(iXpos, iYpos, -28, 73, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			Pt2 = GetXYpoint(iXpos, iYpos, -23, 58, iRot);
			pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			pg.ForeColor = Color.Black;

			DrawFebBreakerText(pg, iXpos, iYpos, 45, iRot, strTxt1, strTxt3, "", "");
		}

		private static void DrawFebCable(Page pg, int iXpos1, int iYpos1, int iXpos2, int iYpos2, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			PointF Pt1 = new PointF();
			PointF Pt2 = new PointF();
			SizeF Sz1 = new SizeF();
			int iCableLength;
			int iRotation;
			int iTextPos;
			float rTextPos;

            Font pfont = new Font("Arial", 6);
			pg.Font = pfont;
			//pg.PenStyle = ePenstyle;
			pg.ForeColor = cCol;

			//Draw Line
			pg.DrawLine(GetInch(iXpos1), GetInch(iYpos1), GetInch(iXpos2), GetInch(iYpos2));

			if (iXpos1 > iXpos2)
			{
				iRotation = 180;
				iCableLength = iXpos1 - iXpos2;
			}
			else if (iXpos2 > iXpos1)
			{
				iRotation = 0;
				iCableLength = iXpos2 - iXpos1;
			}
			else if (iYpos1 > iYpos2)
			{
				iRotation = 270;
				iCableLength = iYpos1 - iYpos2;
			}
			else
			{
				iRotation = 90;
				iCableLength = iYpos2 - iYpos1;
			}


			//Draw triangle 1
			for (int iCount = 0; iCount < 10; iCount++)
			{
				Pt1 = GetXYpoint(iXpos1, iYpos1, 0, -10 + iCount, iRotation);
				Pt2 = GetXYpoint(iXpos1, iYpos1, 0, 10 - iCount, iRotation);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
				Pt1 = GetXYpoint(iXpos1, iYpos1, 20 - iCount, 0, iRotation);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
				Pt2 = GetXYpoint(iXpos1, iYpos1, 0, -10 + iCount, iRotation);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			}

			//Draw triangle 2
			for (int iCount = 0; iCount < 10; iCount++)
			{
				Pt1 = GetXYpoint(iXpos2, iYpos2, 0, -10 + iCount, iRotation);
				Pt2 = GetXYpoint(iXpos2, iYpos2, 0, 10 - iCount, iRotation);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
				Pt1 = GetXYpoint(iXpos2, iYpos2, iCount - 20, 0, iRotation);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
				Pt2 = GetXYpoint(iXpos2, iYpos2, 0, -10 + iCount, iRotation);
				pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
			}
			pg.ForeColor = Color.Black;

			Sz1 = pg.MeasureText(strTxt2);
			if (Sz1.Width <= GetInch(iCableLength))
			{
				pg.VerticalTextAlignment = VerticalTextAlignment.Bottom;
				if (iRotation == 0 || iRotation == 180)
				{
					if (iRotation == 180)
					{
						pg.TextAlignment = TextAlignment.Right;
						rTextPos = GetInch(iXpos2 - 35) - 5.0f;
					}
					else
					{
						pg.TextAlignment = TextAlignment.Left;
						rTextPos = GetInch(iXpos1 + 35);
					}
					iTextPos = iYpos1 - 5;
					if (strTxt3 != "")
					{
						pg.DrawText(strTxt3, rTextPos, GetInch(iTextPos) - 1.0f, 5.0f, 1.0f);
						iTextPos -= 25;
					}
					if (strTxt2 != "")
					{
						pg.DrawText(strTxt2, rTextPos, GetInch(iTextPos) - 1.0f, 5.0f, 1.0f);
						iTextPos -= 25;
					}
					if (strTxt1 != "") pg.DrawText(strTxt1, rTextPos, GetInch(iTextPos) - 1.0f, 5.0f, 1.0f);
				}
				else
				{
					pg.TextAngle = 2700;
					if (iRotation == 270)
					{
						pg.TextAlignment = TextAlignment.Right;
						rTextPos = GetInch(iYpos1 - 20);
					}
					else
					{
						pg.TextAlignment = TextAlignment.Right;
						rTextPos = GetInch(iYpos2 - 20);
					}
					iTextPos = iXpos1 - 5;
					if (strTxt3 != "")
					{
						Sz1 = pg.MeasureText(strTxt3);
						pg.DrawText(strTxt3, GetInch(iTextPos) - 1.0f, rTextPos - Sz1.Width, 1.0f, Sz1.Width);
						iTextPos -= 25;
					}
					if (strTxt2 != "")
					{
						Sz1 = pg.MeasureText(strTxt2);
						pg.DrawText(strTxt2, GetInch(iTextPos) - 1.0f, rTextPos - Sz1.Width, 1.0f, Sz1.Width);
						iTextPos -= 25;
					}
					if (strTxt1 != "")
					{
						Sz1 = pg.MeasureText(strTxt1);
						pg.DrawText(strTxt1, GetInch(iTextPos) - 1.0f, rTextPos - Sz1.Width, 1.0f, Sz1.Width);
					}

					pg.TextAngle = 0;
				}
			}
		}

		private static void DrawFebText(Page pg, int iXpos, int iYpos, int iRot, string strTxt, Color clPen, VerticalTextAlignment vertTextAlignment, TextAlignment txtAlign, int iFontSize)
		{
			SizeF Sz1 = new SizeF();
			float rYpos = 0;
			float rXpos = 0;

            Font pfont = new Font("Arial", iFontSize);
            pg.Font = pfont;

            pg.ForeColor = clPen;
			pg.VerticalTextAlignment = vertTextAlignment;
			pg.TextAlignment = txtAlign;

			if (strTxt != "")
			{
                try
                {
                    Sz1 = pg.MeasureText(strTxt);
                }
                catch (Exception err)
                {
                    throw;
                }

				if (iRot == 0 || iRot == 180)
				{
					if (vertTextAlignment == VerticalTextAlignment.Top)
						rYpos = GetInch(iYpos);
					else if (vertTextAlignment == VerticalTextAlignment.Bottom)
						rYpos = GetInch(iYpos) - Sz1.Height;
					else if (vertTextAlignment == VerticalTextAlignment.Middle)
						rYpos = GetInch(iYpos) - (Sz1.Height / 2);

					if (txtAlign == TextAlignment.Left)
						rXpos = GetInch(iXpos);
					else if (txtAlign == TextAlignment.Right)
						rXpos = GetInch(iXpos) - Sz1.Width;
					else if (txtAlign == TextAlignment.Center)
						rXpos = GetInch(iXpos) - (Sz1.Width / 2);

					pg.DrawText(strTxt, rXpos, rYpos, Sz1.Width, Sz1.Height);
				}
				else
				{
					pg.TextAngle = 2700;

					//if (txtAlign == TextAlignment.Left)
					//	rYpos = GetInch(iYpos);
					//else if (txtAlign == TextAlignment.Right)
					//	rYpos = GetInch(iYpos) - Sz1.Width;
					//else if (txtAlign == TextAlignment.Center)
					//	rYpos = GetInch(iYpos) - (Sz1.Width / 2);

					//if (vertTextAlignment == VerticalTextAlignment.Top)
					//	rXpos = GetInch(iXpos);
					//else if (vertTextAlignment == VerticalTextAlignment.Bottom)
					//	rXpos = GetInch(iXpos) - Sz1.Height;
					//else if (vertTextAlignment == VerticalTextAlignment.Middle)
					//	rXpos = GetInch(iXpos) - (Sz1.Height / 2);

					//pg.TextAlignment			= TextAlignment.Left;
					//pg.VerticalTextAlignment	= VerticalTextAlignment.Top;

					rXpos						= GetInch(iXpos);
					rYpos						= GetInch(iYpos);
					pg.TextAlignment			= TextAlignment.Right;
					pg.VerticalTextAlignment	= VerticalTextAlignment.Bottom;


					pg.DrawText(strTxt, rXpos - 1.0f, rYpos - Sz1.Width, 1.0f, Sz1.Width);
					//pg.DrawText(strTxt, rXpos, rYpos, Sz1.Height, Sz1.Width);

					pg.TextAngle = 0;
				}

			}
            

        }
		private static void DrawFebRect(Page pg, int iXpos, int iYpos, int iWidth, int iHeight)
		{
			DrawFebLine(pg, iXpos, iYpos, iXpos + iWidth, iYpos);
			DrawFebLine(pg, iXpos + iWidth, iYpos, iXpos + iWidth, iYpos + iHeight);
			DrawFebLine(pg, iXpos + iWidth, iYpos + iHeight, iXpos, iYpos + iHeight);
			DrawFebLine(pg, iXpos, iYpos + iHeight, iXpos, iYpos);
		}

		private static void DrawFebLine(Page pg, int iXpos1, int iYpos1, int iXpos2, int iYpos2)
		{
			pg.DrawLine(GetInch(iXpos1), GetInch(iYpos1), GetInch(iXpos2), GetInch(iYpos2));
		}

		private static void DrawFebUPS(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
            Font pfont = new Font("Arial", 6);
			int iXposX;
			int iYposX;

			pg.Font = pfont;
			pg.ForeColor = cCol;
			pg.BackColor = Color.Transparent;

			string strText = "";
			if (!string.IsNullOrWhiteSpace(strTxt1))
				strText = strTxt1;
			if (!string.IsNullOrWhiteSpace(strTxt2))
			{
				if (!string.IsNullOrWhiteSpace(strText))
					strText += Environment.NewLine;
				strText += strTxt2;
			}
			if (!string.IsNullOrWhiteSpace(strTxt3))
			{
				if (!string.IsNullOrWhiteSpace(strText))
					strText += Environment.NewLine;
				strText += strTxt3;
			}

			if (iRot == 0 || iRot == 180)
			{
				if (iRot == 0) iYposX = iYpos;
				else iYposX = iYpos - 120;
				//DrawLine
				//DrawFebLine(pg, iXpos, iYposX, iXpos, iYposX + 20);//Febdok draws line instead.. 
				DrawFebLine(pg, iXpos, iYposX + 100, iXpos, iYposX + 120);

				//Draw UPS
				DrawFebRect(pg, iXpos - 40, iYposX + 20, 80, 80);
				DrawFebLine(pg, iXpos - 40, iYposX + 100, iXpos + 40, iYposX + 20);

				pg.TextAlignment = TextAlignment.Center;
				pg.VerticalTextAlignment = VerticalTextAlignment.Middle;
				pg.DrawText("~", GetInch(iXpos - 20) - 0.5f, GetInch(iYposX + 40) - 0.5f, 1.0f, 1.0f);
				pg.DrawText("~", GetInch(iXpos + 20) - 0.5f, GetInch(iYposX + 80) - 0.5f, 1.0f, 1.0f);

				if (!string.IsNullOrWhiteSpace(strText))
				{
					pg.ForeColor = Color.Black;
					pg.TextAlignment = TextAlignment.Right;
					pg.VerticalTextAlignment = VerticalTextAlignment.Top;
					pg.DrawText(strTxt1, GetInch(iXpos - 45) - 2.0f, GetInch(iYpos + 20), 2.0f, 1.0f);
				}
			}
			else
			{
				if (iRot == 270) iXposX = iXpos;
				else iXposX = iXpos - 220;

				pg.ForeColor = cCol;
				DrawFebRect(pg, iXposX + 40, iYpos - 60, 140, 140);
				DrawFebUpsCore1(pg, iXposX, iYpos);
				pg.ForeColor = Color.Black;
				if (!string.IsNullOrWhiteSpace(strText))
				{
					pg.TextAlignment = TextAlignment.Left;
					pg.VerticalTextAlignment = VerticalTextAlignment.Bottom;
					pg.DrawText(strTxt1, GetInch(iXpos +40), GetInch(iYpos - 61) - 1.0f, 2.0f, 1.0f);
				}
			}
		}

		private static void DrawFebUPS_StaticBypass(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			int iXposX;

			//if (iRot == 0 || iRot == 180) return;
			//if (iRot == 270) iXposX = iXpos;
			//else iXposX = iXpos - 220;

			if (iRot != 0)
				return;
			iXposX = iXpos;

			pg.ForeColor = cCol;
			DrawFebRect(pg, iXposX + 40, iYpos - 100, 140, 180);
			DrawFebUpsCore1(pg, iXposX, iYpos);
			DrawFebUpsCore2(pg, iXposX + 60, iYpos - 65);
			DrawFebLine(pg, iXposX +  60, iYpos, iXposX + 60, iYpos - 65);
			DrawFebLine(pg, iXposX + 160, iYpos, iXpos + 160, iYpos - 65);
			pg.ForeColor = Color.Black;
			DrawFebUpsText(pg, iXposX + 40, iYpos - 100, strTxt1, strTxt2, strTxt3);
		}

		private static void DrawFebUPS_StaticBypass_SeparateFeeder(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			int iXposX;

			//if (iRot == 0 || iRot == 180) return;
			//if (iRot == 270) iXposX = iXpos;
			//else iXposX = iXpos - 220;

			if (iRot != 0)
				return;
			iXposX = iXpos;

			pg.ForeColor = cCol;
			DrawFebRect(pg, iXposX + 40, iYpos - 140, 140, 220);
			DrawFebUpsCore1(pg, iXposX, iYpos);
			DrawFebUpsCore2(pg, iXposX + 60, iYpos - 100);
			DrawFebLine(pg, iXposX, iYpos - 100, iXposX + 60, iYpos - 100);
			DrawFebLine(pg, iXposX + 160, iYpos, iXpos + 160, iYpos - 100);
			pg.ForeColor = Color.Black;
			DrawFebUpsText(pg, iXposX + 40, iYpos - 140, strTxt1, strTxt2, strTxt3);
		}

		private static void DrawFebUpsCore1(Page pg, int iXpos, int iYpos)
		{
            Font pfont = new Font("Arial", 6);

			DrawFebLine(pg, iXpos, iYpos, iXpos + 80, iYpos);
			DrawFebLine(pg, iXpos + 140, iYpos, iXpos + 220, iYpos);

			DrawFebRect(pg, iXpos + 80, iYpos - 30, 60, 60);
			DrawFebLine(pg, iXpos + 80, iYpos + 30, iXpos + 140, iYpos - 30);
			DrawFebLine(pg, iXpos + 110, iYpos + 30, iXpos + 110, iYpos + 50);
			DrawFebLine(pg, iXpos + 100, iYpos + 50, iXpos + 120, iYpos + 50);
			DrawFebLine(pg, iXpos + 90, iYpos + 60, iXpos + 130, iYpos + 60);

			pg.Font = pfont;
			pg.TextAlignment = TextAlignment.Center;
			pg.VerticalTextAlignment = VerticalTextAlignment.Middle;
			pg.DrawText("~", GetInch(iXpos + 97) - 0.5f, GetInch(iYpos - 12) - 0.5f, 1.0f, 1.0f);
			pg.DrawText("~", GetInch(iXpos + 123) - 0.5f, GetInch(iYpos + 12) - 0.5f, 1.0f, 1.0f);
		}

		private static void DrawFebUpsCore2(Page pg, int iXpos, int iYpos)
		{
			DrawFebLine(pg, iXpos, iYpos, iXpos + 100, iYpos);

			DrawFebRect(pg, iXpos + 30, iYpos - 20, 44, 40);
			DrawFebLine(pg, iXpos + 38, iYpos + 13, iXpos + 38, iYpos - 13);
			DrawFebLine(pg, iXpos + 38, iYpos - 13, iXpos + 63, iYpos);
			DrawFebLine(pg, iXpos + 63, iYpos, iXpos + 38, iYpos + 13);
			DrawFebLine(pg, iXpos + 50, iYpos + 7, iXpos + 50, iYpos + 15);
		}

		private static void DrawFebUpsText(Page pg, int iXpos, int iYpos, string strTxt1, string strTxt2, string strTxt3)
		{
            Font pfont = new Font("Arial", 6);
			int iYposX;

			pg.Font = pfont;
			pg.TextAlignment = TextAlignment.Left;
			pg.VerticalTextAlignment = VerticalTextAlignment.Bottom;
			iYposX = iYpos - 5;
			if (strTxt3 != "")
			{
				pg.DrawText(strTxt3, GetInch(iXpos), GetInch(iYposX) - 1.0f, 5.0f, 1.0f);
				iYposX -= 25;
			}
			if (strTxt2 != "")
			{
				pg.DrawText(strTxt2, GetInch(iXpos), GetInch(iYposX) - 1.0f, 5.0f, 1.0f);
				iYposX -= 25;
			}
			if (strTxt1 != "")
			{
				pg.DrawText(strTxt1, GetInch(iXpos), GetInch(iYposX) - 1.0f, 5.0f, 1.0f);
			}
		}

		private static void DrawFebTrafo(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			PointF Pt1 = new PointF();
			int iXpos1 = 0;
			int iYpos1 = 0;
			int iXpos2 = 0;
			int iYpos2 = 0;
			int iXpos3 = 0;
			int iYpos3 = 0;
			int iXpos4 = 0;
			int iYpos4 = 0;
			int iDiameter = 0;

			pg.ForeColor = cCol;
			switch (iRot)
			{
				case 0:
					iXpos1 = iXpos - 40;
					iYpos1 = iYpos + 50;
					iXpos2 = iXpos - 40;
					iYpos2 = iYpos + 100;
					iXpos3 = iXpos;
					iYpos3 = iYpos + 180;
					iXpos4 = iXpos;
					iYpos4 = iYpos + 230;
					iDiameter = 80;
					Pt1 = GetXYpoint(iXpos, iYpos1, 0, 0, 0);
					break;
				case 270:
					iXpos1 = iXpos + 30;
					iYpos1 = iYpos - 30;
					iXpos2 = iXpos + 70;
					iYpos2 = iYpos - 30;
					iXpos3 = iXpos + 130;
					iYpos3 = iYpos;
					iXpos4 = iXpos + 160;
					iYpos4 = iYpos;
					iDiameter = 60;
					Pt1 = GetXYpoint(iXpos1, iYpos, 0, 0, 0);
					break;
				case 180:
					iXpos1 = iXpos - 30;
					iYpos1 = iYpos - 130;
					iXpos2 = iXpos - 30;
					iYpos2 = iYpos - 90;
					iXpos3 = iXpos;
					iYpos3 = iYpos - 160;
					iXpos4 = iXpos;
					iYpos4 = iYpos - 130;
					iDiameter = 60;
					Pt1 = GetXYpoint(iXpos, iYpos1 - 30, 0, 0, 0);
					break;
				case 90:
					iXpos1 = iXpos - 130;
					iYpos1 = iYpos - 30;
					iXpos2 = iXpos - 90;
					iYpos2 = iYpos - 30;
					iXpos3 = iXpos - 130;
					iYpos3 = iYpos;
					iXpos4 = iXpos - 160;
					iYpos4 = iYpos;
					iDiameter = 60;
					Pt1 = GetXYpoint(iXpos1, iYpos, 0, 0, 0);
					break;
			}
			pg.DrawLine(GetInch(iXpos), GetInch(iYpos), Pt1.X, Pt1.Y);
			pg.DrawLine(GetInch(iXpos3), GetInch(iYpos3), GetInch(iXpos4), GetInch(iYpos4));

			//DrawTrafo
			pg.BackColor = Color.Transparent;
			pg.DrawEllipse(GetInch(iXpos1), GetInch(iYpos1), GetInch(iDiameter), GetInch(iDiameter));
			pg.DrawEllipse(GetInch(iXpos2), GetInch(iYpos2), GetInch(iDiameter), GetInch(iDiameter));

			pg.ForeColor = Color.Black;

			//Text
			if (iRot == 0 || iRot == 180)
			{
				pg.TextAlignment = TextAlignment.Right;
				pg.VerticalTextAlignment = VerticalTextAlignment.Bottom;
				if (strTxt1 != "")
				{
					Pt1 = GetXYpoint(iXpos1, iYpos1, -5, 20, 0);
					pg.DrawText(strTxt1, Pt1.X - 2.0f, Pt1.Y - 1.0f, 2.0f, 1.0f);
				}
				if (strTxt2 != "")
				{
					Pt1 = GetXYpoint(iXpos1, iYpos1, -5, 45, 0);
					pg.DrawText(strTxt2, Pt1.X - 2.0f, Pt1.Y - 1.0f, 2.0f, 1.0f);
				}
				pg.VerticalTextAlignment = VerticalTextAlignment.Top;
				if (strTxt3 != "")
				{
					pg.ForeColor = Color.Red;
					Pt1 = GetXYpoint(iXpos1, iYpos1, -5, 55, 0);
					pg.DrawText(strTxt4, Pt1.X - 2.0f, Pt1.Y, 2.0f, 1.0f);
				}
				if (strTxt4 != "")
				{
					pg.ForeColor = Color.Red;
					Pt1 = GetXYpoint(iXpos1, iYpos1, -5, 80, 0);
					pg.DrawText(strTxt4, Pt1.X - 2.0f, Pt1.Y, 2.0f, 1.0f);
				}
			}
			else
			{
				pg.TextAlignment = TextAlignment.Left;
				pg.VerticalTextAlignment = VerticalTextAlignment.Bottom;
				iYpos -= 35;
				if (strTxt3 + strTxt4 != "")
				{
					Pt1 = GetXYpoint(iXpos1, iYpos1, 5, 0, 0);
					pg.DrawText(strTxt3 + "  " + strTxt4, Pt1.X, Pt1.Y - 1.0f, 2.0f, 1.0f);
					iYpos1 -= 25;
				}
				if (strTxt1 != "")
				{
					Pt1 = GetXYpoint(iXpos1, iYpos1, 5, 0, 0);
					pg.DrawText(strTxt1, Pt1.X, Pt1.Y - 1.0f, 2.0f, 1.0f);
				}
			}
		}

		private static void DrawFebBellTransformer(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			PointF Pt1 = new PointF();
			Color OldBackColor = new Color();
            Font pfont = new Font("Arial", 6);
			int iXpos1 = 0;
			int iYpos1 = 0;
			int iXpos2 = 0;
			int iYpos2 = 0;
			int iXpos3 = 0;
			int iYpos3 = 0;

			pg.Font = pfont;
			pg.ForeColor = cCol;
			switch (iRot)
			{
				case 0:
					iXpos1 = iXpos - 40;
					iYpos1 = iYpos + 20;
					iXpos2 = iXpos - 40;
					iYpos2 = iYpos + 100;
					iXpos3 = iXpos - 40;
					iYpos3 = iYpos + 120;
					Pt1 = GetXYpoint(iXpos, iYpos1, 0, 0, 0);
					break;
				case 270:
					iXpos1 = iXpos + 20;
					iYpos1 = iYpos - 40;
					iXpos2 = iXpos + 100;
					iYpos2 = iYpos;
					iXpos3 = iXpos + 120;
					iYpos3 = iYpos;
					Pt1 = GetXYpoint(iXpos1, iYpos, 0, 0, 0);
					break;
				case 180:
					iXpos1 = iXpos - 40;
					iYpos1 = iYpos - 100;
					iXpos2 = iXpos - 40;
					iYpos2 = iYpos - 20;
					iXpos3 = iXpos - 40;
					iYpos3 = iYpos;
					Pt1 = GetXYpoint(iXpos, iYpos1, 0, 0, 0);
					break;
				case 90:
					iXpos1 = iXpos - 100;
					iYpos1 = iYpos - 40;
					iXpos2 = iXpos - 20;
					iYpos2 = iYpos;
					iXpos3 = iXpos;
					iYpos3 = iYpos;
					Pt1 = GetXYpoint(iXpos1, iYpos, 0, 0, 0);
					break;
			}
			pg.DrawLine(GetInch(iXpos), GetInch(iYpos), Pt1.X, Pt1.Y);
			pg.DrawLine(GetInch(iXpos2), GetInch(iYpos2), GetInch(iXpos3), GetInch(iYpos3));

			pg.DrawRect(GetInch(iXpos1), GetInch(iYpos1), GetInch(80), GetInch(80));

			//DrawTrafo
			pg.BackColor = Color.Transparent;
			pg.DrawEllipse(GetInch(iXpos1 + 21), GetInch(iYpos1 + 46), GetInch(24), GetInch(24));
			pg.DrawEllipse(GetInch(iXpos1 + 35), GetInch(iYpos1 + 46), GetInch(24), GetInch(24));
			pg.DrawLine(GetInch(iXpos1 + 11), GetInch(iYpos1 + 58), GetInch(iXpos1 + 21), GetInch(iYpos1 + 58));
			pg.DrawLine(GetInch(iXpos1 + 59), GetInch(iYpos1 + 58), GetInch(iXpos1 + 69), GetInch(iYpos1 + 58));

			//DrawBell
			pg.DrawEllipse(GetInch(iXpos1 + 28), GetInch(iYpos1 + 10), GetInch(24), GetInch(24));
			pg.PenStyle = PenStyles.Transparent;
			OldBackColor = pg.BackColor;
			pg.BackColor = Color.White;
			pg.FillRect(GetInch(iXpos1 + 28), GetInch(iYpos1 + 22), GetInch(24), GetInch(13));
			pg.BackColor = OldBackColor;
			pg.PenStyle = PenStyles.Solid;
			pg.DrawLine(GetInch(iXpos1 + 28), GetInch(iYpos1 + 22), GetInch(iXpos1 + 52), GetInch(iYpos1 + 22));
			pg.DrawLine(GetInch(iXpos1 + 35), GetInch(iYpos1 + 22), GetInch(iXpos1 + 35), GetInch(iYpos1 + 32));
			pg.DrawLine(GetInch(iXpos1 + 45), GetInch(iYpos1 + 22), GetInch(iXpos1 + 45), GetInch(iYpos1 + 32));

			pg.ForeColor = Color.Black;

			//Text
			if (strTxt1 != "")
			{
				if (iRot == 0 || iRot == 180)
				{
					pg.TextAlignment = TextAlignment.Right;
					pg.VerticalTextAlignment = VerticalTextAlignment.Top;
					pg.DrawText(strTxt1, GetInch(iXpos1 - 5) - 2.0f, GetInch(iYpos1 + 5), 2.0f, 1.0f);
				}
				else
				{
					pg.TextAlignment = TextAlignment.Left;
					pg.VerticalTextAlignment = VerticalTextAlignment.Bottom;
					pg.DrawText(strTxt1, GetInch(iXpos1 + 5), GetInch(iYpos1 - 5) - 1.0f, 2.0f, 1.0f);
				}
			}
		}

        //private static void DrawFebUPS(Page pg, int iXpos, int iYpos, int iRot, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
        //{
        //    int iXposX;
        //    int iYposX;
        //    PointF Pt1 = new PointF();
        //    PointF Pt2 = new PointF();
        //    Font pfont = new Font("Arial", 6);
        //    pg.Font = pfont;
        //    pg.ForeColor = cCol;
        //    pg.BackColor = Color.Transparent;


        //    if (iRot == 0 || iRot == 180)
        //    {
        //        //DrawLine
        //        Pt1 = GetXYpoint(iXpos, iYpos, 0, 0, iRot);
        //        Pt2 = GetXYpoint(iXpos, iYpos, 0, -20, iRot);
        //        pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);

        //        Pt1 = GetXYpoint(iXpos, iYpos, 0, -100, iRot);
        //        Pt2 = GetXYpoint(iXpos, iYpos, 0, -120, iRot);
        //        pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);

        //        //Draw UPS
        //        Pt1 = GetXYpoint(iXpos, iYpos, -40, -20, iRot);
        //        Pt2 = GetXYpoint(iXpos, iYpos, 40, -20, iRot);
        //        pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
        //        Pt1 = GetXYpoint(iXpos, iYpos, 40, -100, iRot);
        //        pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
        //        Pt2 = GetXYpoint(iXpos, iYpos, -40, -100, iRot);
        //        pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
        //        Pt1 = GetXYpoint(iXpos, iYpos, -40, -20, iRot);
        //        pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);

        //        Pt1 = GetXYpoint(iXpos, iYpos, -40, -20, iRot);
        //        Pt2 = GetXYpoint(iXpos, iYpos, 40, -100, iRot);
        //        pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);

        //        // Draw "~"
        //        Pt1 = GetXYpoint(iXpos, iYpos, -20, -70, iRot);
        //        Pt2 = GetXYpoint(iXpos, iYpos, -17, -73, iRot);
        //        pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
        //        Pt1 = GetXYpoint(iXpos, iYpos, -15, -70, iRot);
        //        pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
        //        Pt2 = GetXYpoint(iXpos, iYpos, -13, -67, iRot);
        //        pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
        //        Pt1 = GetXYpoint(iXpos, iYpos, -10, -70, iRot);
        //        pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);

        //        // Draw "~"
        //        Pt1 = GetXYpoint(iXpos, iYpos, 10, -50, iRot);
        //        Pt2 = GetXYpoint(iXpos, iYpos, 13, -53, iRot);
        //        pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
        //        Pt1 = GetXYpoint(iXpos, iYpos, 15, -50, iRot);
        //        pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
        //        Pt2 = GetXYpoint(iXpos, iYpos, 17, -47, iRot);
        //        pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
        //        Pt1 = GetXYpoint(iXpos, iYpos, 20, -50, iRot);
        //        pg.DrawLine(Pt1.X, Pt1.Y, Pt2.X, Pt2.Y);
        //    }
        //    //Text
        //    pg.ForeColor = Color.Black;
        //    pg.TextAngle = 0;
        //    if (iRot == 0 || iRot == 180)
        //    {
        //        if (iRot == 0)
        //            iYposX = iYpos;
        //        else
        //            iYposX = iYpos + 120;

                
        //        pg.TextAlignment = TextAlignment.Right;
        //        if (strTxt1 != "")
        //        {
        //            Pt1 = GetXYpoint(iXpos, iYposX, -50, -80, 0);
        //            pg.DrawText(strTxt1, Pt1.X - 2.0f, Pt1.Y, 2.0f, 1.0f);
        //        }
        //        if (strTxt2 != "")
        //        {
        //            Pt1 = GetXYpoint(iXpos, iYposX, -50, -60, 0);
        //            pg.DrawText(strTxt2, Pt1.X - 2.0f, Pt1.Y, 2.0f, 1.0f);
        //        }
        //    }
        //    else
        //    {
        //        if (iRot == 90) iXposX = iXpos - 120;
        //        else iXposX = iXpos;
        //        if (iRot == 90) iYposX = iYpos-15;
        //        else iYposX = iYpos - 15;
        //        pg.TextAlignment = TextAlignment.Left;
        //        if (strTxt1 != "")
        //        {
        //            Pt1 = GetXYpoint(iXposX, iYposX, 20, -80, 0);
        //            pg.DrawText(strTxt1, Pt1.X, Pt1.Y, 2.0f, 1.0f);
        //        }
        //        if (strTxt2 != "")
        //        {
        //            Pt1 = GetXYpoint(iXposX, iYposX, 20, -60, 0);
        //            pg.DrawText(strTxt2, Pt1.X, Pt1.Y, 2.0f, 1.0f);
        //        }
        //        //if (strTxt4 != "")
        //        //{
        //        //    pg.ForeColor = Color.Red;
        //        //    Pt1 = GetXYpoint(iXposX, iYpos, 5, 5, 0);
        //        //    pg.DrawText(strTxt4, Pt1.X, Pt1.Y, 2.0f, 1.0f);
        //        //}
        //    }
        //    pg.ForeColor = Color.Black;
        //    //pfont.Dispose();

        //}

		private static void DrawFebDiscriminationDiagram(Page pg, int iXpos1, int iYpos1, int iXpos2, int iYpos2, int iRot)
		{
			//DrawFebDiagram(pg, iXpos1, iYpos1, iXpos2, iYpos2, 4, 7, (float)iRot, 0.001f, "[A]", "[s]");
			DrawFebDiagram(pg, iXpos1, iYpos1, iXpos2, iYpos2, 4, 7, (float)iRot / 1000.0f, 0.001f, "[A]", "[s]");
		}

		private static void DrawFebCurrentTimeDiagram(Page pg, int iXpos1, int iYpos1, int iXpos2, int iYpos2)
		{
			DrawFebDiagram(pg, iXpos1, iYpos1, iXpos2, iYpos2, 2, 7, 1.0f, 0.001f, "[x In]", "t [s]");
		}

		private static void DrawFebI2tDiagram(Page pg, int iXpos1, int iYpos1, int iXpos2, int iYpos2, int iRot)
		{
			float rStartValue = ((float)iRot) / 100.0f;
			DrawFebDiagram(pg, iXpos1, iYpos1, iXpos2, iYpos2, 3, 7, rStartValue, 100.0f, "Ik [kA]", "I²t [A²s]");
		}

		private static void DrawFebIIpeakDiagram(Page pg, int iXpos1, int iYpos1, int iXpos2, int iYpos2, int iRot)
		{
			float rStartValue = ((float)iRot) / 100.0f;
			DrawFebDiagram(pg, iXpos1, iYpos1, iXpos2, iYpos2, 3, 4, rStartValue, rStartValue, "Ik [kA]", "Î [kA]");
		}

		private static void DrawFebDiagram(Page pg, int iXpos1, int iYpos1, int iXpos2, int iYpos2,
									int iXcount, int iYcount, float rXstartVal, float rYstartVal, string strXtext, string strYtext)
		{
			int iCount;
			int iCountx;
			int iPos;
			float rDeltaX;
			float rDeltaY;
			float rNumber;

			//rDeltaX = Convert.ToSingle(iXpos2 - iXpos1) / 4.0f;
			//rDeltaY = Convert.ToSingle(iYpos1 - iYpos2) / 7.0f;

			rDeltaX = Convert.ToSingle(iXpos2 - iXpos1) / Convert.ToSingle(iXcount);
			rDeltaY = Convert.ToSingle(iYpos1 - iYpos2) / Convert.ToSingle(iYcount);



			pg.ForeColor = Color.LightGray;

			for (iCount = 0; iCount < iXcount; iCount++)
			{
				for (iCountx = 2; iCountx < 10; iCountx++)
				{
					iPos = iXpos1 + Convert.ToInt32(rDeltaX * (Convert.ToSingle(iCount) + Math.Log10(Convert.ToDouble(iCountx))));
					DrawFebLine(pg, iPos, iYpos1, iPos, iYpos2);
				}
			}
			for (iCount = 0; iCount < iYcount; iCount++)
			{
				for (iCountx = 2; iCountx < 10; iCountx++)
				{
					iPos = iYpos1 - Convert.ToInt32(rDeltaY * (Convert.ToSingle(iCount) + Math.Log10(Convert.ToDouble(iCountx))));
					DrawFebLine(pg, iXpos1, iPos, iXpos2, iPos);
				}
			}

			pg.ForeColor = Color.Black;

			iPos = iXpos1;
			for (iCount = 1; iCount < iXcount; iCount++)
			{
				iPos += Convert.ToInt32(rDeltaX);
				DrawFebLine(pg, iPos, iYpos1, iPos, iYpos2);
			}
			iPos = iYpos2;
			for (iCount = 1; iCount < iYcount; iCount++)
			{
				iPos += Convert.ToInt32(rDeltaY);
				DrawFebLine(pg, iXpos1, iPos, iXpos2, iPos);
			}


			pg.ForeColor = Color.Black;
			pg.TextAlignment = TextAlignment.Center;
			pg.VerticalTextAlignment = VerticalTextAlignment.Top;
			rNumber = rXstartVal;
			iPos = iXpos1;
			for (iCount = 0; iCount < iXcount; iCount++)
			{
				pg.DrawText(rNumber.ToString(1), GetInch(iPos) - 0.5f, GetInch(iYpos1 + 5), 1.0f, 1.0f);
				iPos += Convert.ToInt32(rDeltaX);
				rNumber *= 10.0f;
			}
			pg.TextAlignment = TextAlignment.Right;
			pg.DrawText(rNumber.ToString(), GetInch(iPos) - 1.0f, GetInch(iYpos1 + 5), 1.0f, 1.0f);
			pg.DrawText(strXtext, GetInch(iPos) - 1.0f, GetInch(iYpos1 + 35), 1.0f, 1.0f);

			pg.VerticalTextAlignment = VerticalTextAlignment.Middle;
			rNumber = rYstartVal;
			iPos = iYpos1;
			for (iCount = 0; iCount <= iYcount; iCount++)
			{
				if (rNumber > 1000.0f)
				{
					pg.DrawText(rNumber.ToString("0.#E-0"), GetInch(iXpos1 - 5) - 1.0f, GetInch(iPos) - 0.5f, 1.0f, 1.0f);
				}
				else
				{
					pg.DrawText(rNumber.ToString(), GetInch(iXpos1 - 5) - 1.0f, GetInch(iPos) - 0.5f, 1.0f, 1.0f);
				}
				iPos -= Convert.ToInt32(rDeltaY);
				rNumber *= 10.0f;
			}
			pg.DrawText(strYtext, GetInch(iXpos1 - 5) - 1.0f, GetInch(iYpos2 - 30) - 0.5f, 1.0f, 1.0f);

			DrawFebRect(pg, iXpos1, iYpos2, (iXpos2 - iXpos1), (iYpos1 - iYpos2));
		}

		private static void DrawFebClosedCurve(Page pg, int iXpos, int iYpos, string strTxt1, string strTxt2, string strTxt3, string strTxt4, Color cCol)
		{
			int iIndexLowMax = 0;
			int iIndexUppMax = 0;
			int iXpos1 = 0;
			int iYpos1 = 0;
			int iYpos2 = 0;
			int iIndex;
			int[] iXlow = new int[16];
			int[] iXupp = new int[16];
			int[] iYlow = new int[16];
			int[] iYupp = new int[16];

			GetCurveCoordinates(strTxt1, iXpos, 1, iXlow);
			GetCurveCoordinates(strTxt2, iYpos, -1, iYlow);
			pg.ForeColor = cCol;

			iIndex = 1;
			while (iIndex < 16 && iXlow[iIndex] >= 0)
			{
				DrawFebLine(pg, iXlow[iIndex - 1], iYlow[iIndex - 1], iXlow[iIndex], iYlow[iIndex]);
				iIndex++;
			}
			if (strTxt3 != "")
			{
				GetCurveCoordinates(strTxt3, iXpos, 1, iXupp);
				GetCurveCoordinates(strTxt4, iYpos, -1, iYupp);

				iIndexLowMax = iIndex - 1;
				iIndex = 1;
				while (iIndex < 16 && iXupp[iIndex] >= 0)
				{
					DrawFebLine(pg, iXupp[iIndex - 1], iYupp[iIndex - 1], iXupp[iIndex], iYupp[iIndex]);
					iIndex++;
				}
				iIndexUppMax = iIndex - 1;

				if (iXlow[0] >= 0)
				{
					for (iXpos1 = iXlow[0]; iXpos1 < iXupp[iIndexUppMax]; iXpos1++)
					{
						if (iXpos1 > iXlow[iIndexLowMax])
						{
							iYpos1 = iYlow[iIndexLowMax];
						}
						else
						{
							iYpos1 = FindCurveCoordinate(iXpos1, iXlow, iYlow);
						}
						if (iXpos1 < iXupp[0])
						{
							iYpos2 = iYupp[0];
						}
						else
						{
							iYpos2 = FindCurveCoordinate(iXpos1, iXupp, iYupp);
						}
						DrawFebLine(pg, iXpos1, iYpos1, iXpos1, iYpos2);
					}
				}
			}
			pg.ForeColor = Color.Black;
		}

		private static void GetCurveCoordinates(string strTxt, int iXYorigo, int iSign, int[] iVal)
		{
			int iPos;
			int iIndex;

			for (iIndex = 0; iIndex < 16; iIndex++)
			{
				iVal[iIndex] = -1;
			}
			iIndex = 0;
			iPos = strTxt.IndexOf(";");
			while (iPos > 0 && iIndex < 16)
			{
				iVal[iIndex] = iXYorigo + iSign * Convert.ToInt32(strTxt.Substring(0, iPos));
				iIndex++;
				strTxt = strTxt.Remove(0, iPos + 1);
				iPos = strTxt.IndexOf(";");
			}
		}

		private static int FindCurveCoordinate(int iXpos, int[] iXval, int[] iYval)
		{
			int iIndex = 0;
			int iYpos = 0;

			while (iXpos > iXval[iIndex] && iIndex < 16)
			{
				iIndex++;
			}
			if (iIndex == 0)
			{
				iYpos = iYval[0];
			}
			else if (iIndex > 15)
			{
				iYpos = iYval[15];
			}
			else
			{
				iYpos = iYval[iIndex - 1] + (iYval[iIndex] - iYval[iIndex - 1]) * (iXpos - iXval[iIndex - 1]) / (iXval[iIndex] - iXval[iIndex - 1]);
			}
			return iYpos;
		}

		private static PointF GetXYpoint(int iX0, int iY0, int iX1, int iY1, int iRot)
		{
			int iCosPhi;
			int iSinPhi;
			PointF Point = new PointF();
			//float mmToInch = 0.0393700787f;


			if (iRot == 270)
			{
				iCosPhi = 0;
				iSinPhi = -1;
				//             iSinPhi = 1;
			}
			else if (iRot == 180)
			{
				iCosPhi = -1;
				iSinPhi = 0;
			}
			else if (iRot == 90)
			{
				iCosPhi = 0;
				iSinPhi = 1;
				//                iSinPhi = -1;
			}
			else
			{
				iCosPhi = 1;
				iSinPhi = 0;
			}
			Point.X = GetInch(iX0 + iX1 * iCosPhi - iY1 * iSinPhi);
			Point.Y = GetInch(iY0 + iX1 * iSinPhi + iY1 * iCosPhi);
			return Point;
		}


		static int GetXpos(float rXpos, int iKolSta, float rKolFak, float rX0)
		{
			return (int)((Math.Log10(rXpos) - rX0) * rKolFak + iKolSta);
		}

		static int GetYpos(float rYpos, int iRowSta, float rRowFak, float rY0)
		{
			return (int)((Math.Log10(rYpos) - rY0) * rRowFak + iRowSta);
		}
        #endregion


        //******************************************************************
        //* Functions to get string by number
        #region GetStrings by number

        /*
        DistributionBoardKind	
         *  1	Fordeling
	        2	Avgreningspunkt
	        3	Gruppering
	        4	Koblingspunkt
        */
		public static string GetDistrBoardKind(string strNumber)
		{
			if (strNumber == "1")
				return FebPrintClassLib.Properties.Resources.IDS_LOADTYPE_1;
			else if (strNumber == "2")
				return FebPrintClassLib.Properties.Resources.IDS_LOADTYPE_2;
			else if (strNumber == "3")
				return FebPrintClassLib.Properties.Resources.IDS_LOADTYPE_3;
			else if (strNumber == "4")
				return FebPrintClassLib.Properties.Resources.IDS_LOADTYPE_4;
			else
				return "";
		}

        /*
        ProtectiveDeviceKind	
         *  -1  sjekk
         *  0	Automatsikring
	        1	Sikring
	        2	Bimetall
	        3	Effektbryter
            4   JFB
        */
		public static string GetKindOfDevice(string strNumber)
		{
			if (strNumber == "0")
				return FebPrintClassLib.Properties.Resources.IDS_AUTOMAT_TXT;
			else if (strNumber == "1")
				return FebPrintClassLib.Properties.Resources.IDS_SIKR_TXT;
			else if (strNumber == "2")
				return FebPrintClassLib.Properties.Resources.IDS_BIMET_TXT;
			else if (strNumber == "3")
				return FebPrintClassLib.Properties.Resources.IDS_EFFBR_TXT;
			else if (strNumber == "4")
				return FebPrintClassLib.Properties.Resources.IDS_JFB_TXT;
			else if (strNumber == "-1")
				return FebPrintClassLib.Properties.Resources.IDS_CHECK_TXT;
			else
				return "";
		}

        /*
        Installasjonstype	
         *  0	Alders-/sykehjem
	        1	Andre næringsbygg
	        2	Barnehager/skoler
	        3	Bensinstasjoner
	        4	Bil-/mek.verksteder
	        5	Boligblokker
	        6	Bolighus
	        7	Campingplasser
	        8	Driftsbygninger
	        9	Forsamlingslokaler
	        10	Gatelysanlegg
	        11	Helsesentre
	        12	Hoteller
	        13	Hytter
	        14	Idrettsanlegg
	        15	Lakkeringsanlegg
	        16	Midlertidige anlegg
	        17	Restauranter/diskotek
	        18	Sykehus
	        19	Trebearbeidende industri
	        20	Verneverdige bygn.
	        21	Andre anlegg i Ex-omr.
	        22	Diverse
        */
		public static string GetInstallationType(string strNumber)
		{
			if (strNumber == "0")
				return FebPrintClassLib.Properties.Resources.IDS_InstallationType_0;
			else if (strNumber == "1")
				return FebPrintClassLib.Properties.Resources.IDS_InstallationType_1;
			else if (strNumber == "2")
				return FebPrintClassLib.Properties.Resources.IDS_InstallationType_2;
			else if (strNumber == "3")
				return FebPrintClassLib.Properties.Resources.IDS_InstallationType_3;
			else if (strNumber == "4")
				return FebPrintClassLib.Properties.Resources.IDS_InstallationType_4;
			else if (strNumber == "5")
				return FebPrintClassLib.Properties.Resources.IDS_InstallationType_5;
			else if (strNumber == "6")
				return FebPrintClassLib.Properties.Resources.IDS_InstallationType_6;
			else if (strNumber == "7")
				return FebPrintClassLib.Properties.Resources.IDS_InstallationType_7;
			else if (strNumber == "8")
				return FebPrintClassLib.Properties.Resources.IDS_InstallationType_8;
			else if (strNumber == "9")
				return FebPrintClassLib.Properties.Resources.IDS_InstallationType_9;
			else if (strNumber == "10")
				return FebPrintClassLib.Properties.Resources.IDS_InstallationType_10;
			else if (strNumber == "11")
				return FebPrintClassLib.Properties.Resources.IDS_InstallationType_11;
			else if (strNumber == "12")
				return FebPrintClassLib.Properties.Resources.IDS_InstallationType_12;
			else if (strNumber == "13")
				return FebPrintClassLib.Properties.Resources.IDS_InstallationType_13;
			else if (strNumber == "14")
				return FebPrintClassLib.Properties.Resources.IDS_InstallationType_14;
			else if (strNumber == "15")
				return FebPrintClassLib.Properties.Resources.IDS_InstallationType_15;
			else if (strNumber == "16")
				return FebPrintClassLib.Properties.Resources.IDS_InstallationType_16;
			else if (strNumber == "17")
				return FebPrintClassLib.Properties.Resources.IDS_InstallationType_17;
			else if (strNumber == "18")
				return FebPrintClassLib.Properties.Resources.IDS_InstallationType_18;
			else if (strNumber == "19")
				return FebPrintClassLib.Properties.Resources.IDS_InstallationType_19;
			else if (strNumber == "20")
				return FebPrintClassLib.Properties.Resources.IDS_InstallationType_20;
			else if (strNumber == "21")
				return FebPrintClassLib.Properties.Resources.IDS_InstallationType_21;
            else if (strNumber == "22")
                return FebPrintClassLib.Properties.Resources.IDS_InstallationType_22;
            return "";
		}

        /*
        InstallationDesignBasis	
         *  0	Annet
	        1	NEK 400:1998
	        2	NEK 400:2002
	        3	NEK 400:2006
        */
		public static string GetNEKRelease(string strNumber)
		{
            if (strNumber == "0")
                return "";
            else if (strNumber == "1")
                return "1998";
            else if (strNumber == "2")
                return "2002";
            else if (strNumber == "3")
                return "2006";
            else if (strNumber == "4")
                return "2010";
            else if (strNumber == "5")
                return "2014";
            else if (strNumber == "6")
                return "2018";
            else
                return "2018";
			
		}

        /*
        ProtectiveDeviceFunction	
         *  0	Kombinert vern
	        1	Kortslutningsvern – KV
	        2	Overbelastningsvern – OV

        */
		public static string GetProtectiveDeviceFunction(string strNumber)
		{
			if (strNumber == "1")
				return FebPrintClassLib.Properties.Resources.IDS_ProtectiveDeviceFunction_1;
			else if (strNumber == "2")
				return FebPrintClassLib.Properties.Resources.IDS_ProtectiveDeviceFunction_2;
			else return "";
		}

        /*
        TrippingUnitClass	
         *  0	Automat u/Jfb
	        1	Automat m/Jfb
	        2	Automat overbelastning
	        3	Termomagnetisk standard
	        4	Termomagnetisk kortslutning
	        5	Elektronisk standard
	        6	Elektronisk kortslutning
	        7	Elektronisk tidsforinket
	        8	Elektronisk motorvern
	        9	Elektronisk bimetal
	        10	Bimetall
	        11	Motorvern
	        12	NH-patroner
	        13	Diazed
	        14	Neozed
	        15	Minized
	        16	Silized
	        17	Jordfeilbeskyttelse
            18  Mykstarter
        */
		public static string GetTrippingUnitClass(string strNumber)
		{
			if (strNumber == "0")
				return FebPrintClassLib.Properties.Resources.IDS_TrippingUnitClass_0;
			else if (strNumber == "1")
				return FebPrintClassLib.Properties.Resources.IDS_TrippingUnitClass_1;
			else if (strNumber == "2")
				return FebPrintClassLib.Properties.Resources.IDS_TrippingUnitClass_2;
			else if (strNumber == "3")
				return FebPrintClassLib.Properties.Resources.IDS_TrippingUnitClass_3;
			else if (strNumber == "4")
				return FebPrintClassLib.Properties.Resources.IDS_TrippingUnitClass_4;
			else if (strNumber == "5")
				return FebPrintClassLib.Properties.Resources.IDS_TrippingUnitClass_5;
			else if (strNumber == "6")
				return FebPrintClassLib.Properties.Resources.IDS_TrippingUnitClass_6;
			else if (strNumber == "7")
				return FebPrintClassLib.Properties.Resources.IDS_TrippingUnitClass_7;
			else if (strNumber == "8")
				return FebPrintClassLib.Properties.Resources.IDS_TrippingUnitClass_8;
			else if (strNumber == "9")
				return FebPrintClassLib.Properties.Resources.IDS_TrippingUnitClass_9;
			else if (strNumber == "10")
				return FebPrintClassLib.Properties.Resources.IDS_TrippingUnitClass_10;
			else if (strNumber == "11")
				return FebPrintClassLib.Properties.Resources.IDS_TrippingUnitClass_11;
			else if (strNumber == "12")
				return FebPrintClassLib.Properties.Resources.IDS_TrippingUnitClass_12;
			else if (strNumber == "13")
				return FebPrintClassLib.Properties.Resources.IDS_TrippingUnitClass_13;
			else if (strNumber == "14")
				return FebPrintClassLib.Properties.Resources.IDS_TrippingUnitClass_14;
			else if (strNumber == "15")
				return FebPrintClassLib.Properties.Resources.IDS_TrippingUnitClass_15;
			else if (strNumber == "16")
				return FebPrintClassLib.Properties.Resources.IDS_TrippingUnitClass_16;
			else if (strNumber == "17")
				return FebPrintClassLib.Properties.Resources.IDS_TrippingUnitClass_17;
            else if (strNumber == "18")
                return FebPrintClassLib.Properties.Resources.IDS_TrippingUnitClass_18;
            else
                return "";
		}

        /*
        BreakerUnitClass	
         *  0	Automater
	        1	Effektbrytere
	        2	Motorbeskyttelse
	        3	Smeltesikringer
	        4	Jordfeilmodul
	        5	Kontaktor
        */
		public static string GetBreakerUnitClass(string strNumber)
		{
			if (strNumber == "0")
				return FebPrintClassLib.Properties.Resources.IDS_BreakerUnitClass_0;
			else if (strNumber == "1")
				return FebPrintClassLib.Properties.Resources.IDS_BreakerUnitClass_1;
			else if (strNumber == "2")
				return FebPrintClassLib.Properties.Resources.IDS_BreakerUnitClass_2;
			else if (strNumber == "3")
				return FebPrintClassLib.Properties.Resources.IDS_BreakerUnitClass_3;
			else if (strNumber == "4")
				return FebPrintClassLib.Properties.Resources.IDS_BreakerUnitClass_4;
			else if (strNumber == "5")
				return FebPrintClassLib.Properties.Resources.IDS_BreakerUnitClass_5;
			else
				return "";
		}

        public static bool CheckforVisible(XMLDataSource xMLDataSource, string fieldName)
        {
            if (xMLDataSource.Field(fieldName, false).ToString() == "0" ||
                xMLDataSource.Field(fieldName, false).ToString() == "0.0" ||
                xMLDataSource.Field(fieldName, false).ToString() == "0.00" ||
                xMLDataSource.Field(fieldName, false).ToString() == "0.000" ||
                xMLDataSource.Field(fieldName, false).ToString() == "0.0000" ||
                xMLDataSource.Field(fieldName, false).ToString() == "." ||
                xMLDataSource.Field(fieldName, false).ToString() == "" ||
                xMLDataSource.Field(fieldName, false).ToString() == "-1")
                return false;
            else
                return true;
        }

        public static string GetCableKind(string strNumber)
		{
            if (strNumber == "0")
                return "";
            else if (strNumber == "1")
                return FebText.GetRCString("IDS_CABLE_KIND_1");
            else if (strNumber == "2")
                return FebText.GetRCString("IDS_CABLE_KIND_2");
            else if (strNumber == "3")
                return FebText.GetRCString("IDS_CABLE_KIND_3");
            else if (strNumber == "4")
                return FebText.GetRCString("IDS_CABLE_KIND_4");
            else if (strNumber == "5")
                return FebText.GetRCString("IDS_CABLE_KIND_5");
            else if (strNumber == "6")
                return FebText.GetRCString("IDS_CABLE_KIND_6");
            else if (strNumber == "7")
                return FebText.GetRCString("IDS_CABLE_KIND_7");
            else if (strNumber == "8")
                return FebText.GetRCString("IDS_CABLE_KIND_8"); 
            else if (strNumber == "9")
                return FebText.GetRCString("IDS_CABLE_KIND_9");
            else if (strNumber == "10")
                return FebText.GetRCString("IDS_CABLE_KIND_10");
            else if (strNumber == "11")
                return FebText.GetRCString("IDS_CABLE_KIND_11");
            else if (strNumber == "12")
                return FebText.GetRCString("IDS_CABLE_KIND_12");
            else if (strNumber == "13")
                return FebText.GetRCString("IDS_CABLE_KIND_13");
            else if (strNumber == "14")
                return FebText.GetRCString("IDS_CABLE_KIND_14");
            else if (strNumber == "15")
                return FebText.GetRCString("IDS_CABLE_KIND_15");
            else
                return "";
		}

        /*
        DiscriminationCriteria	
         *  0	Tabell
	        1	Nedre strøm/tid-kurve mangler
	        2	Strømbegrensningsdata mangler
	        3	Data for gjennomsluppet energi mangler
	        4	Data for bryteenergi mangler
	        5	Data for smelteenergi mangler
	        6	Strøm/tid-kurver
	        7	I4-verdi, strøm/tid-kurven
	        8	I5-verdi, strøm/tid-kurven
	        9	Strøm/tid-kurve, utkobling 0.1s
	        10	Gjennomsluppet strøm
	        11	Gjennomsluppet energi
	        12	Bryteevne
	        13	Kurvebetraktninger tillates ikke !
	        14	Identiske vern !
	        15	Ukjent
        */
		public static string GetDiscriminationCriteria(string strNumber)
		{
			if (strNumber == "0")
				return FebPrintClassLib.Properties.Resources.IDS_DiscriminationCriteria_0;
			else if (strNumber == "1")
				return FebPrintClassLib.Properties.Resources.IDS_DiscriminationCriteria_1;
			else if (strNumber == "2")
				return FebPrintClassLib.Properties.Resources.IDS_DiscriminationCriteria_2;
			else if (strNumber == "3")
				return FebPrintClassLib.Properties.Resources.IDS_DiscriminationCriteria_3;
			else if (strNumber == "4")
				return FebPrintClassLib.Properties.Resources.IDS_DiscriminationCriteria_4;
			else if (strNumber == "5")
				return FebPrintClassLib.Properties.Resources.IDS_DiscriminationCriteria_5;
			else if (strNumber == "6")
				return FebPrintClassLib.Properties.Resources.IDS_DiscriminationCriteria_6;
			else if (strNumber == "7")
				return FebPrintClassLib.Properties.Resources.IDS_DiscriminationCriteria_7;
			else if (strNumber == "8")
				return FebPrintClassLib.Properties.Resources.IDS_DiscriminationCriteria_8;
			else if (strNumber == "9")
				return FebPrintClassLib.Properties.Resources.IDS_DiscriminationCriteria_9;
			else if (strNumber == "10")
				return FebPrintClassLib.Properties.Resources.IDS_DiscriminationCriteria_10;
			else if (strNumber == "11")
				return FebPrintClassLib.Properties.Resources.IDS_DiscriminationCriteria_11;
			else if (strNumber == "12")
				return FebPrintClassLib.Properties.Resources.IDS_DiscriminationCriteria_12;
			else if (strNumber == "13")
				return FebPrintClassLib.Properties.Resources.IDS_DiscriminationCriteria_13;
			else if (strNumber == "14")
				return FebPrintClassLib.Properties.Resources.IDS_DiscriminationCriteria_14;
			else if (strNumber == "15")
				return FebPrintClassLib.Properties.Resources.IDS_DiscriminationCriteria_15;
			else
				return "";

		}

        /*
        CircuitOtherComponentType	
         *  0	Ingen komponent
	        1	Lastskillebryter
	        2	Lastbryter
	        3	Skillebryter
	        4	Kontaktor
	        5	Måler
	        6	Overspenningsvern
	        7	Ringetransformator
        */
		public static string GetCircuitOtherComponentType(string strNumber)
		{
			if (strNumber == "1")
				return FebPrintClassLib.Properties.Resources.IDS_CircuitOtherComponentType_1;
			else if (strNumber == "2")
				return FebPrintClassLib.Properties.Resources.IDS_CircuitOtherComponentType_2;
			else if (strNumber == "3")
				return FebPrintClassLib.Properties.Resources.IDS_CircuitOtherComponentType_3;
			else if (strNumber == "4")
				return FebPrintClassLib.Properties.Resources.IDS_CircuitOtherComponentType_4;
			else if (strNumber == "5")
				return FebPrintClassLib.Properties.Resources.IDS_CircuitOtherComponentType_5;
			else if (strNumber == "6")
				return FebPrintClassLib.Properties.Resources.IDS_CircuitOtherComponentType_6;
			else if (strNumber == "7")
				return FebPrintClassLib.Properties.Resources.IDS_CircuitOtherComponentType_7;
			else
				return "";
		}


        /*
        CircuitResidualDeviceType	
         *  0	Ingen
	        1	RCD - Jordfeilbryter
	        2	RCM – Jordfeilvarsler
	        3	ProtectiveDevice - Vern
        */
		public static string GetCircuitResidualDeviceType(string strNumber)
		{
			if (strNumber == "1")
				return FebPrintClassLib.Properties.Resources.IDS_CircuitResidualDeviceType_1;
			else if (strNumber == "2")
				return FebPrintClassLib.Properties.Resources.IDS_CircuitResidualDeviceType_2;
			else if (strNumber == "3")
				return FebPrintClassLib.Properties.Resources.IDS_CircuitResidualDeviceType_3;
			else
				return "";
		}

        /*
        CircuitEqipotentialBonding	
         * -1	Bruk tag’en CircuitEqipotentialBondingText
            0	
            1	Jordelektrode
            2	Utjevningsforbindelse
            3	Jordelektrode; Utjevningsforbindelse
        */
		public static string GetCircuitEquipotentialBonding(string strNumber)
		{
			if (strNumber == "1")
				return FebPrintClassLib.Properties.Resources.IDS_CircuitEquipotentialBonding_1;
			else if (strNumber == "2")
				return FebPrintClassLib.Properties.Resources.IDS_CircuitEquipotentialBonding_2;
			else if (strNumber == "3")
				return FebPrintClassLib.Properties.Resources.IDS_CircuitEquipotentialBonding_3;
			else
				return "";

		}

		public static string GetEqiPotBound(string strNumber)
		{
			if (strNumber == "1")
				return FebPrintClassLib.Properties.Resources.IDS_EquipotentialBonding;
			else
				return "";

		}


        /*
        KindOfEarthElectrode	
         *  0	Ingen
	        1	Spyd
	        2	Bånd/tråd
	        3	Plate
	        4	Fundament
	        5	Armering i betong
	        6	Bånd/tråd + fundament
	        7	Bånd/tråd + spyd
	        8	Bånd/tråd + armering
	        9	Bånd/tråd + plate
	        10	Fundament + plate
         *  11  Fundament + Armering
         *  12  Spyd + Plate
         *  13  Spyd + Armering
        */
		public static string GetKindOfEarthTxt(string strNumber)
		{
			if (strNumber == "1")
				return FebPrintClassLib.Properties.Resources.IDS_KINDOF_EARTHELEKTRODE_1;
			else if (strNumber == "2")
				return FebPrintClassLib.Properties.Resources.IDS_KINDOF_EARTHELEKTRODE_2;
			else if (strNumber == "3")
				return FebPrintClassLib.Properties.Resources.IDS_KINDOF_EARTHELEKTRODE_3;
			else if (strNumber == "4")
				return FebPrintClassLib.Properties.Resources.IDS_KINDOF_EARTHELEKTRODE_4;
			else if (strNumber == "5")
				return FebPrintClassLib.Properties.Resources.IDS_KINDOF_EARTHELEKTRODE_5;
			else if (strNumber == "6")
				return FebPrintClassLib.Properties.Resources.IDS_KINDOF_EARTHELEKTRODE_6;
			else if (strNumber == "7")
				return FebPrintClassLib.Properties.Resources.IDS_KINDOF_EARTHELEKTRODE_7;
			else if (strNumber == "8")
				return FebPrintClassLib.Properties.Resources.IDS_KINDOF_EARTHELEKTRODE_8;
			else if (strNumber == "9")
				return FebPrintClassLib.Properties.Resources.IDS_KINDOF_EARTHELEKTRODE_9;
			else if (strNumber == "10")
				return FebPrintClassLib.Properties.Resources.IDS_KINDOF_EARTHELEKTRODE_10;
			else if (strNumber == "11")
				return FebPrintClassLib.Properties.Resources.IDS_KINDOF_EARTHELEKTRODE_11;
			else if (strNumber == "12")
				return FebPrintClassLib.Properties.Resources.IDS_KINDOF_EARTHELEKTRODE_12;
			else if (strNumber == "13")
				return FebPrintClassLib.Properties.Resources.IDS_KINDOF_EARTHELEKTRODE_13;
			else
				return "";
		}


        /*
        NameCode
        NameCode ProtectiveDevice
        NameCodeHeading1
        NameCodeHeading2	
         *  0	Kabel
	        1	Kabel primær
	        2	Kabel sekundær
	        3	Matekabel
            4	Avgreningskabel
            5	Kabel inngang
            6	Kabel inngang primær
            7	Kabel inngang sekundær
            8	Kabel switch
            9	Kabel switch primær
            10	Kabel switch sekundær
            11	Kabel utgang
            12	Kabel utgang primær
            13	Kabel utgang sekundær
            14	Skinne
            15	Skinne primær
            16	Skinne sekundær
            17	Mateskinne
            18	Avgreningsskinne
            19	Skinne inngang
            20	Skinne inngang primær
            21	Skinne inngang sekundær
            22	Skinne switch
            23	Skinne switch primær
            24	Skinne switch sekundær
            25	Skinne utgang
            26	Skinne utgang primær
            27	Skinne utgang sekundær
            28	Kombinert vern
            29	Kortslutningsvern
            30	Overbelastningsvern
            31	Vern inngang
            32	Vern switch
            33	Vern utgang
            34	Matevern
            35	Avgreningsvern
            36	Transformator
            37	Reservevern
         *  38  Transformator inngang
         *  39  Transformator utgang
         *  40  Transformator switch
         *  41  Vern
         *  42 Upstream protective device
         *  43 Upstream short-circuit protective device
         *  44 Upstream overload protective device
        */
		public static string GetNameCodeTxt(string strNumber)
		{
			if (strNumber == "0")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_0;
			else if (strNumber == "1")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_1;
			else if (strNumber == "2")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_2;
			else if (strNumber == "3")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_3;
			else if (strNumber == "4")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_4;
			else if (strNumber == "5")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_5;
			else if (strNumber == "6")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_6;
			else if (strNumber == "7")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_7;
			else if (strNumber == "8")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_8;
			else if (strNumber == "9")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_9;
			else if (strNumber == "10")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_10;
			else if (strNumber == "11")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_11;
			else if (strNumber == "12")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_12;
			else if (strNumber == "13")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_13;
			else if (strNumber == "14")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_14;
			else if (strNumber == "15")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_15;
			else if (strNumber == "16")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_16;
			else if (strNumber == "17")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_17;
			else if (strNumber == "18")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_18;
			else if (strNumber == "19")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_19;
			else if (strNumber == "20")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_20;
			else if (strNumber == "21")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_21;
			else if (strNumber == "22")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_22;
			else if (strNumber == "23")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_23;
			else if (strNumber == "24")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_24;
			else if (strNumber == "25")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_25;
			else if (strNumber == "26")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_26;
			else if (strNumber == "27")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_27;
			else if (strNumber == "28")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_28;
			else if (strNumber == "29")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_29;
			else if (strNumber == "30")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_30;
			else if (strNumber == "31")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_31;
			else if (strNumber == "32")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_32;
			else if (strNumber == "33")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_33;
			else if (strNumber == "34")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_34;
			else if (strNumber == "35")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_35;
			else if (strNumber == "36")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_36;
			else if (strNumber == "37")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_37;
			else if (strNumber == "38")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_38;
			else if (strNumber == "39")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_39;
			else if (strNumber == "40")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_40;
			else if (strNumber == "41")
				return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_41;
            else if (strNumber == "42")
                return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_42;
            else if (strNumber == "43")
                return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_43;
            else if (strNumber == "44")
                return FebPrintClassLib.Properties.Resources.IDS_NAMECODE_44;
            else
                return "";

		}

        /*
        CircuitLoadType	
         * -1	Ingen utskrift
	        0	Reservekurs
	        1	Fordeling
	        2	Avgreningspunkt
	        3	Gruppering
	        4	Koblingspunkt
	        5	Motor
	        6	Variabel last
	        7	Fast last
	        8	Styrestrøm
	        9	Distribuert last
            10  Ring kurs
        */
        //CircLoad
		public static string GetCircLoadType(string strNumber)
		{
			//CircLoad
			if (strNumber == "0")
				return FebText.GetRCString("IDS_LASTTYPE_0");//FebPrintClassLib.Properties.Resources.IDS_LOADTYPE_0;
			else if (strNumber == "1")
				return FebText.GetRCString("IDS_LASTTYPE_1");//FebPrintClassLib.Properties.Resources.IDS_LOADTYPE_1;
			else if (strNumber == "2")
				return FebText.GetRCString("IDS_LASTTYPE_2");//FebPrintClassLib.Properties.Resources.IDS_LOADTYPE_2;
			else if (strNumber == "3")
				return FebText.GetRCString("IDS_LASTTYPE_3");//FebPrintClassLib.Properties.Resources.IDS_LOADTYPE_3;
			else if (strNumber == "4")
				return FebText.GetRCString("IDS_LASTTYPE_4");//FebPrintClassLib.Properties.Resources.IDS_LOADTYPE_4;
			else if (strNumber == "5")
				return FebText.GetRCString("IDS_LASTTYPE_5");//FebPrintClassLib.Properties.Resources.IDS_LOADTYPE_5;
			else if (strNumber == "6")
				return FebText.GetRCString("IDS_LASTTYPE_6");//FebPrintClassLib.Properties.Resources.IDS_LOADTYPE_6;
			else if (strNumber == "7")
				return FebText.GetRCString("IDS_LASTTYPE_7");//FebPrintClassLib.Properties.Resources.IDS_LOADTYPE_7;
			else if (strNumber == "8")
				return FebText.GetRCString("IDS_LASTTYPE_8");//FebPrintClassLib.Properties.Resources.IDS_LOADTYPE_8;
			else if (strNumber == "9")
				return FebText.GetRCString("IDS_LASTTYPE_9");//FebPrintClassLib.Properties.Resources.IDS_LOADTYPE_9;
			else if (strNumber == "10")
				return FebText.GetRCString("IDS_LASTTYPE_10");//FebPrintClassLib.Properties.Resources.IDS_LOADTYPE_10;
			else if (strNumber == "11")
				return FebText.GetRCString("IDS_LASTTYPE_11");
			else if (strNumber == "12")
				return FebText.GetRCString("IDS_LASTTYPE_12");
			else
				return "";

		}


        /*
        FaultCurrentCode	
         *  0	Ik3p max
	        1	Ik3p max ende
	        2	Ik3p min
	        3	Ik2p max
	        4	Ik2p max ende
	        5	Ik2p min
	        6	Ik1p max
	        7	Ik1p max ende
	        8	Ik1p min
	        9	Ij max
	        10	Ij max ende
	        11	Ij min
	        12	UPS
        */
        //FaultCurrentCode
		public static string GetFaultCodeTxt(string strNumber)
		{
			if (strNumber == "0")
				return FebPrintClassLib.Properties.Resources.IDS_FaultCurrentCode_0;
			else if (strNumber == "1")
				return FebPrintClassLib.Properties.Resources.IDS_FaultCurrentCode_1;
			else if (strNumber == "2")
				return FebPrintClassLib.Properties.Resources.IDS_FaultCurrentCode_2;
			else if (strNumber == "3")
				return FebPrintClassLib.Properties.Resources.IDS_FaultCurrentCode_3;
			else if (strNumber == "4")
				return FebPrintClassLib.Properties.Resources.IDS_FaultCurrentCode_4;
			else if (strNumber == "5")
				return FebPrintClassLib.Properties.Resources.IDS_FaultCurrentCode_5;
			else if (strNumber == "6")
				return FebPrintClassLib.Properties.Resources.IDS_FaultCurrentCode_6;
			else if (strNumber == "7")
				return FebPrintClassLib.Properties.Resources.IDS_FaultCurrentCode_7;
			else if (strNumber == "8")
				return FebPrintClassLib.Properties.Resources.IDS_FaultCurrentCode_8;
			else if (strNumber == "9")
				return FebPrintClassLib.Properties.Resources.IDS_FaultCurrentCode_9;
			else if (strNumber == "10")
				return FebPrintClassLib.Properties.Resources.IDS_FaultCurrentCode_10;
			else if (strNumber == "11")
				return FebPrintClassLib.Properties.Resources.IDS_FaultCurrentCode_11;
			else if (strNumber == "12")
				return FebPrintClassLib.Properties.Resources.IDS_FaultCurrentCode_12;
			else
				return "";
		}

   

        #endregion
        //* End region for Get strings by number
    }
}
