﻿using System;
using System.Globalization;
using System.Windows.Forms;
using GrapeCity.ActiveReports.Data;


namespace FebPrintClassLib.Rpt6
{
    /// <summary>
    /// Summary description for Rpt06_CircLoad.
    /// </summary>
	public partial class Rpt06_CircLoad1 : GrapeCity.ActiveReports.SectionReport
	{
		//CommonItems clItems = null;

		public Rpt06_CircLoad1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

            Document.CacheToDisk = true;
            Document.CacheToDiskLocation = System.IO.Path.GetTempPath();

        }

        private void detail_Format(object sender, EventArgs e)
		{
			string strL1 = "";
			string strL2 = "";
			string strL3 = "";
			string strN = "";



			if (((XMLDataSource)this.DataSource).Field("CircuitLoadType", false).ToString() == "0")
				txtOV.Visible = true;
			else
				txtOV.Visible = false;


			//CircLoad
			txtCircLoadType.Text = CommonItems.GetCircLoadType(((XMLDataSource)this.DataSource).Field("CircuitLoadType", false).ToString());

			//txtKindOfEarth
			txtKindOfEarth.Text = CommonItems.GetKindOfEarthTxt(((XMLDataSource)this.DataSource).Field("../KindOfEarthElectrode", false).ToString());

			//txtEqiBound
			txtEqiBound.Text = CommonItems.GetEqiPotBound(((XMLDataSource)this.DataSource).Field("../EquipotentialBonding", false).ToString());

			if (((XMLDataSource)this.DataSource).Field("../KindOfEarthElectrode", false).ToString() == "0" &&
				((XMLDataSource)this.DataSource).Field("../EquipotentialBonding", false).ToString() == "1")
			{
				txtJordelektrod.Visible = true;
				txtJordelektrod.Text = txtEqiBound.Text;
				txtEqiBound.Visible = false;
				txtCol1.Visible = false;
			}
			else if (((XMLDataSource)this.DataSource).Field("../KindOfEarthElectrode", false).ToString() == "0" &&
					 ((XMLDataSource)this.DataSource).Field("../EquipotentialBonding", false).ToString() == "0")
			{
				txtEqiBound.Visible = false;
				txtJordelektrod.Visible = false;
				txtCol1.Visible = false;
			}
			else
			{
				txtEqiBound.Visible = true;
				txtJordelektrod.Visible = true;
				txtJordelektrod.Text = FebPrintClassLib.Properties.Resources.IDS_Jordelektrode;
			}

            //if (FebUtil.Operations.FebLicenseInfo.DesignBasisUK)
			if (System.Threading.Thread.CurrentThread.CurrentUICulture.Name == "en-GB")
			{
				//Zfor
				if (((XMLDataSource)this.DataSource).Field("Zfor", false).ToString() == "." ||
					((XMLDataSource)this.DataSource).Field("Zfor", false).ToString() == "-1")
				{
					txtZfor.Text = "";
					rtfZfor.Visible = false;
				}
				else
				{
					rtfZfor.Visible = true;
					if (this.rtfZfor.Find("Zs") != -1)
					{
						this.rtfZfor.SelectionStart = this.rtfZfor.Find("s");
						this.rtfZfor.SelectionLength = 1;
						this.rtfZfor.SelectionCharOffset = -.03f;

						txtZfor.Text = String.Format("{0:#0.0000} [Ω]",
							Convert.ToDouble(((XMLDataSource)this.DataSource).Field("Zfor", false), CultureInfo.InvariantCulture));
					}
				}
			}
			else if (System.Threading.Thread.CurrentThread.CurrentUICulture.Name == "fi-FI")
            {
                if (((XMLDataSource)this.DataSource).Field("Zfor", false).ToString() == "." ||
                    ((XMLDataSource)this.DataSource).Field("Zfor", false).ToString() == "-1")
                {
                    txtZfor.Text = "";
                    rtfZfor.Visible = false;
                }
                else
                {
                    rtfZfor.Visible = true;
                    if (this.rtfZfor.Find("Zs") != -1)
                    {
                        this.rtfZfor.SelectionStart = this.rtfZfor.Find("s");
                        this.rtfZfor.SelectionLength = 1;
                        this.rtfZfor.SelectionCharOffset = -.03f;

                        txtZfor.Text = String.Format("{0:#0.0000} [Ω]",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("Zfor", false), CultureInfo.InvariantCulture));
                    }
                }

            }
            else
            {
				//Zfor
				if (((XMLDataSource)this.DataSource).Field("Zfor", false).ToString() == "." ||
					((XMLDataSource)this.DataSource).Field("Zfor", false).ToString() == "-1")
				{
					txtZfor.Text = "";
					rtfZfor.Visible = false;
				}
				else
				{
					rtfZfor.Visible = true;
					if (this.rtfZfor.Find("för") != -1)
					{
						this.rtfZfor.SelectionStart = this.rtfZfor.Find("för");
						this.rtfZfor.SelectionLength = 3;
						this.rtfZfor.SelectionCharOffset = -.03f;

						txtZfor.Text = String.Format("{0:#0.0000} [Ω]",
							Convert.ToDouble(((XMLDataSource)this.DataSource).Field("Zfor", false), CultureInfo.InvariantCulture));
					}
				}
			}

			//rtfDistTemp
			if (((XMLDataSource)this.DataSource).Field("DistributionBoardTemperature", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("DistributionBoardTemperature", false).ToString() == "-1")
				rtfDistTemp.Text = "";
			else
				rtfDistTemp.ReplaceField("DistributionBoardTemperature",
					((XMLDataSource)this.DataSource).Field("DistributionBoardTemperature", false).ToString());


			//txtFeedingCircuitId
			if (((XMLDataSource)this.DataSource).Field("IncomingFeederCircuitId", false).ToString() == ".")
				txtFeedingCircuitId.Text = "";
			else
				txtFeedingCircuitId.Text = ((XMLDataSource)this.DataSource).Field("IncomingFeederCircuitId", false).ToString();


			//LoadDescription
			if (((XMLDataSource)this.DataSource).Field("LoadDescription", false).ToString() == ".")
				txtLoadDesc.Text = "";

			try
			{
				//LoadNominalVoltage
				if (((XMLDataSource)this.DataSource).Field("LoadNominalVoltage", false).ToString() == "." ||
					((XMLDataSource)this.DataSource).Field("LoadNominalVoltage", false).ToString() == "-1")
					txtNomVolt.Text = "";
				else
					txtNomVolt.Text = String.Format("{0} V",
						Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LoadNominalVoltage", false), CultureInfo.InvariantCulture));
				//LoadRatedCurrent
				if (((XMLDataSource)this.DataSource).Field("LoadRatedCurrent", false).ToString() == "." ||
					((XMLDataSource)this.DataSource).Field("LoadRatedCurrent", false).ToString() == "-1")
					txtLoadratedCurrent.Text = "";
				else
					txtLoadratedCurrent.Text = String.Format("{0:#0.0} A",
						Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LoadRatedCurrent", false), CultureInfo.InvariantCulture));
				//LoadPowerFactor
				if (((XMLDataSource)this.DataSource).Field("LoadPowerFactor", false).ToString() == "." ||
					((XMLDataSource)this.DataSource).Field("LoadPowerFactor", false).ToString() == "-1")
					txtCosPhi.Text = "";
				//LoadRatedPower
				if (((XMLDataSource)this.DataSource).Field("LoadRatedPower", false).ToString() == "." ||
					((XMLDataSource)this.DataSource).Field("LoadRatedPower", false).ToString() == "-1")
					txtPowerPn.Text = "";
				else
					txtPowerPn.Text = String.Format("{0:#0.0} kW",
						Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LoadRatedPower", false), CultureInfo.InvariantCulture));
				//LoadRatedTotalPower
				if (((XMLDataSource)this.DataSource).Field("LoadRatedTotalPower", false).ToString() == "." ||
					((XMLDataSource)this.DataSource).Field("LoadRatedTotalPower", false).ToString() == "-1")
					txtLoadSn.Text = "";
				else
					txtLoadSn.Text = String.Format("{0:#0.0} kVA",
						Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LoadRatedTotalPower", false), CultureInfo.InvariantCulture));
				//txtSammenCurrent L1
				if (((XMLDataSource)this.DataSource).Field("SumLoadCurrentL1", false).ToString() == "." ||
					((XMLDataSource)this.DataSource).Field("SumLoadCurrentL1", false).ToString() == "-1")
					strL1 = "";
				else
					strL1 = String.Format("L1: {0:#0.0} A\t", Convert.ToDouble(((XMLDataSource)this.DataSource).Field("SumLoadCurrentL1", false), CultureInfo.InvariantCulture));
				//txtSammenCurrent L2
				if (((XMLDataSource)this.DataSource).Field("SumLoadCurrentL2", false).ToString() == "." ||
					((XMLDataSource)this.DataSource).Field("SumLoadCurrentL2", false).ToString() == "-1")
					strL2 = "";
				else
					strL2 = String.Format("L2: {0:#0.0} A\t", Convert.ToDouble(((XMLDataSource)this.DataSource).Field("SumLoadCurrentL2", false), CultureInfo.InvariantCulture));
				//txtSammenCurrent L3
				if (((XMLDataSource)this.DataSource).Field("SumLoadCurrentL3", false).ToString() == "." ||
					((XMLDataSource)this.DataSource).Field("SumLoadCurrentL3", false).ToString() == "-1")
					strL3 = "";
				else
					strL3 = String.Format("L3: {0:#0.0} A\t", Convert.ToDouble(((XMLDataSource)this.DataSource).Field("SumLoadCurrentL3", false), CultureInfo.InvariantCulture));
				//txtSammenCurrent N
				if (((XMLDataSource)this.DataSource).Field("SumLoadCurrentN", false).ToString() == "." ||
					((XMLDataSource)this.DataSource).Field("SumLoadCurrentN", false).ToString() == "-1")
					strN = "";
				else
					strN = String.Format("N: {0:#0.0} A", Convert.ToDouble(((XMLDataSource)this.DataSource).Field("SumLoadCurrentN", false), CultureInfo.InvariantCulture));
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message, "CircLoad1");
			}
			txtSammenCurrent.Text = strL1 + strL2 + strL3 + strN;

			//txtOV
			if (((XMLDataSource)this.DataSource).Field("CircuitLoadType", false).ToString() == "2")
			{
				txtOV.Visible = true;
				txtSumOv.Visible = true;
			}
			else
			{
				txtOV.Visible = false;
				txtSumOv.Visible = false;
			}

			//txtSumOv L1
			if (((XMLDataSource)this.DataSource).Field("SumRatedCurrentOverloadProtectiveDeviceL1", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("SumRatedCurrentOverloadProtectiveDeviceL1", false).ToString() == "-1")
				strL1 = "";
			else
				strL1 = String.Format("L1: {0:#0.0} A\t", Convert.ToDouble(((XMLDataSource)this.DataSource).Field("SumRatedCurrentOverloadProtectiveDeviceL1", false), CultureInfo.InvariantCulture));
			//txtSumOv L2
			if (((XMLDataSource)this.DataSource).Field("SumRatedCurrentOverloadProtectiveDeviceL2", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("SumRatedCurrentOverloadProtectiveDeviceL2", false).ToString() == "-1")
				strL2 = "";
			else
				strL2 = String.Format("L2: {0:#0.0} A\t", Convert.ToDouble(((XMLDataSource)this.DataSource).Field("SumRatedCurrentOverloadProtectiveDeviceL2", false), CultureInfo.InvariantCulture));
			//txtSumOv L3
			if (((XMLDataSource)this.DataSource).Field("SumRatedCurrentOverloadProtectiveDeviceL3", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("SumRatedCurrentOverloadProtectiveDeviceL3", false).ToString() == "-1")
				strL3 = "";
			else
				strL3 = String.Format("L3: {0:#0.0} A", Convert.ToDouble(((XMLDataSource)this.DataSource).Field("SumRatedCurrentOverloadProtectiveDeviceL3", false), CultureInfo.InvariantCulture));

			txtSumOv.Text = strL1 + strL2 + strL3;

			if (((XMLDataSource)this.DataSource).Field("DownstreamLosses", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("DownstreamLosses", false).ToString() == "-1")
				txtDownTap.Text = "";
			else
				txtDownTap.Text = String.Format("{0:#0.0} [kW]", Convert.ToDouble(((XMLDataSource)this.DataSource).Field("DownstreamLosses", false), CultureInfo.InvariantCulture));


			//DistributionBoardType
			if (((XMLDataSource)this.DataSource).Field("DistributionBoardType", false).ToString() == ".")
				txtDistrType.Text = "";

			//LoadNumberOfConductors
			//if (((XMLDataSource)this.DataSource).Field("LoadNumberOfConductors", false).ToString() == "." ||
			//    ((XMLDataSource)this.DataSource).Field("LoadNumberOfConductors", false).ToString() == "-1")
			//    txtFaserValue.Text = "";

			if (((XMLDataSource)this.DataSource).Field("CircuitLoadType", false).ToString() == "8")
			{
				txtFaser.Text = FebPrintClassLib.Properties.Resources.IDS_FASERTXT_1;
				txtFaserValue.Text = ((XMLDataSource)this.DataSource).Field("LoadNumberOfConductors", false).ToString();
			}
			else
			{
				txtFaser.Text = FebPrintClassLib.Properties.Resources.IDS_FASERTXT_2;
				txtFaserValue.Text = ((XMLDataSource)this.DataSource).Field("NumberOfLiveConductors", false).ToString();
			}

			//LiveConductorArrangement
			if (((XMLDataSource)this.DataSource).Field("LiveConductorArrangement", false).ToString() == "." ||
			  ((XMLDataSource)this.DataSource).Field("LiveConductorArrangement", false).ToString() == "-1")
				txtLiveCondArr.Text = "";

			shape1.Height = detail.Height + CmToInch(0.2f);
		}
	}
}
