﻿using System;
using System.Globalization;
using GrapeCity.ActiveReports.Data;


namespace FebPrintClassLib.Rpt6
{
    /// <summary>
    /// Summary description for Rpt06_CircLoad3.
    /// </summary>
	public partial class Rpt06_CircLoad3 : GrapeCity.ActiveReports.SectionReport
	{
		//CommonItems clItems = null;
		public Rpt06_CircLoad3()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

            Document.CacheToDisk = true;
            Document.CacheToDiskLocation = System.IO.Path.GetTempPath();

        }

        private void detail_Format(object sender, EventArgs e)
		{

			//CircLoad
			txtCircLoadType.Text = CommonItems.GetCircLoadType(((XMLDataSource)this.DataSource).Field("CircuitLoadType", false).ToString());

			//txtKindOfEarth
			txtKindOfEarth.Text = CommonItems.GetKindOfEarthTxt(((XMLDataSource)this.DataSource).Field("../KindOfEarthElectrode", false).ToString());
			//txtEqiBound

			txtEqiBound.Text = CommonItems.GetEqiPotBound(((XMLDataSource)this.DataSource).Field("../EquipotentialBonding", false).ToString());


			if (System.Threading.Thread.CurrentThread.CurrentUICulture.Name == "en-GB")
			{
				//Zfor
				if (((XMLDataSource)this.DataSource).Field("Zfor", false).ToString() == "." ||
					((XMLDataSource)this.DataSource).Field("Zfor", false).ToString() == "-1")
				{
					txtZfor.Text = "";
					rtfZfor.Visible = false;
					txtZforSemi.Visible = false;
				}
				else
				{
					rtfZfor.Visible = true;
					if (this.rtfZfor.Find("Zs") != -1)
					{
						this.rtfZfor.SelectionStart = this.rtfZfor.Find("s");
						this.rtfZfor.SelectionLength = 1;
						this.rtfZfor.SelectionCharOffset = -.03f;

						txtZfor.Text = String.Format("{0:#0.0000} [Ω]",
							Convert.ToDouble(((XMLDataSource)this.DataSource).Field("Zfor", false), CultureInfo.InvariantCulture));
					}
				}
			}
			else if (System.Threading.Thread.CurrentThread.CurrentUICulture.Name == "fi-FI")
            {
                if (((XMLDataSource)this.DataSource).Field("Zfor", false).ToString() == "." ||
                    ((XMLDataSource)this.DataSource).Field("Zfor", false).ToString() == "-1")
                {
                    txtZfor.Text = "";
                    rtfZfor.Visible = false;
                    txtZforSemi.Visible = false;
                }
                else
                {
                    rtfZfor.Visible = true;
                    if (this.rtfZfor.Find("Zs") != -1)
                    {
                        this.rtfZfor.SelectionStart = this.rtfZfor.Find("s");
                        this.rtfZfor.SelectionLength = 1;
                        this.rtfZfor.SelectionCharOffset = -.03f;

                        txtZfor.Text = String.Format("{0:#0.0000} [Ω]",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("Zfor", false), CultureInfo.InvariantCulture));
                    }
                }
            }
            else
            {
				//Zfor
				if (((XMLDataSource)this.DataSource).Field("Zfor", false).ToString() == "." ||
					((XMLDataSource)this.DataSource).Field("Zfor", false).ToString() == "-1")
				{
					txtZfor.Text = "";
					rtfZfor.Visible = false;
					txtZforSemi.Visible = false;
				}
				else
				{
					rtfZfor.Visible = true;
					if (this.rtfZfor.Find("för") != -1)
					{
						this.rtfZfor.SelectionStart = this.rtfZfor.Find("för");
						this.rtfZfor.SelectionLength = 3;
						this.rtfZfor.SelectionCharOffset = -.03f;

						txtZfor.Text = String.Format("{0:#0.0000} [Ω]",
							Convert.ToDouble(((XMLDataSource)this.DataSource).Field("Zfor", false), CultureInfo.InvariantCulture));
					}
				}
			}





			//txtEqiBound
			if (((XMLDataSource)this.DataSource).Field("../KindOfEarthElectrode", false).ToString() == "0" &&
				((XMLDataSource)this.DataSource).Field("../EquipotentialBonding", false).ToString() == "1")
			{
				txtJordelektrod.Visible = true;
				txtJordelektrod.Text = txtEqiBound.Text;
				txtEqiBound.Visible = false;
				txtCol0.Visible = false;
			}
			else if (((XMLDataSource)this.DataSource).Field("../KindOfEarthElectrode", false).ToString() == "0" &&
					 ((XMLDataSource)this.DataSource).Field("../EquipotentialBonding", false).ToString() == "0")
			{
				txtJordelektrod.Visible = false;
				txtCol0.Visible = false;
				txtEqiBound.Visible = false;
			}
			else
			{
				txtJordelektrod.Visible = true;
				txtEqiBound.Visible = true;
				txtJordelektrod.Text = FebPrintClassLib.Properties.Resources.IDS_Jordelektrode;
			}

			//LoadDescription
			if (((XMLDataSource)this.DataSource).Field("LoadDescription", false).ToString() == ".")
				txtLoadDesc.Text = "";
			//LoadNominalVoltage
			if (((XMLDataSource)this.DataSource).Field("LoadNominalVoltage", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("LoadNominalVoltage", false).ToString() == "-1")
				txtNomVolt.Text = "";
			else
				txtNomVolt.Text = String.Format("{0} V",
					Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LoadNominalVoltage", false), CultureInfo.InvariantCulture));
			//LoadRatedCurrent
			if (((XMLDataSource)this.DataSource).Field("LoadRatedCurrent", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("LoadRatedCurrent", false).ToString() == "-1")
				txtLoadratedCurrent.Text = "";
			else
				txtLoadratedCurrent.Text = String.Format("{0:#0.00} A",
					Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LoadRatedCurrent", false), CultureInfo.InvariantCulture));
			//LoadPowerFactor
			if (((XMLDataSource)this.DataSource).Field("LoadPowerFactor", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("LoadPowerFactor", false).ToString() == "-1")
				txtCosPhi.Text = "";
			//LoadRatedPower
			if (((XMLDataSource)this.DataSource).Field("LoadRatedPower", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("LoadRatedPower", false).ToString() == "-1")
				txtPowerPn.Text = "";
			else
				txtPowerPn.Text = String.Format("{0:#0.0} kW",
					Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LoadRatedPower", false), CultureInfo.InvariantCulture));
			//LoadRatedTotalPower
			if (((XMLDataSource)this.DataSource).Field("LoadRatedTotalPower", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("LoadRatedTotalPower", false).ToString() == "-1")
				txtLoadSn.Text = "";
			else
				txtLoadSn.Text = String.Format("{0:#0.0} kVA",
					Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LoadRatedTotalPower", false), CultureInfo.InvariantCulture));
			//LiveConductorArrangement
			if (((XMLDataSource)this.DataSource).Field("LiveConductorArrangement", false).ToString() == "." ||
			  ((XMLDataSource)this.DataSource).Field("LiveConductorArrangement", false).ToString() == "-1")
				txtLiveCondArr.Text = "";

			//txtStartTidtxt
			if (((XMLDataSource)this.DataSource).Field("MotorTeTime", false).ToString() == "-1")
				txtStartTidtxt.Text = FebPrintClassLib.Properties.Resources.IDS_STARTTIDTXT_1;
			else
				txtStartTidtxt.Text = FebPrintClassLib.Properties.Resources.IDS_STARTTIDTXT_2;
			//txtStartTidVal
			if (((XMLDataSource)this.DataSource).Field("CircuitLoadType", false).ToString() == "5")
			{
				txtVirkgrad.Visible = true;
				txtCol1.Visible = true;
				txtCol5.Visible = true;
				txtStartCur.Visible = true;
				//txtMotorRatedEff.Text = "";
				//txtMotorStartCurrent.Text = "";

				textBox19.Visible = true;
				if (((XMLDataSource)this.DataSource).Field("MotorTeTime", false).ToString() == "-1")
					txtStartTidVal.Text = String.Format("{0:#0.00} s", Convert.ToDouble(((XMLDataSource)this.DataSource).Field("MotorStartingTime", false), CultureInfo.InvariantCulture));
				else
					txtStartTidVal.Text = String.Format("{0:#0.00} s / {1:#0.00} s", Convert.ToDouble(((XMLDataSource)this.DataSource).Field("MotorStartingTime", false), CultureInfo.InvariantCulture),
						Convert.ToDouble(((XMLDataSource)this.DataSource).Field("MotorTeTime", false), CultureInfo.InvariantCulture));
			}
			else
			{
				txtVirkgrad.Visible = false;
				txtCol1.Visible = false;
				txtCol5.Visible = false;
				txtStartCur.Visible = false;
				txtMotorRatedEff.Text = "";
				txtMotorStartCurrent.Text = "";

				txtStartTidtxt.Text = "";
				txtStartTidVal.Text = "";
				textBox19.Visible = false;

				txtVirkgrad.Visible = true;
				txtCol1.Visible = true;
				txtCol5.Visible = true;
				txtStartCur.Visible = true;

			}

			if (((XMLDataSource)this.DataSource).Field("CircuitLoadType", false).ToString() == "8")
			{
				txtFaser.Text = FebPrintClassLib.Properties.Resources.IDS_FASERTXT_1;
				txtFaserValue.Text = ((XMLDataSource)this.DataSource).Field("LoadNumberOfConductors", false).ToString();
			}
			else
			{
				txtFaser.Text = FebPrintClassLib.Properties.Resources.IDS_FASERTXT_2;
				txtFaserValue.Text = ((XMLDataSource)this.DataSource).Field("NumberOfLiveConductors", false).ToString();
			}

			//txtLoadUtilFact
			if (((XMLDataSource)this.DataSource).Field("LoadUtilisationFactor", false).ToString() == "." ||
			  ((XMLDataSource)this.DataSource).Field("LoadUtilisationFactor", false).ToString() == "-1")
				txtLoadUtilFact.Text = "";
			//txtLoadDivfact
			if (((XMLDataSource)this.DataSource).Field("LoadDiversityFactor", false).ToString() == "." ||
			  ((XMLDataSource)this.DataSource).Field("LoadDiversityFactor", false).ToString() == "-1")
				txtLoadDivfact.Text = "";

			//txtMotorRatedEff
			if (((XMLDataSource)this.DataSource).Field("MotorRatedEfficiency", false).ToString() == "." ||
			  ((XMLDataSource)this.DataSource).Field("MotorRatedEfficiency", false).ToString() == "-1")
			{
				txtMotorRatedEff.Text = "";
				txtVirkgrad.Visible = false;
				txtCol1.Visible = false;
			}
			else
			{
				txtVirkgrad.Visible = true;
				txtCol1.Visible = true;
			}

			//txtMotorStartCurrent
			if (((XMLDataSource)this.DataSource).Field("MotorStartCurrentRatio", false).ToString() == "." ||
			  ((XMLDataSource)this.DataSource).Field("MotorStartCurrentRatio", false).ToString() == "-1")
			{
				txtMotorStartCurrent.Text = "";
				txtStartCur.Visible = false;
				txtCol5.Visible = false;
			}
			else
			{
				txtStartCur.Visible = true;
				txtCol5.Visible = true;
			}

			shape1.Height = detail.Height + CmToInch(0.2f);

			/*

			*/
		}
	}
}
