﻿using System;
using System.Globalization;
using GrapeCity.ActiveReports.Data;


namespace FebPrintClassLib.Rpt6
{
    /// <summary>
    /// Summary description for Rpt06_CircLoad4.
    /// </summary>
	public partial class Rpt06_CircLoad4 : GrapeCity.ActiveReports.SectionReport
	{
		//CommonItems clItems = null;
		public Rpt06_CircLoad4()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

            Document.CacheToDisk = true;
            Document.CacheToDiskLocation = System.IO.Path.GetTempPath();

        }

        private void detail_Format(object sender, EventArgs e)
		{
			string strL1 = "";
			string strL2 = "";
			string strL3 = "";
			string strN = "";


			//CircLoad
			txtCircLoadType.Text = CommonItems.GetCircLoadType(((XMLDataSource)this.DataSource).Field("CircuitLoadType", false).ToString());

			//txtKindOfEarth
			txtKindOfEarth.Text = CommonItems.GetKindOfEarthTxt(((XMLDataSource)this.DataSource).Field("../KindOfEarthElectrode", false).ToString());

			//txtEqiBound
			txtEqiBound.Text = CommonItems.GetEqiPotBound(((XMLDataSource)this.DataSource).Field("../EquipotentialBonding", false).ToString());

			//txtStationaryEq // StationaryEquipment
			if (((XMLDataSource)this.DataSource).Field("StationaryEquipment", false).ToString() == "0")
				txtStationaryEq.Text = "";
			else if (((XMLDataSource)this.DataSource).Field("StationaryEquipment", false).ToString() == "1")
				txtStationaryEq.Text = FebPrintClassLib.Properties.Resources.txt_StatUtstyr;
			else if (((XMLDataSource)this.DataSource).Field("StationaryEquipment", false).ToString() == "2")
				txtStationaryEq.Text = FebPrintClassLib.Properties.Resources.txt_MotorLys;


			if (System.Threading.Thread.CurrentThread.CurrentUICulture.Name == "en-GB" ||
                System.Threading.Thread.CurrentThread.CurrentUICulture.Name == "fi-FI")
			{
				//Zfor
				if (((XMLDataSource)this.DataSource).Field("Zfor", false).ToString() == "." ||
					((XMLDataSource)this.DataSource).Field("Zfor", false).ToString() == "-1")
				{
					txtZfor.Text = "";
					rtfZfor.Visible = false;
					txtZforSemi.Visible = false;
				}
				else
				{
					rtfZfor.Visible = true;
					if (this.rtfZfor.Find("Zs") != -1)
					{
						this.rtfZfor.SelectionStart = this.rtfZfor.Find("s");
						this.rtfZfor.SelectionLength = 1;
						this.rtfZfor.SelectionCharOffset = -.03f;

						txtZfor.Text = String.Format("{0:#0.0000} [Ω]",
							Convert.ToDouble(((XMLDataSource)this.DataSource).Field("Zfor", false), CultureInfo.InvariantCulture));
					}
				}
			}
			else
			{
				//Zfor
				if (((XMLDataSource)this.DataSource).Field("Zfor", false).ToString() == "." ||
					((XMLDataSource)this.DataSource).Field("Zfor", false).ToString() == "-1")
				{
					txtZfor.Text = "";
					rtfZfor.Visible = false;
					txtZforSemi.Visible = false;
				}
				else
				{
					rtfZfor.Visible = true;
					if (this.rtfZfor.Find("för") != -1)
					{
						this.rtfZfor.SelectionStart = this.rtfZfor.Find("för");
						this.rtfZfor.SelectionLength = 3;
						this.rtfZfor.SelectionCharOffset = -.03f;

						txtZfor.Text = String.Format("{0:#0.0000} [Ω]",
							Convert.ToDouble(((XMLDataSource)this.DataSource).Field("Zfor", false), CultureInfo.InvariantCulture));
					}
				}
			}




			//txtEqiBound
			if (((XMLDataSource)this.DataSource).Field("../KindOfEarthElectrode", false).ToString() == "0" &&
				((XMLDataSource)this.DataSource).Field("../EquipotentialBonding", false).ToString() == "1")
			{
				txtJordelektrod.Visible = true;
				txtJordelektrod.Text = txtEqiBound.Text;
				txtEqiBound.Visible = false;
				txtCol0.Visible = false;
			}
			else if (((XMLDataSource)this.DataSource).Field("../KindOfEarthElectrode", false).ToString() == "0" &&
					 ((XMLDataSource)this.DataSource).Field("../EquipotentialBonding", false).ToString() == "0")
			{
				txtJordelektrod.Visible = false;
				txtCol0.Visible = false;
				txtEqiBound.Visible = false;
			}
			else
			{
				txtJordelektrod.Visible = true;
				txtEqiBound.Visible = true;
				txtJordelektrod.Text = FebPrintClassLib.Properties.Resources.IDS_Jordelektrode;
			}

			//LoadDescription
			if (((XMLDataSource)this.DataSource).Field("LoadDescription", false).ToString() == ".")
				txtLoadDesc.Text = "";
			//LoadNominalVoltage
			if (((XMLDataSource)this.DataSource).Field("LoadNominalVoltage", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("LoadNominalVoltage", false).ToString() == "-1")
				txtNomVolt.Text = "";
			else
				txtNomVolt.Text = String.Format("{0} V",
					Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LoadNominalVoltage", false), CultureInfo.InvariantCulture));
			//LoadRatedCurrent
			if (((XMLDataSource)this.DataSource).Field("LoadRatedCurrent", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("LoadRatedCurrent", false).ToString() == "-1")
				txtLoadratedCurrent.Text = "";
			else
				txtLoadratedCurrent.Text = String.Format("{0:#0.00} A",
					Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LoadRatedCurrent", false), CultureInfo.InvariantCulture));
			//LoadPowerFactor
			if (((XMLDataSource)this.DataSource).Field("LoadPowerFactor", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("LoadPowerFactor", false).ToString() == "-1")
				txtCosPhi.Text = "";
			//LoadRatedPower
			if (((XMLDataSource)this.DataSource).Field("LoadRatedPower", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("LoadRatedPower", false).ToString() == "-1")
				txtPowerPn.Text = "";
			else
				txtPowerPn.Text = String.Format("{0} kW",
					Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LoadRatedPower", false), CultureInfo.InvariantCulture));
			//LoadRatedTotalPower
			if (((XMLDataSource)this.DataSource).Field("LoadRatedTotalPower", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("LoadRatedTotalPower", false).ToString() == "-1")
				txtLoadSn.Text = "";
			else
				txtLoadSn.Text = String.Format("{0} kVA",
					Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LoadRatedTotalPower", false), CultureInfo.InvariantCulture));
			//txtSammenCurrent L1
			if (((XMLDataSource)this.DataSource).Field("SumLoadCurrentL1", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("SumLoadCurrentL1", false).ToString() == "-1")
				strL1 = "";
			else
				strL1 = String.Format("L1: {0:#0.0} A\n", Convert.ToDouble(((XMLDataSource)this.DataSource).Field("SumLoadCurrentL1", false), CultureInfo.InvariantCulture));
			//txtSammenCurrent L2
			if (((XMLDataSource)this.DataSource).Field("SumLoadCurrentL2", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("SumLoadCurrentL2", false).ToString() == "-1")
				strL2 = "";
			else
				strL2 = String.Format("L2: {0:#0.0} A\n", Convert.ToDouble(((XMLDataSource)this.DataSource).Field("SumLoadCurrentL2", false), CultureInfo.InvariantCulture));
			//txtSammenCurrent L3
			if (((XMLDataSource)this.DataSource).Field("SumLoadCurrentL3", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("SumLoadCurrentL3", false).ToString() == "-1")
				strL3 = "";
			else
				strL3 = String.Format("L3: {0:#0.0} A\n", Convert.ToDouble(((XMLDataSource)this.DataSource).Field("SumLoadCurrentL3", false), CultureInfo.InvariantCulture));
			//txtSammenCurrent N
			if (((XMLDataSource)this.DataSource).Field("SumLoadCurrentN", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("SumLoadCurrentN", false).ToString() == "-1")
				strN = "";
			else
				strN = String.Format("N:  {0:#0.0} A", Convert.ToDouble(((XMLDataSource)this.DataSource).Field("SumLoadCurrentN", false), CultureInfo.InvariantCulture));

			txtSammenCurrent.Text = strL1 + strL2 + strL3 + strN;


			//LoadNumberOfConductors
			//if (((XMLDataSource)this.DataSource).Field("LoadNumberOfConductors", false).ToString() == "." ||
			//    ((XMLDataSource)this.DataSource).Field("LoadNumberOfConductors", false).ToString() == "-1")
			//    txtNoOfLiveCond.Text = "";

			if (((XMLDataSource)this.DataSource).Field("CircuitLoadType", false).ToString() == "8")
			{
				txtFaser.Text = FebPrintClassLib.Properties.Resources.IDS_FASERTXT_1;
				txtFaserValue.Text = ((XMLDataSource)this.DataSource).Field("LoadNumberOfConductors", false).ToString();
			}
			else
			{
				txtFaser.Text = FebPrintClassLib.Properties.Resources.IDS_FASERTXT_2;
				txtFaserValue.Text = ((XMLDataSource)this.DataSource).Field("NumberOfLiveConductors", false).ToString();

			}


            //LiveConductorArrangement
            if (((XMLDataSource)this.DataSource).Field("LiveConductorArrangement", false).ToString() == "." ||
              ((XMLDataSource)this.DataSource).Field("LiveConductorArrangement", false).ToString() == "-1")
                txtLiveCondArr.Text = "";
            else
                txtLiveCondArr.Text = ((XMLDataSource)this.DataSource).Field("LiveConductorArrangement", false).ToString();

            //txtPunkterVal
            if (((XMLDataSource)this.DataSource).Field("NumberOfDistributedLoadNodes", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("NumberOfDistributedLoadNodes", false).ToString() == "-1")
				txtPunkterVal.Text = "";
			else
				txtPunkterVal.Text = String.Format("{0}",
					Convert.ToDouble(((XMLDataSource)this.DataSource).Field("NumberOfDistributedLoadNodes", false), CultureInfo.InvariantCulture));

			//txtKabelFirstVal
			if (((XMLDataSource)this.DataSource).Field("CableLengthToFirstBranch", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("CableLengthToFirstBranch", false).ToString() == "-1")
				txtKabelFirstVal.Text = "";
			else
				txtKabelFirstVal.Text = String.Format("{0:#0.0 m}",
					Convert.ToDouble(((XMLDataSource)this.DataSource).Field("CableLengthToFirstBranch", false), CultureInfo.InvariantCulture));

			//txtKabelMidVal
			if (((XMLDataSource)this.DataSource).Field("CableLengthBetweenBranches", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("CableLengthBetweenBranches", false).ToString() == "-1")
				txtKabelMidVal.Text = "";
			else
				txtKabelMidVal.Text = String.Format("{0:#0.0 m}",
					Convert.ToDouble(((XMLDataSource)this.DataSource).Field("CableLengthBetweenBranches", false), CultureInfo.InvariantCulture));

			//txtKabelAvgrVal
			if (((XMLDataSource)this.DataSource).Field("CableLengthBranch", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("CableLengthBranch", false).ToString() == "-1")
				txtKabelAvgrVal.Text = "";
			else
				txtKabelAvgrVal.Text = String.Format("{0:#0.0 m}",
					Convert.ToDouble(((XMLDataSource)this.DataSource).Field("CableLengthBranch", false), CultureInfo.InvariantCulture));

			shape1.Height = detail.Height + CmToInch(0.2f);
		}
	}
}
