using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Globalization;
using GrapeCity.ActiveReports.Data;
using System.Windows.Forms;

namespace FebPrintClassLib.Rpt6
{
	/// <summary>
	/// Summary description for Rpt06_CircLoad6.
	/// </summary>
	public partial class Rpt06_CircLoad6 : GrapeCity.ActiveReports.SectionReport
	{
		//CommonItems clItems = null;

		public Rpt06_CircLoad6()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

            Document.CacheToDisk = true;
            Document.CacheToDiskLocation = System.IO.Path.GetTempPath();

        }

        private void detail_Format(object sender, EventArgs e)
		{

			//CircLoad
			txtCircLoadType.Text = CommonItems.GetCircLoadType(((XMLDataSource)this.DataSource).Field("CircuitLoadType", false).ToString());

			//LoadDescription
			if (((XMLDataSource)this.DataSource).Field("LoadDescription", false).ToString() == ".")
				txtLoadDesc.Text = "";
			//LoadNominalVoltage
			if (((XMLDataSource)this.DataSource).Field("LoadNominalVoltage", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("LoadNominalVoltage", false).ToString() == "-1")
				txtNomVolt.Text = "";
			else
				txtNomVolt.Text = String.Format("{0} V",
					Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LoadNominalVoltage", false), CultureInfo.InvariantCulture));
			//LoadRatedCurrent
			if (((XMLDataSource)this.DataSource).Field("LoadRatedCurrent", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("LoadRatedCurrent", false).ToString() == "-1")
				txtLoadratedCurrent.Text = "";
			else
				txtLoadratedCurrent.Text = String.Format("{0:#0.00} A",
					Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LoadRatedCurrent", false), CultureInfo.InvariantCulture));

			//LoadPowerFactor
			if (((XMLDataSource)this.DataSource).Field("LoadPowerFactor", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("LoadPowerFactor", false).ToString() == "-1")
				txtCosPhi.Text = "";

			//LoadRatedPower
			if (((XMLDataSource)this.DataSource).Field("LoadRatedPower", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("LoadRatedPower", false).ToString() == "-1")
				txtPowerPn.Text = "";
			else
				txtPowerPn.Text = String.Format("{0:#0.0} kW",
					Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LoadRatedPower", false), CultureInfo.InvariantCulture));
			//LoadRatedTotalPower
			if (((XMLDataSource)this.DataSource).Field("LoadRatedTotalPower", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("LoadRatedTotalPower", false).ToString() == "-1")
				txtLoadSn.Text = "";
			else
				txtLoadSn.Text = String.Format("{0:#0.0} kVA",
					Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LoadRatedTotalPower", false), CultureInfo.InvariantCulture));

            //LiveConductorArrangement
            if (((XMLDataSource)this.DataSource).Field("LiveConductorArrangement", false).ToString() == "." ||
              ((XMLDataSource)this.DataSource).Field("LiveConductorArrangement", false).ToString() == "-1")
                txtLiveCondArr.Text = "";
            else
                txtLiveCondArr.Text = ((XMLDataSource)this.DataSource).Field("LiveConductorArrangement", false).ToString();

            //GeneratorSubTransientReactance
            if (((XMLDataSource)this.DataSource).Field("GeneratorSubTransientReactance", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("GeneratorSubTransientReactance", false).ToString() == "-1")
				txtGeneratorSubTransientReactance.Text = "";
			else
				txtGeneratorSubTransientReactance.Text = String.Format("{0:#0.00} p.u",
					Convert.ToDouble(((XMLDataSource)this.DataSource).Field("GeneratorSubTransientReactance", false), CultureInfo.InvariantCulture));

			//GeneratorX0
			if (((XMLDataSource)this.DataSource).Field("GeneratorX0", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("GeneratorX0", false).ToString() == "-1")
				txtGeneratorX0.Text = "";
			else
				txtGeneratorX0.Text = String.Format("{0:#0.00} p.u",
					Convert.ToDouble(((XMLDataSource)this.DataSource).Field("GeneratorX0", false), CultureInfo.InvariantCulture));

			//GeneratorStatorResistance
			if (((XMLDataSource)this.DataSource).Field("GeneratorStatorResistance", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("GeneratorStatorResistance", false).ToString() == "-1")
				txtGeneratorStatorResistance.Text = "";
			else
				txtGeneratorStatorResistance.Text = String.Format("{0:#0.#####} Ohm",
					Convert.ToDouble(((XMLDataSource)this.DataSource).Field("GeneratorStatorResistance", false), CultureInfo.InvariantCulture));

			//GeneratorSubTransientTimeConstant
			if (((XMLDataSource)this.DataSource).Field("GeneratorSubTransientTimeConstant", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("GeneratorSubTransientTimeConstant", false).ToString() == "-1")
				txtGeneratorSubTransientTimeConstant.Text = "";
			else
				txtGeneratorSubTransientTimeConstant.Text = String.Format("{0:#0.00} ms",
					Convert.ToDouble(((XMLDataSource)this.DataSource).Field("GeneratorSubTransientTimeConstant", false), CultureInfo.InvariantCulture));

			//GeneratorTransientTimeConstant
			if (((XMLDataSource)this.DataSource).Field("GeneratorTransientTimeConstant", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("GeneratorTransientTimeConstant", false).ToString() == "-1")
				txtGeneratorTransientTimeConstant.Text = "";
			else
				txtGeneratorTransientTimeConstant.Text = String.Format("{0:#0.00} ms",
					Convert.ToDouble(((XMLDataSource)this.DataSource).Field("GeneratorTransientTimeConstant", false), CultureInfo.InvariantCulture));

			//GeneratorTransientReactance
			if (((XMLDataSource)this.DataSource).Field("GeneratorTransientReactance", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("GeneratorTransientReactance", false).ToString() == "-1")
				txtGeneratorTransientReactance.Text = "";
			else
				txtGeneratorTransientReactance.Text = String.Format("{0:#0.00} p.u",
					Convert.ToDouble(((XMLDataSource)this.DataSource).Field("GeneratorTransientReactance", false), CultureInfo.InvariantCulture));

			//GeneratorReactance
			if (((XMLDataSource)this.DataSource).Field("GeneratorReactance", false).ToString() == "." ||
				((XMLDataSource)this.DataSource).Field("GeneratorReactance", false).ToString() == "-1")
				txtGeneratorReactance.Text = "";
			else
				txtGeneratorReactance.Text = String.Format("{0:#0.00} p.u",
					Convert.ToDouble(((XMLDataSource)this.DataSource).Field("GeneratorReactance", false), CultureInfo.InvariantCulture));

            ////GeneratorDCTimeConstant
            //if (((XMLDataSource)this.DataSource).Field("GeneratorDCTimeConstant", false).ToString() == "." ||
            //    ((XMLDataSource)this.DataSource).Field("GeneratorDCTimeConstant", false).ToString() == "-1")
            //    txtGeneratorDCTimeConstant.Text = "";
            //else
            //    txtGeneratorDCTimeConstant.Text = String.Format("{0:#0.00} ms",
            //        Convert.ToDouble(((XMLDataSource)this.DataSource).Field("GeneratorDCTimeConstant", false), CultureInfo.InvariantCulture));

            //lblSpanningsRegulator
            if (((XMLDataSource)this.DataSource).Field("GeneratorVoltageRegulator", false).ToString() == "1")
            {
                lblSpanningsRegulator.Visible = true;
                lblGenStromVFulltPadrag.Visible = true;
                lblTidTStartPadrag.Visible = true;
                lblTidTilFulltPadrag.Visible = true;
                lbl2GenStromVFulltPadrag.Visible = true;
                lbl2TidTStartPadrag.Visible = true;
                lbl2TidTilFulltPadrag.Visible = true;
                txtGenStromVFulltPadrag.Visible = true;
                txtTidTStartPadrag.Visible = true;
                txtTidTilFulltPadrag.Visible = true;

                //Values..
                if (((XMLDataSource)this.DataSource).Field("GeneratorCurrentAtFullOpening", false).ToString() == "." ||
                    ((XMLDataSource)this.DataSource).Field("GeneratorCurrentAtFullOpening", false).ToString() == "-1")
                    txtGenStromVFulltPadrag.Text = "";
                else
                    txtGenStromVFulltPadrag.Text = String.Format("{0:#0.00} [x In]",
                        Convert.ToDouble(((XMLDataSource)this.DataSource).Field("GeneratorCurrentAtFullOpening", false), CultureInfo.InvariantCulture));

                if (((XMLDataSource)this.DataSource).Field("GeneratorTimeStartRegulator", false).ToString() == "." ||
                    ((XMLDataSource)this.DataSource).Field("GeneratorTimeStartRegulator", false).ToString() == "-1")
                    txtTidTStartPadrag.Text = "";
                else
                    txtTidTStartPadrag.Text = String.Format("{0:#0.000} s",
                        Convert.ToDouble(((XMLDataSource)this.DataSource).Field("GeneratorTimeStartRegulator", false), CultureInfo.InvariantCulture));

                if (((XMLDataSource)this.DataSource).Field("GeneratorTimeFullOpening", false).ToString() == "." ||
                    ((XMLDataSource)this.DataSource).Field("GeneratorTimeFullOpening", false).ToString() == "-1")
                    txtTidTilFulltPadrag.Text = "";
                else
                    txtTidTilFulltPadrag.Text = String.Format("{0:#0.000} s",
                        Convert.ToDouble(((XMLDataSource)this.DataSource).Field("GeneratorTimeFullOpening", false), CultureInfo.InvariantCulture));
            }
            else
            {
                lblSpanningsRegulator.Visible = false;
                lblGenStromVFulltPadrag.Visible = false;
                lblTidTStartPadrag.Visible = false;
                lblTidTilFulltPadrag.Visible = false;
                lbl2GenStromVFulltPadrag.Visible = false;
                lbl2TidTStartPadrag.Visible = false;
                lbl2TidTilFulltPadrag.Visible = false;
                txtGenStromVFulltPadrag.Visible = false;
                txtTidTStartPadrag.Visible = false;
                txtTidTilFulltPadrag.Visible = false;

            }

            //txtGenMerkeStrom
            if (((XMLDataSource)this.DataSource).Field("GeneratorRatedCurrent", false).ToString() == "." ||
                ((XMLDataSource)this.DataSource).Field("GeneratorRatedCurrent", false).ToString() == "-1")
                txtGenMerkeStrom.Text = "";
            else
                txtGenMerkeStrom.Text = String.Format("{0:#0.00} A",
                    Convert.ToDouble(((XMLDataSource)this.DataSource).Field("GeneratorRatedCurrent", false), CultureInfo.InvariantCulture));

            shape1.Height = detail.Height + CmToInch(0.2f);
		}
	}
}
