﻿using System;
using System.Drawing;
using System.Globalization;
using System.Windows.Forms;
using GrapeCity.ActiveReports.Data;


namespace FebPrintClassLib.Rpt6
{
    /* ErrorAtFaultCurrent1
     * ErrorAtFaultCurrent2
     * Når disse er satt til 1 skal det skrives ut @ etter verdien i kolonnen med vernets utkoblingstid
    Når tag'en CableMaxTime1 er satt til -2 skal det skrives ut "Ik < Iz" i kolonnen for kablens max tid og ingen verdi.Kabel
    t=k²S²/I² [s]
    Når tag'en TrippingTime1 er satt til -2 skal det skrives ut "Ik < I2" i kolonnen med utkoblingstid. Kolonnen med kabelens max tid skal da være blank.
         * 
         */
    /// <summary>
    /// Summary description for Rpt06_FaultCurr.
    /// </summary>
	public partial class Rpt06_FaultCurr : GrapeCity.ActiveReports.SectionReport
    {
        //CommonItems clItems = null;
		public Rpt06_FaultCurr()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

            Document.CacheToDisk = true;
            Document.CacheToDiskLocation = System.IO.Path.GetTempPath();

        }

        private void detail_Format(object sender, EventArgs e)
		{


			if (((XMLDataSource)this.DataSource).Field("../NameCodeHeading2", false).ToString() == "-1" ||
				((XMLDataSource)this.DataSource).Field("../NameCodeHeading2", false).ToString() == ".")
			{
				txtRmsValue21.Visible = false;
				txtPowerFactor21.Visible = false;
				txtPeakValue21.Visible = false;
				txtCableMaxTime21.Visible = false;
				txtTrippingTime21.Visible = false;
				txtAlfa2.Visible = false;
			}
			else
			{
				txtRmsValue21.Visible = true;
				txtPowerFactor21.Visible = true;
				txtPeakValue21.Visible = true;
				txtCableMaxTime21.Visible = true;
				txtTrippingTime21.Visible = true;
				txtAlfa2.Visible = true;


				//@ visas om xx = 1 eller 2
				//Colour = red if 1 blue if 2
				try
				{
                    switch (((XMLDataSource)this.DataSource).Field("ErrorAtFaultCurrent2", false).ToString())
                    {
                        case "1":
                            txtAlfa2.Text = "@";
                            txtAlfa2.ForeColor = Color.Red;
                            break;
                        case "2":
                            txtAlfa2.Text = "#";
                            txtAlfa2.ForeColor = Color.Blue;
                            break;
                        default:
                            txtAlfa2.Text = "";
                            break;
                    }

                    switch (((XMLDataSource)this.DataSource).Field("RmsValue2", false).ToString())
                    {
                        case "-1":
                        case ".":
                        case "":
                            txtRmsValue21.Text = "";
                            break;
                        default:
                            txtRmsValue21.Text = String.Format("{0:#0.000}",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("RmsValue2", false), CultureInfo.InvariantCulture));
                            break;
                    }

                    switch (((XMLDataSource)this.DataSource).Field("PowerFactor2", false).ToString())
                    {
                        case "-1":
                        case ".":
                        case "":
                            txtPowerFactor21.Text = "";
                            break;
                        default:
                            txtPowerFactor21.Text = String.Format("{0:#0.00}",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("PowerFactor2", false), CultureInfo.InvariantCulture));
                            break;
                    }

                    switch (((XMLDataSource)this.DataSource).Field("PeakValue2", false).ToString())
                    {
                        case "-1":
                        case ".":
                        case "":
                            txtPeakValue21.Text = "";
                            break;
                        default:
                            txtPeakValue21.Text = String.Format("{0:#0.000}",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("PeakValue2", false), CultureInfo.InvariantCulture));
                            break;
                    }

                    switch (((XMLDataSource)this.DataSource).Field("CableMaxTime2", false).ToString())
                    {
                        case ".":
                        case "-1":
                        case "":
                            txtCableMaxTime21.Text = "";
                            break;
                        case "-3":
                            txtCableMaxTime21.Text = "Ik < Iz";
                            txtCableMaxTime21.ForeColor = Color.Blue;
                            break;
                        default:
                            txtCableMaxTime21.ForeColor = Color.Black;
                            txtCableMaxTime21.Text = String.Format("{0:#0.000}",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("CableMaxTime2", false), CultureInfo.InvariantCulture));
                            break;
                    }

                    switch (((XMLDataSource)this.DataSource).Field("TrippingTime2", false).ToString())
                    {
                        case ".":
                        case "-1":
                        case "":
                            txtTrippingTime21.Text = "";
                            break;
                        case "-2":
                            txtTrippingTime21.Text = "Ik < I2";
                            txtTrippingTime21.ForeColor = Color.Blue;
                            break;
                        case "-3":
                            txtTrippingTime21.Text = "Ik < Iz";
                            txtTrippingTime21.ForeColor = Color.Blue;
                            break;
                        default:
                            txtTrippingTime21.ForeColor = Color.Black;
                            txtTrippingTime21.Text = String.Format("{0:#0.000}",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("TrippingTime2", false), CultureInfo.InvariantCulture));
                            break;
                    }

				}
				catch (Exception ex)
				{
					MessageBox.Show("FaultCurr 2", ex.Message);
				}


			}

			txtFaultCode.Text = CommonItems.GetFaultCodeTxt(((XMLDataSource)this.DataSource).Field("FaultCurrentCode", false).ToString());

			try
			{
                switch (((XMLDataSource)this.DataSource).Field("ErrorAtFaultCurrent1", false).ToString())
                {
                    case "1":
                        txtAlfa1.Text = "@";
                        txtAlfa1.ForeColor = Color.Red;
                        break;
                    case "2":
                        txtAlfa1.Text = "#";
                        txtAlfa1.ForeColor = Color.Blue;
                        break;
                    default:
                        txtAlfa1.Text = "";
                        break;
                }

                switch (((XMLDataSource)this.DataSource).Field("RmsValue1", false).ToString())
                {
                    case "-1":
                    case ".":
                    case "":
                        txtRmsValue11.Text = "";
                        break;
                    default:
                        txtRmsValue11.Text = String.Format("{0:#0.000}",
                        Convert.ToDouble(((XMLDataSource)this.DataSource).Field("RmsValue1", false), CultureInfo.InvariantCulture));
                        break;
                }

                switch (((XMLDataSource)this.DataSource).Field("PowerFactor1", false).ToString())
                {
                    case "-1":
                    case ".":
                    case "":
                        txtPowerFactor11.Text = "";
                        break;
                    default:
                        txtPowerFactor11.Text = String.Format("{0:#0.00}",
                        Convert.ToDouble(((XMLDataSource)this.DataSource).Field("PowerFactor1", false), CultureInfo.InvariantCulture));
                        break;
                }

                switch (((XMLDataSource)this.DataSource).Field("PeakValue1", false).ToString())
                {
                    case "-1":
                    case ".":
                    case "":
                        txtPeakValue11.Text = "";
                        break;
                    default:
                        txtPeakValue11.Text = String.Format("{0:#0.000}",
                        Convert.ToDouble(((XMLDataSource)this.DataSource).Field("PeakValue1", false), CultureInfo.InvariantCulture));
                        break;
                }

                switch (((XMLDataSource)this.DataSource).Field("CableMaxTime1", false).ToString())
                {
                    case "-1":
                    case ".":
                    case "":
                        txtCableMaxTime11.Text = "";
                        break;
                    case "-3":
                        txtCableMaxTime11.Text = "Ik < Iz";
                        txtCableMaxTime11.ForeColor = Color.Blue;
                        break;
                    default:
                        txtCableMaxTime11.ForeColor = Color.Black;
                        txtCableMaxTime11.Text = String.Format("{0:#0.000}",
                        Convert.ToDouble(((XMLDataSource)this.DataSource).Field("CableMaxTime1", false), CultureInfo.InvariantCulture));
                        break;
                }

                switch (((XMLDataSource)this.DataSource).Field("TrippingTime1", false).ToString())
                {
                    case "-1":
                    case ".":
                    case "":
                        txtTrippingTime11.Text = "";
                        break;
                    case "-2":
                        txtTrippingTime11.Text = "Ik < I2";
                        txtTrippingTime11.ForeColor = Color.Blue;
                        break;
                    case "-3":
                        txtTrippingTime11.Text = "Ik < Iz";
                        txtTrippingTime11.ForeColor = Color.Blue;
                        break;
                    default:
                        txtTrippingTime11.ForeColor = Color.Black;
                        txtTrippingTime11.Text = String.Format("{0:#0.000}",
                        Convert.ToDouble(((XMLDataSource)this.DataSource).Field("TrippingTime1", false), CultureInfo.InvariantCulture));
                        break;
                }
			}
			catch (Exception ex)
			{
				MessageBox.Show("FaultCurr 1", ex.Message);
			}
		}

		private void groupHeader1_Format(object sender, EventArgs e)
		{
			txtNameCodeDevice.BackColor = CommonItems.clBackGround;
			txtNameCodeDevice.ForeColor = CommonItems.clForeGround;

			rtf1_1.BackColor = CommonItems.clBackGround;
			rtf1_2.BackColor = CommonItems.clBackGround;

			txtNameCodeHead2.BackColor = CommonItems.clBackGround;
			txt1_2.BackColor = CommonItems.clBackGround;
			txt2_2.BackColor = CommonItems.clBackGround;
			txt3_2.BackColor = CommonItems.clBackGround;
			txt4_2.BackColor = CommonItems.clBackGround;

			txtNameCodeHead1.BackColor = CommonItems.clBackGround;
			txt1_1.BackColor = CommonItems.clBackGround;
			txt2_1.BackColor = CommonItems.clBackGround;
			txt3_1.BackColor = CommonItems.clBackGround;
			txt4_1.BackColor = CommonItems.clBackGround;

			txtNameCodeHead2.ForeColor = CommonItems.clForeGround;
			txt1_2.ForeColor = CommonItems.clForeGround;
			txt2_2.ForeColor = CommonItems.clForeGround;
			txt3_2.ForeColor = CommonItems.clForeGround;
			txt4_2.ForeColor = CommonItems.clForeGround;

			txtNameCodeHead1.ForeColor = CommonItems.clForeGround;
			txt1_1.ForeColor = CommonItems.clForeGround;
			txt2_1.ForeColor = CommonItems.clForeGround;
			txt3_1.ForeColor = CommonItems.clForeGround;
			txt4_1.ForeColor = CommonItems.clForeGround;

			rtf1_1.ReplaceField("utkobling", FebPrintClassLib.Properties.Resources.IDS_UTKOBLING_TXT);
			rtf1_2.ReplaceField("utkobling", FebPrintClassLib.Properties.Resources.IDS_UTKOBLING_TXT);

			int iLen = FebPrintClassLib.Properties.Resources.IDS_UTKOBLING_TXT.Length;

			if (this.rtf1_1.Find(FebPrintClassLib.Properties.Resources.IDS_UTKOBLING_TXT) != -1)
			{
				this.rtf1_1.SelectionStart = this.rtf1_1.Find(FebPrintClassLib.Properties.Resources.IDS_UTKOBLING_TXT);
				this.rtf1_1.SelectionLength = iLen;
				this.rtf1_1.SelectionCharOffset = -.03f;
			}

			if (this.rtf1_2.Find(FebPrintClassLib.Properties.Resources.IDS_UTKOBLING_TXT) != -1)
			{
				this.rtf1_2.SelectionStart = this.rtf1_2.Find(FebPrintClassLib.Properties.Resources.IDS_UTKOBLING_TXT);
				this.rtf1_2.SelectionLength = iLen;
				this.rtf1_2.SelectionCharOffset = -.03f;
			}

			//if {CircuitFaultCurrents.NameCodeHeading2} = "-1" or {CircuitFaultCurrents.NameCodeHeading2} = "." then
			//true
			try
			{
				if (((XMLDataSource)this.DataSource).Field("../NameCodeHeading2", false).ToString() == "-1" ||
					((XMLDataSource)this.DataSource).Field("../NameCodeHeading2", false).ToString() == ".")
				{
					txtNameCodeHead2.Visible = false;
					txt1_2.Visible = false;
					txt2_2.Visible = false;
					txt3_2.Visible = false;
					txt4_2.Visible = false;
					rtf1_2.Visible = false;
				}
				else
				{
					txtNameCodeHead2.Visible = true;
					txt1_2.Visible = true;
					txt2_2.Visible = true;
					txt3_2.Visible = true;
					txt4_2.Visible = true;
					rtf1_2.Visible = true;
					txtNameCodeHead2.Text = CommonItems.GetNameCodeTxt(((XMLDataSource)this.DataSource).Field("../NameCodeHeading2", false).ToString());

				}

				if (((XMLDataSource)this.DataSource).Field("../../../DistributionType", false).ToString() == "DC")	// ES 2019-01-09 - Not showing cosphi and Ikpeak text for DC installations
				{
					txt2_1.Text= "";
					txt3_1.Text= "";
					txt2_2.Text= "";
					txt3_2.Text= "";
				}

				txtNameCodeHead1.Text = CommonItems.GetNameCodeTxt(((XMLDataSource)this.DataSource).Field("../NameCodeHeading1", false).ToString());
				txtNameCodeDevice.Text = CommonItems.GetNameCodeTxt(((XMLDataSource)this.DataSource).Field("../NameCodeProtectiveDevice", false).ToString());

			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message);

			}


			/*
			if (((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingFactorMin", false).ToString() == "-1" ||
				((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingValueMin", false).ToString() == "-1")
				txtMin1.Text = "";
			else
				txtMin1.Text = String.Format("{0:#0.0} / {1:#0.0} A",
					Convert.ToDouble(((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingFactorMin", false), CultureInfo.InvariantCulture),
					Convert.ToDouble(((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingValueMin", false), CultureInfo.InvariantCulture));

			*/

		}

		private void groupFooter1_Format(object sender, EventArgs e)
		{
			txtAlfatext.Text = String.Format("@ = {0}\n# = {1}", FebPrintClassLib.Properties.Resources.IDS_VERNCHECKERR_TXT, Properties.Resources.IDS_VERNCHECKERR2_TXT);

		}

 
     }
}
