﻿using System;
using System.Drawing;
using System.Globalization;
using System.Windows.Forms;
using GrapeCity.ActiveReports.Data;
using GrapeCity.ActiveReports.SectionReportModel;

namespace FebPrintClassLib.Rpt6
{
    /// <summary>
    /// Summary description for Rpt06_ProtDev1.
    /// </summary>
	public partial class Rpt06_ProtDev1 : GrapeCity.ActiveReports.SectionReport
	{
		//private CommonItems clItems = null;
  //      private XMLDataSource xmlDS = null;
  //      private XMLDataSource xmlDS1 = null;
  //      private XMLDataSource xmlDS2 = null;
  //      private XMLDataSource xmlDS3 = null;
  //      private XMLDataSource xmlDS4 = null;
  //      private XMLDataSource xmlDS5 = null;
  //      private Rpt06_ProtDev_LongTime rptLongTime = null;
		//private Rpt06_ProtDev_ShortTime rptShortTime = null;
		//private Rpt06_ProtDev_InstCurr rptInstCurr = null;
		//private Rpt06_ProtDev_Gfault rptGfault = null;
		//private Rpt06_ProtDev_LongTimeTH rptLongTimeTh = null;
		//private Rpt06_ProtDev_InstCurrEm rptInstCurrEm = null;

		public Rpt06_ProtDev1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
            Document.CacheToDisk = true;
            Document.CacheToDiskLocation = System.IO.Path.GetTempPath();
        }

        private void detail_Format(object sender, EventArgs e)
        {
            string strBreakMsg = "";
            string strNameType = "";
            string strName0 = "";
            string strName1 = "";
            string strName2 = "";
            string strName3 = "";
            string strTxt0 = "";
            string strTxt1 = "";
            string strTxt2 = "";
            string strTxt3 = "";

            PointF ptNext = new PointF();
            PointF ptNext2 = new PointF();

            PointF ptHead1 = new PointF(CmToInch(4.188f), 0);
            PointF ptHead2 = new PointF(CmToInch(7.623f), 0);
            PointF ptHead3 = new PointF(CmToInch(11.063f), 0);
            PointF ptRow1 = new PointF(CmToInch(1.803f), 0);
            PointF ptRow2 = new PointF(CmToInch(1.803f), 0);
            PointF ptCol1 = new PointF(CmToInch(4.003f), ptRow1.Y);
            PointF ptCol2 = new PointF(CmToInch(4.003f), ptRow2.Y);

            #region TxtHeadings
            strNameType = CommonItems.GetNameCodeTxt(((XMLDataSource)this.DataSource).Field("NameCode", false).ToString());
            txtNameType.Text = String.Format("{0}, {1}", strNameType, FebPrintClassLib.Properties.Resources.IDS_MERKINGTXT);

            //txtBreakerUnitTypeDesignation1
            if (((XMLDataSource)this.DataSource).Field("BreakerUnitTypeDesignation", false).ToString() == "." ||
                ((XMLDataSource)this.DataSource).Field("BreakerUnitTypeDesignation", false).ToString() == "" ||
                ((XMLDataSource)this.DataSource).Field("BreakerUnitTypeDesignation", false).ToString() == "-1")
                txtBreakerUnitTypeDesignation1.Text = "";
            else
            {
                if (Convert.ToInt32(((XMLDataSource)this.DataSource).Field("ProtectiveDeviceKind", false).ToString()) > 1)
                {
                    txtBreakerUnitTypeDesignation1.Text = String.Format("{0}    Iru: {1} A  /  {2}",
                        ((XMLDataSource)this.DataSource).Field("BreakerUnitTypeDesignation", false).ToString(),
                        ((XMLDataSource)this.DataSource).Field("BreakerUnitUltimateRatedCurrent", false).ToString(),
                        ((XMLDataSource)this.DataSource).Field("BreakerUnitPerformanceClass", false).ToString());
                }
                else
                {
                    txtBreakerUnitTypeDesignation1.Text = String.Format("{0}",
                        ((XMLDataSource)this.DataSource).Field("BreakerUnitTypeDesignation", false).ToString());
                }
            }


            //txtProtectiveDeviceRatedlReleaseCurrentRCD1
            if (((XMLDataSource)this.DataSource).Field("ProtectiveDeviceRatedReleaseCurrentRCD", false).ToString() == "." ||
                ((XMLDataSource)this.DataSource).Field("ProtectiveDeviceRatedReleaseCurrentRCD", false).ToString() == "" ||
                ((XMLDataSource)this.DataSource).Field("ProtectiveDeviceRatedReleaseCurrentRCD", false).ToString() == "-1")
            {
                txtProtectiveDeviceRatedlReleaseCurrentRCD1.Text = "";
                txtMrkJf.Visible = false;
                txtColMrkJf.Visible = false;
            }
            else
            {
                txtMrkJf.Visible = true;
                txtColMrkJf.Visible = true;
            }

            //txtProtectiveDeviceNeedsChecking1 IDS_VERNCHECKERR_TXT
            if (((XMLDataSource)this.DataSource).Field("ProtectiveDeviceNeedsChecking", false).ToString() == "1")
                txtProtectiveDeviceNeedsChecking1.Text = FebPrintClassLib.Properties.Resources.IDS_VERNCHECKERR_TXT;
            else
                txtProtectiveDeviceNeedsChecking1.Text = "";


            //txtProtectiveDeviceReferenceDesignation1
            if (((XMLDataSource)this.DataSource).Field("ProtectiveDeviceReferenceDesignation", false).ToString() == "." ||
                ((XMLDataSource)this.DataSource).Field("ProtectiveDeviceReferenceDesignation", false).ToString() == "-1")
                txtProtectiveDeviceReferenceDesignation1.Text = "";

            //txtProtectiveDeviceManufacturer1
            if (((XMLDataSource)this.DataSource).Field("ProtectiveDeviceManufacturer", false).ToString() == "." ||
                ((XMLDataSource)this.DataSource).Field("ProtectiveDeviceManufacturer", false).ToString() == "-1")
                txtProtectiveDeviceManufacturer1.Text = "";


            //txtTrippingUnitTypeDesignation1
            if (((XMLDataSource)this.DataSource).Field("TrippingUnitTypeDesignation", false).ToString() == "." ||
                ((XMLDataSource)this.DataSource).Field("TrippingUnitTypeDesignation", false).ToString() == "-1")
                txtTrippingUnitTypeDesignation1.Text = "";

            //txtProtectiveDeviceArticleNumber1
            if (((XMLDataSource)this.DataSource).Field("ProtectiveDeviceArticleNumber", false).ToString() == "." ||
                ((XMLDataSource)this.DataSource).Field("ProtectiveDeviceArticleNumber", false).ToString() == "-1")
                txtProtectiveDeviceArticleNumber1.Text = "";

            //txtProtectiveDeviceEanNumber1
            if (((XMLDataSource)this.DataSource).Field("ProtectiveDeviceEanNumber", false).ToString() == "." ||
                ((XMLDataSource)this.DataSource).Field("ProtectiveDeviceEanNumber", false).ToString() == "-1")
                txtProtectiveDeviceEanNumber1.Text = "";

            //strBreakMsg
            if (((XMLDataSource)this.DataSource).Field("ProtectiveDeviceBreakingCapacityMessage", false).ToString() == ".")
                strBreakMsg = "";
            else
                strBreakMsg = ((XMLDataSource)this.DataSource).Field("ProtectiveDeviceBreakingCapacityMessage", false).ToString();

            try
            {
                //txtProtectiveDeviceNominalCurrent1
                if (((XMLDataSource)this.DataSource).Field("ProtectiveDeviceNominalCurrent", false).ToString() == "." ||
                    ((XMLDataSource)this.DataSource).Field("ProtectiveDeviceNominalCurrent", false).ToString() == "-1")
                    txtProtectiveDeviceNominalCurrent1.Text = "";
                else
                    txtProtectiveDeviceNominalCurrent1.Text = String.Format("{0:#0.00} A",
                        Convert.ToDouble(((XMLDataSource)this.DataSource).Field("ProtectiveDeviceNominalCurrent", false), CultureInfo.InvariantCulture));

                //txtProtectiveDeviceBreakingCapacity1
                if (((XMLDataSource)this.DataSource).Field("ProtectiveDeviceBreakingCapacity", false).ToString() == "." ||
                    ((XMLDataSource)this.DataSource).Field("ProtectiveDeviceBreakingCapacity", false).ToString() == "-1")
                    txtProtectiveDeviceBreakingCapacity1.Text = "";
                else
                    txtProtectiveDeviceBreakingCapacity1.Text = String.Format("{0:#0.00} kA {1}",
                        Convert.ToDouble(((XMLDataSource)this.DataSource).Field("ProtectiveDeviceBreakingCapacity", false), CultureInfo.InvariantCulture),
                        strBreakMsg);

                //txtUpperThermalTestCurrent1
                if (((XMLDataSource)this.DataSource).Field("UpperThermalTestCurrent", false).ToString() == "." ||
                    ((XMLDataSource)this.DataSource).Field("UpperThermalTestCurrent", false).ToString() == "-1")
                    txtUpperThermalTestCurrent1.Text = "";
                else
                    txtUpperThermalTestCurrent1.Text = String.Format("{0:#0.00} A",
                        Convert.ToDouble(((XMLDataSource)this.DataSource).Field("UpperThermalTestCurrent", false), CultureInfo.InvariantCulture));

                //txtUpperInstantaneousCurrent1
                if (((XMLDataSource)this.DataSource).Field("UpperInstantaneousCurrent", false).ToString() == "." ||
                    ((XMLDataSource)this.DataSource).Field("UpperInstantaneousCurrent", false).ToString() == "-1")
                    txtUpperInstantaneousCurrent1.Text = "";
                else
                    txtUpperInstantaneousCurrent1.Text = String.Format("{0:#0.00} A",
                        Convert.ToDouble(((XMLDataSource)this.DataSource).Field("UpperInstantaneousCurrent", false), CultureInfo.InvariantCulture));


            }
            catch (Exception ex)
            {
                MessageBox.Show("ProtDev1", ex.Message);
            }

            //NameCodeCable
            if (((XMLDataSource)this.DataSource).Field("NameCodeCable0", false).ToString() == "." ||
                ((XMLDataSource)this.DataSource).Field("NameCodeCable0", false).ToString() == "-1")
                strName0 = "";
            else
                strName0 = CommonItems.GetNameCodeTxt(((XMLDataSource)this.DataSource).Field("NameCodeCable0", false).ToString());

            if (((XMLDataSource)this.DataSource).Field("NameCodeCable1", false).ToString() == "." ||
                ((XMLDataSource)this.DataSource).Field("NameCodeCable1", false).ToString() == "-1")
                strName1 = "";
            else
                strName1 = CommonItems.GetNameCodeTxt(((XMLDataSource)this.DataSource).Field("NameCodeCable1", false).ToString());

            if (((XMLDataSource)this.DataSource).Field("NameCodeCable2", false).ToString() == "." ||
                ((XMLDataSource)this.DataSource).Field("NameCodeCable2", false).ToString() == "-1")
                strName2 = "";
            else
                strName2 = CommonItems.GetNameCodeTxt(((XMLDataSource)this.DataSource).Field("NameCodeCable2", false).ToString());

            if (((XMLDataSource)this.DataSource).Field("NameCodeCable3", false).ToString() == "." ||
                ((XMLDataSource)this.DataSource).Field("NameCodeCable3", false).ToString() == "-1")
                strName3 = "";
            else
                strName3 = CommonItems.GetNameCodeTxt(((XMLDataSource)this.DataSource).Field("NameCodeCable3", false).ToString());

            //MessageCodeMaxLengthCable
            if (((XMLDataSource)this.DataSource).Field("MessageCodeMaxLengthCable0", false).ToString() == "0")
                strTxt0 = FebPrintClassLib.Properties.Resources.IDS_MsgCodeMaxLengthCable_0;
            else if (((XMLDataSource)this.DataSource).Field("MessageCodeMaxLengthCable0", false).ToString() == "1")
                strTxt0 = FebPrintClassLib.Properties.Resources.IDS_MsgCodeMaxLengthCable_1;
            else if (((XMLDataSource)this.DataSource).Field("MessageCodeMaxLengthCable0", false).ToString() == "2")
                strTxt0 = FebPrintClassLib.Properties.Resources.IDS_MsgCodeMaxLengthCable_2;
            else
                strTxt0 = "";

            if (((XMLDataSource)this.DataSource).Field("MessageCodeMaxLengthCable1", false).ToString() == "0")
                strTxt1 = FebPrintClassLib.Properties.Resources.IDS_MsgCodeMaxLengthCable_0;
            else if (((XMLDataSource)this.DataSource).Field("MessageCodeMaxLengthCable1", false).ToString() == "1")
                strTxt1 = FebPrintClassLib.Properties.Resources.IDS_MsgCodeMaxLengthCable_1;
            else if (((XMLDataSource)this.DataSource).Field("MessageCodeMaxLengthCable1", false).ToString() == "2")
                strTxt1 = FebPrintClassLib.Properties.Resources.IDS_MsgCodeMaxLengthCable_2;
            else
                strTxt1 = "";

            if (((XMLDataSource)this.DataSource).Field("MessageCodeMaxLengthCable2", false).ToString() == "0")
                strTxt2 = FebPrintClassLib.Properties.Resources.IDS_MsgCodeMaxLengthCable_0;
            else if (((XMLDataSource)this.DataSource).Field("MessageCodeMaxLengthCable2", false).ToString() == "1")
                strTxt2 = FebPrintClassLib.Properties.Resources.IDS_MsgCodeMaxLengthCable_1;
            else if (((XMLDataSource)this.DataSource).Field("MessageCodeMaxLengthCable2", false).ToString() == "2")
                strTxt2 = FebPrintClassLib.Properties.Resources.IDS_MsgCodeMaxLengthCable_2;
            else
                strTxt2 = "";

            if (((XMLDataSource)this.DataSource).Field("MessageCodeMaxLengthCable3", false).ToString() == "0")
                strTxt3 = FebPrintClassLib.Properties.Resources.IDS_MsgCodeMaxLengthCable_0;
            else if (((XMLDataSource)this.DataSource).Field("MessageCodeMaxLengthCable3", false).ToString() == "1")
                strTxt3 = FebPrintClassLib.Properties.Resources.IDS_MsgCodeMaxLengthCable_1;
            else if (((XMLDataSource)this.DataSource).Field("MessageCodeMaxLengthCable3", false).ToString() == "2")
                strTxt3 = FebPrintClassLib.Properties.Resources.IDS_MsgCodeMaxLengthCable_2;
            else
                strTxt3 = "";

            //MaxCableLengthCable1
            if (strName0.Length == 0 || strTxt0.Length == 0 ||
                ((XMLDataSource)this.DataSource).Field("MaxCableLengthCable0", false).ToString() == "-1")
            {
                txtCable0.Text = "";
                ptNext.X = txtCable0.Location.X;
                ptNext.Y = CmToInch(3.21F);

                ptNext2.X = txtCableLength0.Location.X;
                ptNext2.Y = CmToInch(3.21F);

            }
            else
            {
                txtCable0.Text = String.Format(@"{0}, {1}", strName0, strTxt0);
                ptNext.X = txtCable0.Location.X;
                ptNext.Y = txtCable0.Location.Y + txtCable0.Height;

                ptNext2.X = txtCableLength0.Location.X;
                ptNext2.Y = ptNext.Y;

            }

            txtCableLength1.Location = ptNext2;

            if (strName1.Length == 0 || strTxt1.Length == 0 ||
                ((XMLDataSource)this.DataSource).Field("MaxCableLengthCable1", false).ToString() == "-1")
            {
                txtCable1.Text = "";
            }
            else
            {
                txtCable1.Location = ptNext;
                txtCable1.Text = String.Format(@"{0}, {1}", strName1, strTxt1);
                ptNext.Y = txtCable1.Location.Y + txtCable1.Height;
                ptNext2.Y = ptNext.Y;
            }

            txtCableLength2.Location = ptNext2;

            if (strName2.Length == 0 || strTxt2.Length == 0 ||
                ((XMLDataSource)this.DataSource).Field("MaxCableLengthCable2", false).ToString() == "-1")
            {
                txtCable2.Text = "";
            }
            else
            {
                txtCable2.Location = ptNext;
                txtCable2.Text = String.Format(@"{0}, {1}", strName2, strTxt2);
                ptNext.Y = txtCable2.Location.Y + txtCable2.Height;
                ptNext2.Y = ptNext.Y;
            }

            txtCableLength3.Location = ptNext2;

            if (strName3.Length == 0 || strTxt3.Length == 0 ||
                ((XMLDataSource)this.DataSource).Field("MaxCableLengthCable3", false).ToString() == "-1")
            {
                txtCable3.Text = "";
            }
            else
            {
                txtCable3.Location = ptNext;
                txtCable3.Text = String.Format(@"{0}, {1}", strName3, strTxt3);
                ptNext.Y = txtCable3.Location.Y + txtCable3.Height;
                //MessageBox.Show(txtCable3.Text, "txtCable3.Text");
            }

            //txtCableLength
            if (((XMLDataSource)this.DataSource).Field("MaxCableLengthCable0", false).ToString() == "-2")
                txtCableLength0.Text = FebPrintClassLib.Properties.Resources.IDS_NOTPOSSIBLE_TXT;
            else if (((XMLDataSource)this.DataSource).Field("MaxCableLengthCable0", false).ToString() == "-1")
            {
                txtCableLength0.Text = "";
            }
            else
                txtCableLength0.Text = String.Format(": {0:#0.0} m",
                        Convert.ToDouble(((XMLDataSource)this.DataSource).Field("MaxCableLengthCable0", false), CultureInfo.InvariantCulture));

            if (((XMLDataSource)this.DataSource).Field("MaxCableLengthCable1", false).ToString() == "-2")
                txtCableLength1.Text = FebPrintClassLib.Properties.Resources.IDS_NOTPOSSIBLE_TXT;
            else if (((XMLDataSource)this.DataSource).Field("MaxCableLengthCable1", false).ToString() == "-1")
            {
                txtCableLength1.Text = "";
            }
            else
                txtCableLength1.Text = String.Format(": {0:#0.0} m",
                        Convert.ToDouble(((XMLDataSource)this.DataSource).Field("MaxCableLengthCable1", false), CultureInfo.InvariantCulture));

            if (((XMLDataSource)this.DataSource).Field("MaxCableLengthCable2", false).ToString() == "-2")
                txtCableLength2.Text = FebPrintClassLib.Properties.Resources.IDS_NOTPOSSIBLE_TXT;
            else if (((XMLDataSource)this.DataSource).Field("MaxCableLengthCable2", false).ToString() == "-1")
            {
                txtCableLength2.Text = "";
            }
            else
                txtCableLength2.Text = String.Format(": {0:#0.0} m",
                        Convert.ToDouble(((XMLDataSource)this.DataSource).Field("MaxCableLengthCable2", false), CultureInfo.InvariantCulture));

            if (((XMLDataSource)this.DataSource).Field("MaxCableLengthCable3", false).ToString() == "-2")
                txtCableLength3.Text = FebPrintClassLib.Properties.Resources.IDS_NOTPOSSIBLE_TXT;
            else if (((XMLDataSource)this.DataSource).Field("MaxCableLengthCable3", false).ToString() == "-1")
            {
                txtCableLength3.Text = "";
            }
            else
                txtCableLength3.Text = String.Format(": {0:#0.0} m",
                        Convert.ToDouble(((XMLDataSource)this.DataSource).Field("MaxCableLengthCable3", false), CultureInfo.InvariantCulture));

            #endregion

            ptNext.Y += CmToInch(.3F);

            #region SubItems

            #region LongTime
            //LongTime
            if (((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingFactor", false).ToString() != "-1" &&
                ((XMLDataSource)this.DataSource).Field("ProtectiveDeviceElectronic", false).ToString() == "1")
            {
				pic_LongTime.Image = Properties.Resources.Lcurve;
				pic_LongTime.SizeMode = SizeModes.Zoom;

                pic_LongTime.Location = ptNext;
				ptHead1.Y = ptNext.Y;
				ptHead2.Y = ptNext.Y;
                ptHead3.Y = ptNext.Y;
                ptRow1.Y = CmToInch(0.382f) + ptNext.Y;
                ptRow2.Y = ptRow1.Y + CmToInch(0.508f);
                ptCol1.Y = ptRow1.Y;
                ptCol2.Y = ptRow2.Y;

                labelLongTimeMin.Location = ptHead1;
                labelLongTimeMax.Location = ptHead2;
                labelLongTimeSet.Location = ptHead3;
                txtLongTimeCurrentSettingDesignation1.Location = ptRow1;
                txtLongTimeTimeSettingDesignation1.Location = ptRow2;
                textCol1LongTime.Location = ptCol1;
                textCol2LongTime.Location = ptCol2;
                txtMinLongTime1.Location = new PointF(ptHead1.X, ptRow1.Y);
                txtMinLongTime2.Location = new PointF(ptHead1.X, ptRow2.Y);
                txtMaxLongTime1.Location = new PointF(ptHead2.X, ptRow1.Y);
                txtMaxLongTime2.Location = new PointF(ptHead2.X, ptRow2.Y);
                txtSetLongTime1.Location = new PointF(ptHead3.X, ptRow1.Y);
                txtSetLongTime2.Location = new PointF(ptHead3.X, ptRow2.Y);

                labelLongTimeMin.Visible = true;
                labelLongTimeMax.Visible = true;
                labelLongTimeSet.Visible = true;
                txtLongTimeCurrentSettingDesignation1.Visible = true;
                txtLongTimeTimeSettingDesignation1.Visible = true;
                textCol1LongTime.Visible = true;
                textCol2LongTime.Visible = true;
                txtMinLongTime1.Visible = true;
                txtMinLongTime2.Visible = true;
                txtMaxLongTime1.Visible = true;
                txtMaxLongTime2.Visible = true;
                txtSetLongTime1.Visible = true;
                txtSetLongTime2.Visible = true;
                pic_LongTime.Visible = true;

                ptNext.Y = pic_LongTime.Location.Y + pic_LongTime.Height + 0.1f;

                try
                {

                    //txtLongTimeCurrentSettingDesignation1
                    if (((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingDesignation", false).ToString() == "." ||
                        ((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingDesignation", false).ToString() == "-1")
                        txtLongTimeCurrentSettingDesignation1.Text = "";

                    //txtMin1
                    //min: {1LongTimeCurrentSettingFactorMin} / {2LongTimeCurrentSettingValueMin} A
                    if (((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingFactorMin", false).ToString() == "-1" ||
                        ((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingValueMin", false).ToString() == "-1")
                        txtMinLongTime1.Text = "";
                    else
                        txtMinLongTime1.Text = String.Format("{0:#0.000} / {1:#0.0} A",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingFactorMin", false), CultureInfo.InvariantCulture),
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingValueMin", false), CultureInfo.InvariantCulture));

                    //txtMax1
                    //max: {1LongTimeCurrentSettingFactorMax} / {2LongTimeCurrentSettingValueMax} A
                    if (((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingFactorMax", false).ToString() == "-1" ||
                        ((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingValueMax", false).ToString() == "-1")
                        txtMaxLongTime1.Text = "";
                    else
                        txtMaxLongTime1.Text = String.Format("{0:#0.000} / {1:#0.0} A",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingFactorMax", false), CultureInfo.InvariantCulture),
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingValueMax", false), CultureInfo.InvariantCulture));

                    //txtSet1
                    //set: {1LongTimeCurrentSettingFactor} / {2LongTimeCurrentSettingValue} A
                    if (((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingFactor", false).ToString() == "-1" ||
                        ((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingValue", false).ToString() == "-1")
                        txtSetLongTime1.Text = "";
                    else
                        txtSetLongTime1.Text = String.Format("{0:#0.000} / {1:#0.0} A",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingFactor", false), CultureInfo.InvariantCulture),
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingValue", false), CultureInfo.InvariantCulture));

                    //txtLongTimeTimeSettingDesignation1
                    if (((XMLDataSource)this.DataSource).Field("LongTimeTimeSettingDesignation", false).ToString() == "." ||
                       ((XMLDataSource)this.DataSource).Field("LongTimeTimeSettingDesignation", false).ToString() == "-1")
                        txtLongTimeTimeSettingDesignation1.Text = "";

                    //min: {1LongTimeTimeSettingValueMin} s
                    //txtMin2
                    if (((XMLDataSource)this.DataSource).Field("LongTimeTimeSettingValueMin", false).ToString() == "." ||
                        ((XMLDataSource)this.DataSource).Field("LongTimeTimeSettingValueMin", false).ToString() == "-1")
                        txtMinLongTime2.Text = "";
                    else
                        txtMinLongTime2.Text = String.Format("{0:#0.000} s",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LongTimeTimeSettingValueMin", false), CultureInfo.InvariantCulture));

                    //txtMax2
                    //max: {1LongTimeTimeSettingValueMax} s
                    if (((XMLDataSource)this.DataSource).Field("LongTimeTimeSettingValueMax", false).ToString() == "." ||
                        ((XMLDataSource)this.DataSource).Field("LongTimeTimeSettingValueMax", false).ToString() == "-1")
                        txtMaxLongTime2.Text = "";
                    else
                        txtMaxLongTime2.Text = String.Format("{0:#0.000} s",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LongTimeTimeSettingValueMax", false), CultureInfo.InvariantCulture));

                    //txtSet2
                    //set: {1LongTimeTimeSettingValue} s
                    if (((XMLDataSource)this.DataSource).Field("LongTimeTimeSettingValue", false).ToString() == "." ||
                        ((XMLDataSource)this.DataSource).Field("LongTimeTimeSettingValue", false).ToString() == "-1")
                        txtSetLongTime2.Text = "";
                    else
                        txtSetLongTime2.Text = String.Format("{0:#0.000} s",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LongTimeTimeSettingValue", false), CultureInfo.InvariantCulture));

                }
                catch (Exception ex)
                {
                    MessageBox.Show("LongTime", ex.Message);
                }


                ptNext.Y = pic_LongTime.Location.Y + pic_LongTime.Height + 0.1f;
            }
            else
            {
                labelLongTimeMin.Visible = false;
                labelLongTimeMax.Visible = false;
                labelLongTimeSet.Visible = false;
                txtLongTimeCurrentSettingDesignation1.Visible = false;
                txtLongTimeTimeSettingDesignation1.Visible = false;
                textCol1LongTime.Visible = false;
                textCol2LongTime.Visible = false;
                txtMinLongTime1.Visible = false;
                txtMinLongTime2.Visible = false;
                txtMaxLongTime1.Visible = false;
                txtMaxLongTime2.Visible = false;
                txtSetLongTime1.Visible = false;
                txtSetLongTime2.Visible = false;
                pic_LongTime.Visible = false;
            }

            #endregion

            #region ShortTime
            //ShortTime //if {CircuitProtectiveDevice.ShortTimeCurrentSettingFactor} = "-1" then
            if (((XMLDataSource)this.DataSource).Field("ShortTimeCurrentSettingFactor", false).ToString() != "-1")
            {
				picShortTime.Image = Properties.Resources.Scurve;
				picShortTime.SizeMode = SizeModes.Zoom;
				picShortTime.Location = ptNext;
				ptHead1.Y = ptNext.Y;
                ptHead2.Y = ptNext.Y;
                ptHead3.Y = ptNext.Y;
                ptRow1.Y = CmToInch(0.382f) + ptNext.Y;
                ptRow2.Y = ptRow1.Y + CmToInch(0.508f);
                ptCol1.Y = ptRow1.Y;
                ptCol2.Y = ptRow2.Y;

                labelHeadShortTime1.Location = ptHead1;
                labelHeadShortTime2.Location = ptHead2;
                labelHeadShortTime3.Location = ptHead3;
                txtShortTimeCurrentSettingDesignation1.Location = ptRow1;
                txtShortTimeTimeSettingDesignation1.Location = ptRow2;
                textColShortTime1.Location = ptCol1;
                textColShortTime2.Location = ptCol2;
                txtMinShortTime1.Location = new PointF(ptHead1.X, ptRow1.Y);
                txtMinShortTime2.Location = new PointF(ptHead1.X, ptRow2.Y);
                txtMaxShortTime1.Location = new PointF(ptHead2.X, ptRow1.Y);
                txtMaxShortTime2.Location = new PointF(ptHead2.X, ptRow2.Y);
                txtSetShortTime1.Location = new PointF(ptHead3.X, ptRow1.Y);
                txtSetShortTime2.Location = new PointF(ptHead3.X, ptRow2.Y);

                labelHeadShortTime1.Visible = true;
                labelHeadShortTime2.Visible = true;
                labelHeadShortTime3.Visible = true;
                txtShortTimeCurrentSettingDesignation1.Visible = true;
                txtShortTimeTimeSettingDesignation1.Visible = true;
                textColShortTime1.Visible = true;
                textColShortTime2.Visible = true;
                txtMinShortTime1.Visible = true;
                txtMinShortTime2.Visible = true;
                txtMaxShortTime1.Visible = true;
                txtMaxShortTime2.Visible = true;
                txtSetShortTime1.Visible = true;
                txtSetShortTime2.Visible = true;
                picShortTime.Visible = true;


                ptNext.Y = picShortTime.Location.Y + picShortTime.Height + 0.1f;

                try
                {
                    //MessageBox.Show(((XMLDataSource)this.DataSource).Field("ShortTimeCurrentSettingDesignation", false).ToString());

                    //txtShortTimeCurrentSettingDesignation1
                    if (((XMLDataSource)this.DataSource).Field("ShortTimeCurrentSettingDesignation", false).ToString() == "." ||
                        ((XMLDataSource)this.DataSource).Field("ShortTimeCurrentSettingDesignation", false).ToString() == "-1")
                        txtShortTimeCurrentSettingDesignation1.Text = "";

                    //txtMin1
                    //min: {1ShortTimeCurrentSettingFactorMin} / {2ShortTimeCurrentSettingValueMin} A
                    if (((XMLDataSource)this.DataSource).Field("ShortTimeCurrentSettingFactorMin", false).ToString() == "-1" ||
                        ((XMLDataSource)this.DataSource).Field("ShortTimeCurrentSettingValueMin", false).ToString() == "-1")
                        txtMinShortTime1.Text = "";
                    else
                        txtMinShortTime1.Text = String.Format("{0:#0.000} / {1:#0.0} A",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("ShortTimeCurrentSettingFactorMin", false), CultureInfo.InvariantCulture),
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("ShortTimeCurrentSettingValueMin", false), CultureInfo.InvariantCulture));

                    //txtMax1
                    //max: {1ShortTimeCurrentSettingFactorMax} / {2ShortTimeCurrentSettingValueMax} A
                    if (((XMLDataSource)this.DataSource).Field("ShortTimeCurrentSettingFactorMax", false).ToString() == "-1" ||
                        ((XMLDataSource)this.DataSource).Field("ShortTimeCurrentSettingValueMax", false).ToString() == "-1")
                        txtMaxShortTime1.Text = "";
                    else
                        txtMaxShortTime1.Text = String.Format("{0:#0.000} / {1:#0.0} A",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("ShortTimeCurrentSettingFactorMax", false), CultureInfo.InvariantCulture),
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("ShortTimeCurrentSettingValueMax", false), CultureInfo.InvariantCulture));

                    //txtSet1
                    //set: {1ShortTimeCurrentSettingFactor} / {2ShortTimeCurrentSettingValue} A
                    if (((XMLDataSource)this.DataSource).Field("ShortTimeCurrentSettingFactor", false).ToString() == "-1" ||
                        ((XMLDataSource)this.DataSource).Field("ShortTimeCurrentSettingValue", false).ToString() == "-1")
                        txtSetShortTime1.Text = "";
                    else
                        txtSetShortTime1.Text = String.Format("{0:#0.000} / {1:#0.0} A",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("ShortTimeCurrentSettingFactor", false), CultureInfo.InvariantCulture),
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("ShortTimeCurrentSettingValue", false), CultureInfo.InvariantCulture));

                    //txtShortTimeTimeSettingDesignation1
                    if (((XMLDataSource)this.DataSource).Field("ShortTimeTimeSettingDesignation", false).ToString() == "." ||
                       ((XMLDataSource)this.DataSource).Field("ShortTimeTimeSettingDesignation", false).ToString() == "-1")
                        txtShortTimeTimeSettingDesignation1.Text = "";

                    //min: {1ShortTimeTimeSettingValueMin} s
                    //txtMin2
                    if (((XMLDataSource)this.DataSource).Field("ShortTimeTimeSettingValueMin", false).ToString() == "." ||
                        ((XMLDataSource)this.DataSource).Field("ShortTimeTimeSettingValueMin", false).ToString() == "-1")
                        txtMinShortTime2.Text = "";
                    else
                        txtMinShortTime2.Text = String.Format("{0:#0.00} s",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("ShortTimeTimeSettingValueMin", false), CultureInfo.InvariantCulture));

                    //txtMax2
                    //max: {1ShortTimeTimeSettingValueMax} s
                    if (((XMLDataSource)this.DataSource).Field("ShortTimeTimeSettingValueMax", false).ToString() == "." ||
                        ((XMLDataSource)this.DataSource).Field("ShortTimeTimeSettingValueMax", false).ToString() == "-1")
                        txtMaxShortTime2.Text = "";
                    else
                        txtMaxShortTime2.Text = String.Format("{0:#0.00} s",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("ShortTimeTimeSettingValueMax", false), CultureInfo.InvariantCulture));

                    //txtSet2
                    //set: {1ShortTimeTimeSettingValue} s
                    if (((XMLDataSource)this.DataSource).Field("ShortTimeTimeSettingValue", false).ToString() == "." ||
                        ((XMLDataSource)this.DataSource).Field("ShortTimeTimeSettingValue", false).ToString() == "-1")
                        txtSetShortTime2.Text = "";
                    else
                        txtSetShortTime2.Text = String.Format("{0:#0.00} s",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("ShortTimeTimeSettingValue", false), CultureInfo.InvariantCulture));

                }
                catch (Exception ex)
                {
                    MessageBox.Show("ShortTime", ex.Message);
                }


            }
            else
            {
                labelHeadShortTime1.Visible = false;
                labelHeadShortTime2.Visible = false;
                labelHeadShortTime3.Visible = false;
                txtShortTimeCurrentSettingDesignation1.Visible = false;
                txtShortTimeTimeSettingDesignation1.Visible = false;
                textColShortTime1.Visible = false;
                textColShortTime2.Visible = false;
                txtMinShortTime1.Visible = false;
                txtMinShortTime2.Visible = false;
                txtMaxShortTime1.Visible = false;
                txtMaxShortTime2.Visible = false;
                txtSetShortTime1.Visible = false;
                txtSetShortTime2.Visible = false;
                picShortTime.Visible = false;
            }
            #endregion

            #region InstCurr

            //InstCurr //if {CircuitProtectiveDevice.InstantaneousCurrentSettingFactor} <> "-1" and {CircuitProtectiveDevice.ProtectiveDeviceElectronic} = "1" then
            if (((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingFactor", false).ToString() != "-1" &&
                ((XMLDataSource)this.DataSource).Field("ProtectiveDeviceElectronic", false).ToString() == "1")
            {
				picInstCurr.Image = Properties.Resources.Icurve;
				picInstCurr.SizeMode = SizeModes.Zoom;
				picInstCurr.Location = ptNext;
				ptHead1.Y = ptNext.Y;
                ptHead2.Y = ptNext.Y;
                ptHead3.Y = ptNext.Y;
                ptRow1.Y = CmToInch(0.382f) + ptNext.Y;
                //ptRow2.Y = ptRow1.Y + CmToInch(0.508f);
                ptCol1.Y = ptRow1.Y;
                //ptCol2.Y = ptRow2.Y;

                labelHeadInstCurr1.Location = ptHead1;
                labelHeadInstCurr2.Location = ptHead2;
                labelHeadInstCurr3.Location = ptHead3;
                txtInstantaneousCurrentSettingDesignation1.Location = ptRow1;
                textColInstCurr1.Location = ptCol1;
                txtMinInstCurr1.Location = new PointF(ptHead1.X, ptRow1.Y);
                txtMaxInstCurr1.Location = new PointF(ptHead2.X, ptRow1.Y);
                txtSetInstCurr1.Location = new PointF(ptHead3.X, ptRow1.Y);

                picInstCurr.Visible = true;
                labelHeadInstCurr1.Visible = true;
                labelHeadInstCurr2.Visible = true;
                labelHeadInstCurr3.Visible = true;
                txtInstantaneousCurrentSettingDesignation1.Visible = true;
                textColInstCurr1.Visible = true;
                txtMinInstCurr1.Visible = true;
                txtMaxInstCurr1.Visible = true;
                txtSetInstCurr1.Visible = true;


                ptNext.Y = picInstCurr.Location.Y + picInstCurr.Height + 0.1f;

                try
                {

                    //{txtInstantaneousCurrentSettingDesignation1} {InstantaneousCurrentSettingDesignation}
                    if (((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingDesignation", false).ToString() == "." ||
                        ((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingDesignation", false).ToString() == "-1")
                        txtInstantaneousCurrentSettingDesignation1.Text = "";

                    //txtMin1
                    //min: {1InstantaneousCurrentSettingFactorMin} / {2InstantaneousCurrentSettingValueMin} A
                    if (((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingFactorMin", false).ToString() == "-1" ||
                        ((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingValueMin", false).ToString() == "-1")
                        txtMinInstCurr1.Text = "";
                    else
                        txtMinInstCurr1.Text = String.Format("{0:#0.000} / {1:#0.0} A",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingFactorMin", false), CultureInfo.InvariantCulture),
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingValueMin", false), CultureInfo.InvariantCulture));

                    //txtMax1
                    //max: {1InstantaneousCurrentSettingFactorMax} / {2InstantaneousCurrentSettingValueMax} A
                    if (((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingFactorMax", false).ToString() == "-1" ||
                        ((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingValueMax", false).ToString() == "-1")
                        txtMaxInstCurr1.Text = "";
                    else
                        txtMaxInstCurr1.Text = String.Format("{0:#0.000} / {1:#0.0} A",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingFactorMax", false), CultureInfo.InvariantCulture),
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingValueMax", false), CultureInfo.InvariantCulture));

                    //txtSet1
                    //set: {1InstantaneousCurrentSettingFactor} / {2InstantaneousCurrentSettingValue} A
                    if (((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingFactor", false).ToString() == "-1" ||
                        ((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingValue", false).ToString() == "-1")
                        txtSetInstCurr1.Text = "";
                    else
                        txtSetInstCurr1.Text = String.Format("{0:#0.000} / {1:#0.0} A",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingFactor", false), CultureInfo.InvariantCulture),
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingValue", false), CultureInfo.InvariantCulture));

                }
                catch (Exception ex)
                {
                    MessageBox.Show("InstantaneousCurrent", ex.Message);
                }

            }
            else
            {
                picInstCurr.Visible = false;
                labelHeadInstCurr1.Visible = false;
                labelHeadInstCurr2.Visible = false;
                labelHeadInstCurr3.Visible = false;
                txtInstantaneousCurrentSettingDesignation1.Visible = false;
                textColInstCurr1.Visible = false;
                txtMinInstCurr1.Visible = false;
                txtMaxInstCurr1.Visible = false;
                txtSetInstCurr1.Visible = false;
            }
            #endregion

            #region Gfault
            //Gfault
            if (((XMLDataSource)this.DataSource).Field("GroundFaultCurrentSettingFactor", false).ToString() != "-1")
            {
				picGfault.Image = Properties.Resources.Gcurve;
				picGfault.SizeMode = SizeModes.Zoom;
				picGfault.Location = ptNext;
				ptHead1.Y = ptNext.Y;
				ptHead2.Y = ptNext.Y;
                ptHead3.Y = ptNext.Y;
                ptRow1.Y = CmToInch(0.382f) + ptNext.Y;
                ptRow2.Y = ptRow1.Y + CmToInch(0.508f);
                ptCol1.Y = ptRow1.Y;
                ptCol2.Y = ptRow2.Y;

                labelHeadGfault1.Location = ptHead1;
                labelHeadGfault2.Location = ptHead2;
                labelHeadGfault3.Location = ptHead3;
                txtGroundFaultCurrentSettingDesignation1.Location = ptRow1;
                txtGroundFaultTimeSettingDesignation1.Location = ptRow2;
                textColGfault1.Location = ptCol1;
                textColGfault2.Location = ptCol2;
                txtMinGfault1.Location = new PointF(ptHead1.X, ptRow1.Y);
                txtMinGfault2.Location = new PointF(ptHead1.X, ptRow2.Y);
                txtMaxGfault1.Location = new PointF(ptHead2.X, ptRow1.Y);
                txtMaxGfault2.Location = new PointF(ptHead2.X, ptRow2.Y);
                txtSetGfault1.Location = new PointF(ptHead3.X, ptRow1.Y);
                txtSetGfault2.Location = new PointF(ptHead3.X, ptRow2.Y);

                labelHeadGfault1.Visible = true;
                labelHeadGfault2.Visible = true;
                labelHeadGfault3.Visible = true;
                txtGroundFaultCurrentSettingDesignation1.Visible = true;
                txtGroundFaultTimeSettingDesignation1.Visible = true;
                textColGfault1.Visible = true;
                textColGfault2.Visible = true;
                txtMinGfault1.Visible = true;
                txtMinGfault2.Visible = true;
                txtMaxGfault1.Visible = true;
                txtMaxGfault2.Visible = true;
                txtSetGfault1.Visible = true;
                txtSetGfault2.Visible = true;
                picGfault.Visible = true;


                ptNext.Y = picShortTime.Location.Y + picShortTime.Height + 0.1f;

                try
                {

                    //txtGroundFaultCurrentSettingDesignation1
                    if (((XMLDataSource)this.DataSource).Field("GroundFaultCurrentSettingDesignation", false).ToString() == "." ||
                        ((XMLDataSource)this.DataSource).Field("GroundFaultCurrentSettingDesignation", false).ToString() == "-1")
                        txtGroundFaultCurrentSettingDesignation1.Text = "";

                    //txtMin1
                    //min: {1GroundFaultCurrentSettingFactorMin} / {2GroundFaultCurrentSettingValueMin} A
                    if (((XMLDataSource)this.DataSource).Field("GroundFaultCurrentSettingFactorMin", false).ToString() == "-1" ||
                        ((XMLDataSource)this.DataSource).Field("GroundFaultCurrentSettingValueMin", false).ToString() == "-1")
                        txtMinGfault1.Text = "";
                    else
                        txtMinGfault1.Text = String.Format("{0:#0.000} / {1:#0.0} A",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("GroundFaultCurrentSettingFactorMin", false), CultureInfo.InvariantCulture),
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("GroundFaultCurrentSettingValueMin", false), CultureInfo.InvariantCulture));

                    //txtMax1
                    //max: {1GroundFaultCurrentSettingFactorMax} / {2GroundFaultCurrentSettingValueMax} A
                    if (((XMLDataSource)this.DataSource).Field("GroundFaultCurrentSettingFactorMax", false).ToString() == "-1" ||
                        ((XMLDataSource)this.DataSource).Field("GroundFaultCurrentSettingValueMax", false).ToString() == "-1")
                        txtMaxGfault1.Text = "";
                    else
                        txtMaxGfault1.Text = String.Format("{0:#0.000} / {1:#0.0} A",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("GroundFaultCurrentSettingFactorMax", false), CultureInfo.InvariantCulture),
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("GroundFaultCurrentSettingValueMax", false), CultureInfo.InvariantCulture));

                    //txtSet1
                    //set: {1GroundFaultCurrentSettingFactor} / {2GroundFaultCurrentSettingValue} A
                    if (((XMLDataSource)this.DataSource).Field("GroundFaultCurrentSettingFactor", false).ToString() == "-1" ||
                        ((XMLDataSource)this.DataSource).Field("GroundFaultCurrentSettingValue", false).ToString() == "-1")
                        txtSetGfault1.Text = "";
                    else
                        txtSetGfault1.Text = String.Format("{0:#0.000} / {1:#0.0} A",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("GroundFaultCurrentSettingFactor", false), CultureInfo.InvariantCulture),
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("GroundFaultCurrentSettingValue", false), CultureInfo.InvariantCulture));

                    //txtGroundFaultTimeSettingDesignation1
                    if (((XMLDataSource)this.DataSource).Field("GroundFaultTimeSettingDesignation", false).ToString() == "." ||
                       ((XMLDataSource)this.DataSource).Field("GroundFaultTimeSettingDesignation", false).ToString() == "-1")
                        txtGroundFaultTimeSettingDesignation1.Text = "";

                    //min: {1GroundFaultTimeSettingValueMin} s
                    //txtMin2
                    if (((XMLDataSource)this.DataSource).Field("GroundFaultTimeSettingValueMin", false).ToString() == "." ||
                        ((XMLDataSource)this.DataSource).Field("GroundFaultTimeSettingValueMin", false).ToString() == "-1")
                        txtMinGfault2.Text = "";
                    else
                        txtMinGfault2.Text = String.Format("{0:#0.00} s",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("GroundFaultTimeSettingValueMin", false), CultureInfo.InvariantCulture));

                    //txtMax2
                    //max: {1GroundFaultTimeSettingValueMax} s
                    if (((XMLDataSource)this.DataSource).Field("GroundFaultTimeSettingValueMax", false).ToString() == "." ||
                        ((XMLDataSource)this.DataSource).Field("GroundFaultTimeSettingValueMax", false).ToString() == "-1")
                        txtMaxGfault2.Text = "";
                    else
                        txtMaxGfault2.Text = String.Format("{0:#0.00} s",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("GroundFaultTimeSettingValueMax", false), CultureInfo.InvariantCulture));

                    //txtSet2
                    //set: {1GroundFaultTimeSettingValue} s
                    if (((XMLDataSource)this.DataSource).Field("GroundFaultTimeSettingValue", false).ToString() == "." ||
                        ((XMLDataSource)this.DataSource).Field("GroundFaultTimeSettingValue", false).ToString() == "-1")
                        txtSetGfault2.Text = "";
                    else
                        txtSetGfault2.Text = String.Format("{0:#0.00} s",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("GroundFaultTimeSettingValue", false), CultureInfo.InvariantCulture));

                }
                catch (Exception ex)
                {
                    MessageBox.Show("Gfault", ex.Message);
                }

            }
            else
            {
                labelHeadGfault1.Visible = false;
                labelHeadGfault2.Visible = false;
                labelHeadGfault3.Visible = false;
                txtGroundFaultCurrentSettingDesignation1.Visible = false;
                txtGroundFaultTimeSettingDesignation1.Visible = false;
                textColGfault1.Visible = false;
                textColGfault2.Visible = false;
                txtMinGfault1.Visible = false;
                txtMinGfault2.Visible = false;
                txtMaxGfault1.Visible = false;
                txtMaxGfault2.Visible = false;
                txtSetGfault1.Visible = false;
                txtSetGfault2.Visible = false;
                picGfault.Visible = false;
            }
            #endregion

            #region LongTimeTh
            //if {CircuitProtectiveDevice.LongTimeCurrentSettingFactor} <> "-1" and {CircuitProtectiveDevice.ProtectiveDeviceElectronic} = "0" then
            //LongTimeTh
            if (((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingFactor", false).ToString() != "-1" &&
                ((XMLDataSource)this.DataSource).Field("ProtectiveDeviceElectronic", false).ToString() == "0")
            {
				picLongTimeTh.Image = Properties.Resources.ThermalCurve;
				picLongTimeTh.SizeMode = SizeModes.Zoom;
				picLongTimeTh.Location = ptNext;
				ptHead1.Y = ptNext.Y;
                ptHead2.Y = ptNext.Y;
                ptHead3.Y = ptNext.Y;
                ptRow1.Y = CmToInch(0.382f) + ptNext.Y;
                ptRow2.Y = ptRow1.Y + CmToInch(0.508f);
                ptCol1.Y = ptRow1.Y;
                ptCol2.Y = ptRow2.Y;

                labelHeadLongTimeTh1.Location = ptHead1;
                labelHeadLongTimeTh2.Location = ptHead2;
                labelHeadLongTimeTh3.Location = ptHead3;
                LongTimeThCurrentSettingDesignation.Location = ptRow1;
                LongTimeThTimeSettingDesignation.Location = ptRow2;
                textColLongTimeTh1.Location = ptCol1;
                textColLongTimeTh2.Location = ptCol2;
                txtMinLongTimeTh1.Location = new PointF(ptHead1.X, ptRow1.Y);
                txtMinLongTimeTh2.Location = new PointF(ptHead1.X, ptRow2.Y);
                txtMaxLongTimeTh1.Location = new PointF(ptHead2.X, ptRow1.Y);
                txtMaxLongTimeTh2.Location = new PointF(ptHead2.X, ptRow2.Y);
                txtSetLongTimeTh1.Location = new PointF(ptHead3.X, ptRow1.Y);
                txtSetLongTimeTh2.Location = new PointF(ptHead3.X, ptRow2.Y);

                labelHeadLongTimeTh1.Visible = true;
                labelHeadLongTimeTh2.Visible = true;
                labelHeadLongTimeTh3.Visible = true;
                LongTimeThCurrentSettingDesignation.Visible = true;
                LongTimeThTimeSettingDesignation.Visible = true;
                textColLongTimeTh1.Visible = true;
                textColLongTimeTh2.Visible = true;
                txtMinLongTimeTh1.Visible = true;
                txtMinLongTimeTh2.Visible = true;
                txtMaxLongTimeTh1.Visible = true;
                txtMaxLongTimeTh2.Visible = true;
                txtSetLongTimeTh1.Visible = true;
                txtSetLongTimeTh2.Visible = true;
                picLongTimeTh.Visible = true;


                ptNext.Y = picShortTime.Location.Y + picShortTime.Height + 0.1f;

                try
                {
                    //txtLongTimeCurrentSettingDesignation1
                    if (((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingDesignation", false).ToString() == "." ||
                        ((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingDesignation", false).ToString() == "-1")
                        LongTimeThCurrentSettingDesignation.Text = "";

                    //txtMin1 min: {1LongTimeCurrentSettingFactorMin} / {2LongTimeCurrentSettingValueMin} A
                    //min: {1LongTimeCurrentSettingFactorMin} / {2LongTimeCurrentSettingValueMin} A
                    if (((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingFactorMin", false).ToString() == "-1" ||
                        ((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingValueMin", false).ToString() == "-1")
                        txtMinLongTimeTh1.Text = "";
                    else
                        txtMinLongTimeTh1.Text = String.Format("{0:#0.000} / {1:#0.0} A",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingFactorMin", false), CultureInfo.InvariantCulture),
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingValueMin", false), CultureInfo.InvariantCulture));

                    //txtMax1
                    //max: {1LongTimeCurrentSettingFactorMax} / {2LongTimeCurrentSettingValueMax} A
                    if (((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingFactorMax", false).ToString() == "-1" ||
                        ((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingValueMax", false).ToString() == "-1")
                        txtMaxLongTimeTh1.Text = "";
                    else
                        txtMaxLongTimeTh1.Text = String.Format("{0:#0.000} / {1:#0.0} A",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingFactorMax", false), CultureInfo.InvariantCulture),
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingValueMax", false), CultureInfo.InvariantCulture));

                    //txtSet1
                    //set: {1LongTimeCurrentSettingFactor} / {2LongTimeCurrentSettingValue} A
                    if (((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingFactor", false).ToString() == "-1" ||
                        ((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingValue", false).ToString() == "-1")
                        txtSetLongTimeTh1.Text = "";
                    else
                        txtSetLongTimeTh1.Text = String.Format("{0:#0.000} / {1:#0.0} A",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingFactor", false), CultureInfo.InvariantCulture),
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LongTimeCurrentSettingValue", false), CultureInfo.InvariantCulture));

                    //txtLongTimeTimeSettingDesignation1
                    if (((XMLDataSource)this.DataSource).Field("LongTimeTimeSettingDesignation", false).ToString() == "." ||
                       ((XMLDataSource)this.DataSource).Field("LongTimeTimeSettingDesignation", false).ToString() == "-1")
                        LongTimeThTimeSettingDesignation.Text = "";

                    //min: {1LongTimeTimeSettingValueMin} s
                    //txtMin2
                    if (((XMLDataSource)this.DataSource).Field("LongTimeTimeSettingValueMin", false).ToString() == "." ||
                        ((XMLDataSource)this.DataSource).Field("LongTimeTimeSettingValueMin", false).ToString() == "-1")
                        txtMinLongTimeTh2.Text = "";
                    else
                        txtMinLongTimeTh2.Text = String.Format("{0:#0.00} s",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LongTimeTimeSettingValueMin", false), CultureInfo.InvariantCulture));

                    //txtMax2
                    //max: {1LongTimeTimeSettingValueMax} s
                    if (((XMLDataSource)this.DataSource).Field("LongTimeTimeSettingValueMax", false).ToString() == "." ||
                        ((XMLDataSource)this.DataSource).Field("LongTimeTimeSettingValueMax", false).ToString() == "-1")
                        txtMaxLongTimeTh2.Text = "";
                    else
                        txtMaxLongTimeTh2.Text = String.Format("{0:#0.00} s",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LongTimeTimeSettingValueMax", false), CultureInfo.InvariantCulture));

                    //txtSet2
                    //set: {1LongTimeTimeSettingValue} s
                    if (((XMLDataSource)this.DataSource).Field("LongTimeTimeSettingValue", false).ToString() == "." ||
                        ((XMLDataSource)this.DataSource).Field("LongTimeTimeSettingValue", false).ToString() == "-1")
                        txtSetLongTimeTh2.Text = "";
                    else
                        txtSetLongTimeTh2.Text = String.Format("{0:#0.00} s",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("LongTimeTimeSettingValue", false), CultureInfo.InvariantCulture));

                }
                catch (Exception ex)
                {
                    MessageBox.Show("LongTime TH", ex.Message);
                }

            }
            else
            {

                labelHeadLongTimeTh1.Visible = false;
                labelHeadLongTimeTh2.Visible = false;
                labelHeadLongTimeTh3.Visible = false;
                LongTimeThCurrentSettingDesignation.Visible = false;
                LongTimeThTimeSettingDesignation.Visible = false;
                textColLongTimeTh1.Visible = false;
                textColLongTimeTh2.Visible = false;
                txtMinLongTimeTh1.Visible = false;
                txtMinLongTimeTh2.Visible = false;
                txtMaxLongTimeTh1.Visible = false;
                txtMaxLongTimeTh2.Visible = false;
                txtSetLongTimeTh1.Visible = false;
                txtSetLongTimeTh2.Visible = false;
                picLongTimeTh.Visible = false;
            }
            #endregion

            #region InstCurrEm
            //InstCurrEm 
            if (((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingFactor", false).ToString() != "-1" &&
                ((XMLDataSource)this.DataSource).Field("ProtectiveDeviceElectronic", false).ToString() == "0")
            {
				picInstCurrEm.Image = Properties.Resources.ElectroMagneticCurve;
				picInstCurrEm.SizeMode = SizeModes.Zoom;
				picInstCurrEm.Location = ptNext;
				ptHead1.Y = ptNext.Y;
                ptHead2.Y = ptNext.Y;
                ptHead3.Y = ptNext.Y;
                ptRow1.Y = CmToInch(0.382f) + ptNext.Y;
                ptRow2.Y = ptRow1.Y + CmToInch(0.508f);
                ptCol1.Y = ptRow1.Y;
                ptCol2.Y = ptRow2.Y;

                labelHeadInstCurrEm1.Location = ptHead1;
                labelHeadInstCurrEm2.Location = ptHead2;
                labelHeadInstCurrEm3.Location = ptHead3;
                txtInstantaneousEmCurrentSettingDesignation1.Location = ptRow1;
                textColInstCurrEm1.Location = ptCol1;
                txtMinInstCurrEm1.Location = new PointF(ptHead1.X, ptRow1.Y);
                txtMaxInstCurrEm1.Location = new PointF(ptHead2.X, ptRow1.Y);
                txtSetInstCurrEm1.Location = new PointF(ptHead3.X, ptRow1.Y);

                labelHeadInstCurrEm1.Visible = true;
                labelHeadInstCurrEm2.Visible = true;
                labelHeadInstCurrEm3.Visible = true;
                txtInstantaneousEmCurrentSettingDesignation1.Visible = true;
                textColInstCurrEm1.Visible = true;
                txtMinInstCurrEm1.Visible = true;
                txtMaxInstCurrEm1.Visible = true;
                txtSetInstCurrEm1.Visible = true;
                picInstCurrEm.Visible = true;

                ptNext.Y = picShortTime.Location.Y + picShortTime.Height + 0.1f;

                try
                {

                    //{txtInstantaneousCurrentSettingDesignation1} {InstantaneousCurrentSettingDesignation}
                    if (((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingDesignation", false).ToString() == "." ||
                        ((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingDesignation", false).ToString() == "-1")
                        txtInstantaneousEmCurrentSettingDesignation1.Text = "";

                    //txtMin1
                    //min: {1InstantaneousCurrentSettingFactorMin} / {2InstantaneousCurrentSettingValueMin} A
                    if (((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingFactorMin", false).ToString() == "-1" ||
                        ((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingValueMin", false).ToString() == "-1")
                        txtMinInstCurrEm1.Text = "";
                    else
                        txtMinInstCurrEm1.Text = String.Format("{0:#0.000} / {1:#0.0} A",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingFactorMin", false), CultureInfo.InvariantCulture),
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingValueMin", false), CultureInfo.InvariantCulture));

                    //txtMax1
                    //max: {1InstantaneousCurrentSettingFactorMax} / {2InstantaneousCurrentSettingValueMax} A
                    if (((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingFactorMax", false).ToString() == "-1" ||
                        ((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingValueMax", false).ToString() == "-1")
                        txtMaxInstCurrEm1.Text = "";
                    else
                        txtMaxInstCurrEm1.Text = String.Format("{0:#0.000} / {1:#0.0} A",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingFactorMax", false), CultureInfo.InvariantCulture),
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingValueMax", false), CultureInfo.InvariantCulture));

                    //txtSet1
                    //set: {1InstantaneousCurrentSettingFactor} / {2InstantaneousCurrentSettingValue} A
                    if (((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingFactor", false).ToString() == "-1" ||
                        ((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingValue", false).ToString() == "-1")
                        txtSetInstCurrEm1.Text = "";
                    else
                        txtSetInstCurrEm1.Text = String.Format("{0:#0.000} / {1:#0.0} A",
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingFactor", false), CultureInfo.InvariantCulture),
                            Convert.ToDouble(((XMLDataSource)this.DataSource).Field("InstantaneousCurrentSettingValue", false), CultureInfo.InvariantCulture));

                }
                catch (Exception ex)
                {
                    MessageBox.Show("InstantaneousCurrent Em", ex.Message);
                }

            }
            else
            {
                labelHeadInstCurrEm1.Visible = false;
                labelHeadInstCurrEm2.Visible = false;
                labelHeadInstCurrEm3.Visible = false;
                txtInstantaneousEmCurrentSettingDesignation1.Visible = false;
                textColInstCurrEm1.Visible = false;
                txtMinInstCurrEm1.Visible = false;
                txtMaxInstCurrEm1.Visible = false;
                txtSetInstCurrEm1.Visible = false;
                picInstCurrEm.Visible = false;

            }
            #endregion

            #endregion

            shape1.Height = ptNext.Y + CmToInch(0.3f);

        }

        private void groupHeader1_Format(object sender, EventArgs e)
		{

		}

		private void Rpt06_ProtDev1_ReportStart(object sender, EventArgs e)
		{
            //rptLongTime = new Rpt06_ProtDev_LongTime();
            //rptShortTime = new Rpt06_ProtDev_ShortTime();
            //rptInstCurr = new Rpt06_ProtDev_InstCurr();
            //rptGfault = new Rpt06_ProtDev_Gfault();
            //rptLongTimeTh = new Rpt06_ProtDev_LongTimeTH();
            //rptInstCurrEm = new Rpt06_ProtDev_InstCurrEm();

        }

        private void Rpt06_ProtDev1_ReportEnd(object sender, EventArgs e)
		{
		}

        private void groupFooter1_Format(object sender, EventArgs e)
        {
            shape1.Height = 0F;
        }

        private void Rpt06_ProtDev1_FetchData(object sender, FetchEventArgs eArgs)
        {
  
        }

        private void Rpt06_ProtDev1_PageStart(object sender, EventArgs e)
        {
            
        }
    }
}
