﻿using System;
using System.Globalization;
using System.Windows.Forms;
using GrapeCity.ActiveReports.Data;


namespace FebPrintClassLib.Rpt6
{
    /// <summary>
    /// Summary description for Rpt06_VoltDrop.
    /// </summary>
	public partial class Rpt06_VoltDrop : GrapeCity.ActiveReports.SectionReport
	{

		public Rpt06_VoltDrop()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

            Document.CacheToDisk = true;
            Document.CacheToDiskLocation = System.IO.Path.GetTempPath();

        }

        private void groupHeader1_Format(object sender, EventArgs e)
		{
			try
			{
                //txtVoltageDropTotallyValue, VoltageDropExceedingWarningLevel
                if (((XMLDataSource)this.DataSource).Field("../VoltageDropTotalExceedingWarningLevel", false).ToString() == "1")
                {
                    txtVoltageDropTotallyValue.ForeColor = System.Drawing.Color.Blue;
                    txtVoltageDropTotallyPercentage.ForeColor = System.Drawing.Color.Blue;
                }
                else
                {
                    txtVoltageDropTotallyValue.ForeColor = System.Drawing.Color.Black;
                    txtVoltageDropTotallyPercentage.ForeColor = System.Drawing.Color.Black;
                }

                if (((XMLDataSource)this.DataSource).Field("../VoltageDropTotallyValue", false).ToString() == "." ||
					((XMLDataSource)this.DataSource).Field("../VoltageDropTotallyValue", false).ToString() == "-1")
					txtVoltageDropTotallyValue.Text = "";
				else
					txtVoltageDropTotallyValue.Text = String.Format("{0:#0.0} V",
						Convert.ToDouble(((XMLDataSource)this.DataSource).Field("../VoltageDropTotallyValue", false), CultureInfo.InvariantCulture));

                //VoltageDropDistributionBoardExceedingWarningLevel
                if (((XMLDataSource)this.DataSource).Field("../VoltageDropDistributionBoardExceedingWarningLevel", false).ToString() == "1")
                {
                    txtVoltageDropDistributionBoardValue.ForeColor = System.Drawing.Color.Blue;
                    txtVoltageDropDistributionBoardPercentage.ForeColor = System.Drawing.Color.Blue;
                }
                else
                {
                    txtVoltageDropDistributionBoardValue.ForeColor = System.Drawing.Color.Black;
                    txtVoltageDropDistributionBoardPercentage.ForeColor = System.Drawing.Color.Black;
                }

                //txtTerminalVoltage
                if (((XMLDataSource)this.DataSource).Field("../TerminalVoltage", false).ToString() == "." ||
                    ((XMLDataSource)this.DataSource).Field("../TerminalVoltage", false).ToString() == "-1")
                    txtTerminalVoltage.Text = "";
                else
                    txtTerminalVoltage.Text = String.Format("{0:#0.0} V",
                        Convert.ToDouble(((XMLDataSource)this.DataSource).Field("../TerminalVoltage", false), CultureInfo.InvariantCulture));

                //txtVoltageDropDistributionBoardValue
                if (((XMLDataSource)this.DataSource).Field("../VoltageDropDistributionBoardValue", false).ToString() == "." ||
					((XMLDataSource)this.DataSource).Field("../VoltageDropDistributionBoardValue", false).ToString() == "-1")
					txtVoltageDropDistributionBoardValue.Text = "";
				else
					txtVoltageDropDistributionBoardValue.Text = String.Format("{0:#0.0} V",
						Convert.ToDouble(((XMLDataSource)this.DataSource).Field("../VoltageDropDistributionBoardValue", false), CultureInfo.InvariantCulture));

				//txtVoltageDropDistributionBoardPercentage
				if (((XMLDataSource)this.DataSource).Field("../VoltageDropDistributionBoardPercentage", false).ToString() == "." ||
					((XMLDataSource)this.DataSource).Field("../VoltageDropDistributionBoardPercentage", false).ToString() == "-1")
					txtVoltageDropDistributionBoardPercentage.Text = "";
				else
					txtVoltageDropDistributionBoardPercentage.Text = String.Format("{0:#0.00} %",
						Convert.ToDouble(((XMLDataSource)this.DataSource).Field("../VoltageDropDistributionBoardPercentage", false), CultureInfo.InvariantCulture));

				//txtVoltageDropTotallyPercentage
				if (((XMLDataSource)this.DataSource).Field("../VoltageDropTotallyPercentage", false).ToString() == "." ||
					((XMLDataSource)this.DataSource).Field("../VoltageDropTotallyPercentage", false).ToString() == "-1")
					txtVoltageDropTotallyPercentage.Text = "";
				else
					txtVoltageDropTotallyPercentage.Text = String.Format("{0:#0.00} %",
						Convert.ToDouble(((XMLDataSource)this.DataSource).Field("../VoltageDropTotallyPercentage", false), CultureInfo.InvariantCulture));
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message, "Rpt06 Gr header");
			}
		}

		private void detail_Format(object sender, EventArgs e)
		{
			//NameCode txtSyn
			string strNameType = "";
			//CommonItems clItems = new CommonItems();

			//Get the NameCode text
			strNameType = CommonItems.GetNameCodeTxt(((XMLDataSource)this.DataSource).Field("NameCode", false).ToString());

            if (System.Threading.Thread.CurrentThread.CurrentUICulture.Name == "fi-FI")
            //if (FebObjects.FebDokInstance.UserInterfaceLanguage == FebUtil.Entities.CountryEnum.fi)
            {
                txtSyn.Text = String.Format("...{0} yli", strNameType);
            }
            else
            {
                txtSyn.Text = String.Format("{0} {1}", FebPrintClassLib.Properties.Resources.IDS_OVERSISTE_TXT, strNameType);
            }

			try
			{
				//txtVoltagedDropValue
				if (((XMLDataSource)this.DataSource).Field("VoltagedDropValue", false).ToString() == "." ||
					((XMLDataSource)this.DataSource).Field("VoltagedDropValue", false).ToString() == "-1")
					txtVoltagedDropValue.Text = "";
				else
					txtVoltagedDropValue.Text = String.Format("{0:#0.0} V",
						Convert.ToDouble(((XMLDataSource)this.DataSource).Field("VoltagedDropValue", false), CultureInfo.InvariantCulture));

				//txtVoltageDropPercentage
				if (((XMLDataSource)this.DataSource).Field("VoltageDropPercentage", false).ToString() == "." ||
					((XMLDataSource)this.DataSource).Field("VoltageDropPercentage", false).ToString() == "-1")
					txtVoltageDropPercentage.Text = "";
				else
					txtVoltageDropPercentage.Text = String.Format("{0:#0.00} %",
						Convert.ToDouble(((XMLDataSource)this.DataSource).Field("VoltageDropPercentage", false), CultureInfo.InvariantCulture));

                //txtMaxCableLength
                if (((XMLDataSource)this.DataSource).Field("MaxCableLength", false).ToString() == "." ||
                    ((XMLDataSource)this.DataSource).Field("MaxCableLength", false).ToString() == "-1" ||
                    Convert.ToDouble(((XMLDataSource)this.DataSource).Field("MaxCableLength", false), CultureInfo.InvariantCulture) < 0)
                {
                    txtMaxCableLength.Text = "";
                    txtLength.Visible = false;
                    txtCol2.Visible = false;
                }
                else
                {
                    txtMaxCableLength.Text = String.Format("{0:#0.0} m",
                        Convert.ToDouble(((XMLDataSource)this.DataSource).Field("MaxCableLength", false), CultureInfo.InvariantCulture));
                    txtLength.Visible = true;
                    txtCol2.Visible = true;
                }
            }
			catch (Exception ex)
			{
				//throw ex;
				MessageBox.Show(ex.Message, "VoltDrop: Error convert from XML");
			}

		}
	}
}
